# 1 "sp2.hpf"
      program beps1k
      parameter (indx=7, npx=5120, npxb=512)
      parameter (tend=5.0e0, dt=2.0000000298e-1)
      parameter (vtx=1.0e0, vdx=5.0e0, vtdx=5.0e-1)
      parameter (avdx=5.0e0)
      parameter (indnvp=2, idps=2, idimp=2)
      parameter (np=5632)
      parameter (nx=128, nxh=64)
      parameter (nvp=4, nblok=4)
      parameter (nxpmx=35)
      parameter (kxp=16, kblok=4)
      parameter (ntmax=46)
      parameter (npd=128)
      parameter (nloop=5.0e0 / 2.0000000298e-1 + 9.9999997474e-5)
      parameter (npmax=1408 * 1.0099999905e0 + 250)
      parameter (nbmax=((5120 * 1.0e0 + 512 * 5.0e-1) * 2 + 512 * 
     +1.3999999762e0 * 5.0e0) * 2.0000000298e-1 / 128 + 1)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno, /pghpf_0l/pghpf_0l
      integer pghpf_0(4), pghpf_lineno, pghpf_0l(8)
      character*1 pghpf_0c
      common /pghpf_large_0/ pghpf_large_0a
      integer pghpf_large_0a(1:4)
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer isum_0(:), npr, ibflg, npss, ierr, hpf_np$, z_e_109, 
     +z_b_14, z_b_15, z_b_16, z_b_17, z_b_18, z_b_19, z_b_20, z_b_21, 
     +z__io, edges$inherit, edges$inherit1(1:1,1:1), i$i, i$i1, i$i2, 
     +i$i3, i$i4, i$i5, i$i6, proc$d(1), mixup$f77(:,:), mixup$f77$d(1)
     +, mixup$f77$d1(1), sct$f77$d(1), sct$f77$d1(1), nxp$s, nxp$s1, 
     +i$$l, i$$u, i$$l1, i$$u1, i$$l2, i$$u2, i$$l3, i$$u3, i$$l4, i$$u4
     +, i$$l5, i$$u5, i$$l6, i$$u6, isum_0$tl$d(1), isum_0$d(1), scr$d(1
     +), ihole$d(1), rbufr$d(1), mixup$d(1), fx$d(1), maskp$d(1), part$d
     +(1), isum_0$d1(1), sum_0$d(1), scr$d1(1), jss$d(1), ihole$d1(1), 
     +rbufr$d1(1), nps$d(1), mixup$d1(1), fx$d1(1), maskp$d1(1), part$d1
     +(1), shifted$d(1), scc$d(1), sct$d(1), l$$b, u$$b, l$$b1, u$$b1, 
     +l$$b2, u$$b2, l$$b3, u$$b3, l$$b4, u$$b4, l$$b5, u$$b5, l$$b6, 
     +u$$b6, l$$b7, u$$b7, l$$b8, u$$b8, l$$b9, u$$b9, l$$b10, u$$b10, 
     +l$$b11, u$$b11, l$$b12, u$$b12, l$$b13, u$$b13, l$$b14, u$$b14, 
     +l$$b15, u$$b15
      real sum_0(:), awe(25), awke(25), awt(25)
      double precision start_time, finish_time, tbegin, timeend
      complex ffc(:,:), fc(:,:), qc(:,:), sct(:,:), scc(:,:), f, shifted
     +(:), sct$f77(:,:)
      dimension part(:,:,:), maskp(:,:), q(:,:), fx(:,:), mixup(:,:), 
     +edges(:,:), nxp(:), noff(:), npp(:), nps(:), sbufl(:,:,:), sbufr(:
     +,:,:), rbufl(:,:,:), rbufr(:,:,:), ihole(:,:), jsl(:,:), jsr(:,:)
     +, jss(:,:), scr(:,:)
      allocatable part, mixup$f77, sct$f77
      pointer (part$p,part), (proc$dp,proc$d), (mixup$f77$p,mixup$f77), 
     +(sct$f77$p,sct$f77), (mixup$f77$dp,mixup$f77$d), (mixup$f77$dp1,
     +mixup$f77$d1), (sct$f77$dp,sct$f77$d), (sct$f77$dp1,sct$f77$d1), (
     +isum_0$tl$dp,isum_0$tl$d), (isum_0$dp,isum_0$d), (scr$dp,scr$d), (
     +ihole$dp,ihole$d), (rbufr$dp,rbufr$d), (mixup$dp,mixup$d), (fx$dp,
     +fx$d), (maskp$dp,maskp$d), (part$dp,part$d), (isum_0$dp1,isum_0$d1
     +), (sum_0$dp,sum_0$d), (scr$dp1,scr$d1), (jss$dp,jss$d), (
     +ihole$dp1,ihole$d1), (rbufr$dp1,rbufr$d1), (nps$dp,nps$d), (
     +mixup$dp1,mixup$d1), (fx$dp1,fx$d1), (maskp$dp1,maskp$d1), (
     +part$dp1,part$d1), (shifted$dp,shifted$d), (scc$dp,scc$d), (sct$dp
     +,sct$d)
      integer pgf90io_ldw_init, pgf90io_ldw, pgf90io_ldw_end, 
     +pgf90io_fmtw_init, pgf90io_fmt_write, pgf90io_fmtw_end, 
     +pghpf_nprocs, pghpf_extent, pghpf_newproc
      external pdost1, bitrv1, dist_particle, dcomp1, ppois1, pistr1, 
     +cppfp1, ifft, dfft, ppush1, pmove1
      integer z__fmt993(20),z__fmt991(11)
      data qme,ax /-1.0e0,8.6666667461e-1/
      data z__fmt991/-5,5,' t =','    ',-21,0,7,0,1,-1,0/
      data z__fmt993/-5,34,' fie','ld, ','kine','tic,',' tot','al e','ne
     +rg','ies ','=   ',0,3,-24,0,14,0,7,-1,0/
      data pghpf_0l /860616049,-457488258,918629832,134375930,1,
     +1261038733,0,492551447/
      call pghpf_init(0)
      pghpf_local_mode = 0
# 0 "sp2.hpf"
      hpf_np$ = pghpf_nprocs()
# 0 "sp2.hpf"
      z_e_109 = hpf_np$
# 0 "sp2.hpf"
      proc$dp = pghpf_newproc(1,hpf_np$)
# 0 "sp2.hpf"
      call pghpf_template(part$dp,3,1280,proc$d,3,0,1,2,1,1672,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(part$dp1,part$d,27,4,3,4,4)
# 0 "sp2.hpf"
      call pghpf_common('pghpf_large_0',pghpf_large_0a,1,part$d1)
# 0 "sp2.hpf"
      part$p = pghpf_large_0a(3)
# 0 "sp2.hpf"
      call pghpf_allobnds(part$d1,l$$b,u$$b,l$$b1,u$$b1,l$$b2,u$$b2)
# 0 "sp2.hpf"
      redimension part(l$$b:u$$b,l$$b1:u$$b1,l$$b2:u$$b2)
# 0 "sp2.hpf"
      call pghpf_template(mixup$dp,2,1280,proc$d,1,0,1,16,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(sct$dp,mixup$d,9,8,1,4,4)
# 0 "sp2.hpf"
      call pghpf_template(scr$dp,2,1280,proc$d,1,0,1,2,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(scc$dp,scr$d,9,8,1,4,4)
# 0 "sp2.hpf"
      call pghpf_template(isum_0$dp,1,1280,proc$d,0,0,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(shifted$dp,isum_0$d,9,8,0,4,4)
# 0 "sp2.hpf"
      call pghpf_template(maskp$dp,2,1280,proc$d,1,0,1,1672,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(maskp$dp1,maskp$d,25,4,1,0,0)
# 0 "sp2.hpf"
      call pghpf_template(fx$dp,2,1280,proc$d,1,0,1,35,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(fx$dp1,fx$d,27,4,1,4,4)
# 0 "sp2.hpf"
      call pghpf_instance(mixup$dp1,mixup$d,25,4,1,4,4)
# 0 "sp2.hpf"
      call pghpf_instance(scr$dp1,scr$d,27,4,1,4,4)
# 0 "sp2.hpf"
      call pghpf_instance(nps$dp,isum_0$d,25,4,0,4,4)
# 0 "sp2.hpf"
      call pghpf_template(rbufr$dp,3,1280,proc$d,3,0,1,2,1,23,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(rbufr$dp1,rbufr$d,27,4,3,0,0)
# 0 "sp2.hpf"
      call pghpf_template(ihole$dp,2,1280,proc$d,1,0,1,46,1,4)
# 0 "sp2.hpf"
      call pghpf_instance(ihole$dp1,ihole$d,25,4,1,0,0)
# 0 "sp2.hpf"
      call pghpf_instance(jss$dp,scr$d,25,4,1,0,0)
# 0 "sp2.hpf"
      call pghpf_instance(sum_0$dp,isum_0$d,27,4,0,4,4)
# 0 "sp2.hpf"
      call pghpf_instance(isum_0$dp1,isum_0$d,25,4,0,0,0)
# 0 "sp2.hpf"
      call pghpf_allobnds(sct$d,l$$b3,u$$b3,l$$b4,u$$b4)
# 0 "sp2.hpf"
      allocate(ffc(l$$b3:u$$b3,l$$b4:u$$b4))
# 0 "sp2.hpf"
      allocate(fc(l$$b3:u$$b3,l$$b4:u$$b4))
# 0 "sp2.hpf"
      allocate(qc(l$$b3:u$$b3,l$$b4:u$$b4))
# 0 "sp2.hpf"
      allocate(sct(l$$b3:u$$b3,l$$b4:u$$b4))
# 0 "sp2.hpf"
      call pghpf_allobnds(scc$d,l$$b5,u$$b5,l$$b6,u$$b6)
# 0 "sp2.hpf"
      allocate(scc(l$$b5:u$$b5,l$$b6:u$$b6))
# 0 "sp2.hpf"
      call pghpf_allobnds(shifted$d,l$$b7,u$$b7)
# 0 "sp2.hpf"
      allocate(shifted(l$$b7:u$$b7))
# 0 "sp2.hpf"
      call pghpf_allobnds(fx$d1,l$$b8,u$$b8,l$$b9,u$$b9)
# 0 "sp2.hpf"
      allocate(q(l$$b8:u$$b8,l$$b9:u$$b9))
# 0 "sp2.hpf"
      allocate(fx(l$$b8:u$$b8,l$$b9:u$$b9))
# 0 "sp2.hpf"
      call pghpf_allobnds(mixup$d1,l$$b10,u$$b10,l$$b11,u$$b11)
# 0 "sp2.hpf"
      allocate(mixup(l$$b10:u$$b10,l$$b11:u$$b11))
# 0 "sp2.hpf"
      call pghpf_allobnds(scr$d1,l$$b12,u$$b12,l$$b13,u$$b13)
# 0 "sp2.hpf"
      allocate(edges(l$$b12:u$$b12,l$$b13:u$$b13))
# 0 "sp2.hpf"
      call pghpf_allobnds(nps$d,l$$b14,u$$b14)
# 0 "sp2.hpf"
      allocate(nxp(l$$b14:u$$b14))
# 0 "sp2.hpf"
      allocate(noff(l$$b14:u$$b14))
# 0 "sp2.hpf"
      allocate(npp(l$$b14:u$$b14))
# 0 "sp2.hpf"
      allocate(nps(l$$b14:u$$b14))
# 0 "sp2.hpf"
      allocate(scr(l$$b12:u$$b12,l$$b13:u$$b13))
# 0 "sp2.hpf"
      call pghpf_allobnds(sum_0$d,l$$b15,u$$b15)
# 0 "sp2.hpf"
      allocate(sum_0(l$$b15:u$$b15))
# 214 "sp2.hpf"
      kstrt = 1
# 217 "sp2.hpf"
      itime = 0
      anx = 1.28e2
      qtme = qme * 2.0000000298e-1
      affp = anx / 5.632e3
      zero = 0.0e0
# 227 "sp2.hpf"
      call pgf90io_src_info(227,'sp2.hpf')
# 227 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 227 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'beg')
# 227 "sp2.hpf"
      z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 227 "sp2.hpf"
      z__io = pgf90io_ldw_end()
      call dcomp1(edges,nxp,noff,128,4,2,4,scr$d1,nps$d,nps$d,25,25,25,
     +25)
# 229 "sp2.hpf"
      call pgf90io_src_info(229,'sp2.hpf')
# 229 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 229 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after decomp')
# 229 "sp2.hpf"
      z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 229 "sp2.hpf"
      z__io = pgf90io_ldw_end()
      call pghpf_localize_bounds(nps$d,1,1,4,1,i$$l,i$$u)
# 230 "sp2.hpf"
!     forall (i$i=i$$l:i$$u:1) npp(i$i) = 0
# 230 "sp2.hpf"
      do i$i = i$$l, i$$u
# 230 "sp2.hpf"
         npp(i$i) = 0
# 230 "sp2.hpf"
      enddo
      call pghpf_localize_bounds(nps$d,1,1,4,1,i$$l1,i$$u1)
# 231 "sp2.hpf"
!     forall (i$i=i$$l1:i$$u1:1) nps(i$i) = 1
# 231 "sp2.hpf"
      do i$i = i$$l1, i$$u1
# 231 "sp2.hpf"
         nps(i$i) = 1
# 231 "sp2.hpf"
      enddo
      call pghpf_localize_bounds(fx$d1,2,1,4,1,i$$l2,i$$u2)
# 232 "sp2.hpf"
!     forall (i$i=i$$l2:i$$u2:1, i$i1=1:35:1) q(i$i1,i$i) = 0
# 232 "sp2.hpf"
      do i$i = i$$l2, i$$u2
# 232 "sp2.hpf"
         do i$i1 = 1, 35
# 232 "sp2.hpf"
            q(i$i1,i$i) = 0
# 232 "sp2.hpf"
         enddo
# 232 "sp2.hpf"
      enddo
# 235 "sp2.hpf"
      isign = 0
# 235 "sp2.hpf"
      z_b_18 = 1
# 235 "sp2.hpf"
      z_b_19 = pghpf_extent(mixup$d1,1)
# 235 "sp2.hpf"
      z_b_20 = 1
# 235 "sp2.hpf"
      z_b_21 = pghpf_extent(mixup$d1,2)
# 235 "sp2.hpf"
      z_b_14 = 1
# 235 "sp2.hpf"
      z_b_15 = pghpf_extent(sct$d,1)
# 235 "sp2.hpf"
      z_b_16 = 1
# 235 "sp2.hpf"
      z_b_17 = pghpf_extent(sct$d,2)
# 235 "sp2.hpf"
      call pghpf_qopy_in(mixup$f77$p,pghpf_0(3),pghpf_0(3),mixup$f77$dp1
     +,mixup,mixup$d1,2,25,4,2212,1,0,z_b_18,z_b_20)
# 235 "sp2.hpf"
      call pghpf_qopy_in(sct$f77$p,pghpf_0(3),pghpf_0(3),sct$f77$dp1,sct
     +,sct$d,2,9,8,2212,1,0,z_b_14,z_b_16)
# 235 "sp2.hpf"
# 236 "sp2.hpf"
      call bitrv1(mixup$f77,isign,6,16,4,sct$f77)
# 236 "sp2.hpf"
      call pghpf_copy_out(sct,sct$f77,sct$d,sct$f77$d1,2)
# 236 "sp2.hpf"
      call pghpf_copy_out(mixup,mixup$f77,mixup$d1,mixup$f77$d1,2)
# 238 "sp2.hpf"
      call pgf90io_src_info(238,'sp2.hpf')
# 238 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 238 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after bitrv')
# 238 "sp2.hpf"
      z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 238 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 242 "sp2.hpf"
      call ppois1(qc,fc,isign,ffc,ax,affp,we,128,16,4,4,sum_0,sct$d,
     +sct$d,25,sct$d,27,27,27,25,25,25,25,sum_0$d)
      call pgf90io_src_info(244,'sp2.hpf')
# 244 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 244 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after ppois')
# 244 "sp2.hpf"
      z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 244 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 251 "sp2.hpf"
      if (5120 .gt. 0) then
# 251 "sp2.hpf"
         call pistr1(part,edges,npp,nps,1.0e0,zero,5120,128,2,1672,4,2,
     +sum_0,part$d1,scr$d1,nps$d,nps$d,27,27,25,25,25,25,25,25,sum_0$d)
# 251 "sp2.hpf"
      endif
# 254 "sp2.hpf"
      call pgf90io_src_info(254,'sp2.hpf')
# 254 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 254 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after pistr1')
# 254 "sp2.hpf"
      z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 254 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 261 "sp2.hpf"
      call pghpf_localize_bounds(nps$d,1,1,4,1,i$$l3,i$$u3)
# 261 "sp2.hpf"
!     forall (i$i=i$$l3:i$$u3:1) nps(i$i) = npp(i$i) + 1
# 261 "sp2.hpf"
      do i$i = i$$l3, i$$u3
# 261 "sp2.hpf"
         nps(i$i) = npp(i$i) + 1
# 261 "sp2.hpf"
      enddo
      if (512 .gt. 0) then
# 262 "sp2.hpf"
         call pistr1(part,edges,npp,nps,5.0e-1,5.0e0,512,128,2,1672,4,2,
     +sum_0,part$d1,scr$d1,nps$d,nps$d,27,27,25,25,25,25,25,25,sum_0$d)
# 262 "sp2.hpf"
      endif
# 264 "sp2.hpf"
      call pgf90io_src_info(264,'sp2.hpf')
# 264 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 264 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after pistr1')
# 264 "sp2.hpf"
      z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 264 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 267 "sp2.hpf"
      call pdost1(part,q,noff,npp,qme,2,1672,4,4,35,128,part$d1,fx$d1,
     +nps$d,nps$d,27,25,25,25,25,25,25)
# 270 "sp2.hpf"
      call pgf90io_src_info(270,'sp2.hpf')
# 270 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 270 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after pdost')
# 270 "sp2.hpf"
      z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 270 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 275 "sp2.hpf"
      qi0 = - qme / affp
# 277 "sp2.hpf"
      call pghpf_get_scalar(nxp$s,nxp,nps$d,1)
# 277 "sp2.hpf"
      call pghpf_localize_bounds(fx$d1,2,1,4,1,i$$l4,i$$u4)
# 277 "sp2.hpf"
!     forall (i$i=i$$l4:i$$u4:1, i$i1=2:nxp$s + 1:1) q(i$i1,i$i) = q(
!    +i$i1,i$i) + qi0
# 277 "sp2.hpf"
      do i$i = i$$l4, i$$u4
# 277 "sp2.hpf"
         do i$i1 = 2, nxp$s + 1
# 277 "sp2.hpf"
            q(i$i1,i$i) = q(i$i1,i$i) + qi0
# 277 "sp2.hpf"
         enddo
# 277 "sp2.hpf"
      enddo
# 288 "sp2.hpf"
      call timer(tbegin,28)
99999 continue
# 289 "sp2.hpf"
      if (itime .lt. 25) then
# 291 "sp2.hpf"
         call pgf90io_src_info(291,'sp2.hpf')
# 291 "sp2.hpf"
         z__io = pgf90io_fmtw_init(6,0,0,0,z__fmt991,pghpf_0c)
# 291 "sp2.hpf"
         z__io = pgf90io_fmt_write(25,1,0,itime)
# 291 "sp2.hpf"
         z__io = pgf90io_fmtw_end()
         call pgf90_stop(pghpf_0c)
# 297 "sp2.hpf"
         isign = -1
# 301 "sp2.hpf"
         t1 = elapsed_time()
         call cppfp1(q,qc,isign,scr,scc,4,35,4,16,4,2,fx$d1,sct$d,25,
     +scr$d1,scc$d,25,25,25,25,25,25)
         call pgf90io_src_info(304,'sp2.hpf')
# 304 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 304 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after cppfp')
# 304 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 304 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 306 "sp2.hpf"
         call ifft(qc,fc,isign,mixup,sct,7,16,4,shifted,sct$d,sct$d,25,
     +mixup$d1,sct$d,25,25,25,shifted$d)
         call pgf90io_src_info(308,'sp2.hpf')
# 308 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 308 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after ifft')
# 308 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 308 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 313 "sp2.hpf"
         call ppois1(qc,fc,isign,ffc,ax,affp,we,128,16,4,4,sum_0,sct$d,
     +sct$d,25,sct$d,27,27,27,25,25,25,25,sum_0$d)
         call pgf90io_src_info(315,'sp2.hpf')
# 315 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 315 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after ppois')
# 315 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 315 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 319 "sp2.hpf"
         isign = 1
# 321 "sp2.hpf"
         call dfft(qc,fc,isign,mixup,sct,7,16,4,shifted,sct$d,sct$d,25,
     +mixup$d1,sct$d,25,25,25,shifted$d)
         call pgf90io_src_info(323,'sp2.hpf')
# 323 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 323 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after dfft')
# 323 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 323 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 328 "sp2.hpf"
         call cppfp1(fx,fc,isign,scr,scc,4,35,4,16,4,2,fx$d1,sct$d,25,
     +scr$d1,scc$d,25,25,25,25,25,25)
         call pgf90io_src_info(330,'sp2.hpf')
# 330 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 330 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after cppfp')
# 330 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 330 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 340 "sp2.hpf"
         call pghpf_localize_bounds(fx$d1,2,1,4,1,i$$l5,i$$u5)
# 340 "sp2.hpf"
!        forall (i$i=i$$l5:i$$u5:1, i$i1=1:35:1) q(i$i1,i$i) = 0.0e0
# 340 "sp2.hpf"
         do i$i = i$$l5, i$$u5
# 340 "sp2.hpf"
            do i$i1 = 1, 35
# 340 "sp2.hpf"
               q(i$i1,i$i) = 0.0e0
# 340 "sp2.hpf"
            enddo
# 340 "sp2.hpf"
         enddo
         wke = 0.0e0
# 346 "sp2.hpf"
         call ppush1(part,fx,npp,noff,qtme,2.0000000298e-1,wke,2,1672,4,
     +35,sum_0,edges,128,part$d1,fx$d1,nps$d,nps$d,27,27,27,25,25,25,25,
     +sum_0$d,scr$d1,25)
         call pgf90io_src_info(349,'sp2.hpf')
# 349 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 349 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after ppush')
# 349 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 349 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 358 "sp2.hpf"
         call pgf90io_src_info(358,'sp2.hpf')
# 358 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 358 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after pmove')
# 358 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 358 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 363 "sp2.hpf"
         call pdost1(part,q,noff,npp,qme,2,1672,4,4,35,128,part$d1,fx$d1
     +,nps$d,nps$d,27,25,25,25,25,25,25)
# 366 "sp2.hpf"
         call pgf90io_src_info(366,'sp2.hpf')
# 366 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 366 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'after pdost')
# 366 "sp2.hpf"
         z__io = pgf90io_ldw(27,1,0,elapsed_time())
# 366 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 371 "sp2.hpf"
         call pghpf_get_scalar(nxp$s1,nxp,nps$d,1)
# 371 "sp2.hpf"
         call pghpf_localize_bounds(fx$d1,2,1,4,1,i$$l6,i$$u6)
# 371 "sp2.hpf"
!        forall (i$i=i$$l6:i$$u6:1, i$i1=2:nxp$s1 + 1:1) q(i$i1,i$i) = q
!    +(i$i1,i$i) + qi0
# 371 "sp2.hpf"
         do i$i = i$$l6, i$$u6
# 371 "sp2.hpf"
            do i$i1 = 2, nxp$s1 + 1
# 371 "sp2.hpf"
               q(i$i1,i$i) = q(i$i1,i$i) + qi0
# 371 "sp2.hpf"
            enddo
# 371 "sp2.hpf"
         enddo
# 376 "sp2.hpf"
         wt = we + wke
         call pgf90io_src_info(377,'sp2.hpf')
# 377 "sp2.hpf"
         z__io = pgf90io_fmtw_init(6,0,0,0,z__fmt993,pghpf_0c)
# 377 "sp2.hpf"
         z__io = pgf90io_fmt_write(27,1,0,we)
# 377 "sp2.hpf"
         z__io = pgf90io_fmt_write(27,1,0,wke)
# 377 "sp2.hpf"
         z__io = pgf90io_fmt_write(27,1,0,wt)
# 377 "sp2.hpf"
         z__io = pgf90io_fmtw_end()
         itime = itime + 1
# 381 "sp2.hpf"
         goto 99999
# 381 "sp2.hpf"
      endif
# 388 "sp2.hpf"
      call timer(timeend,28)
      call pgf90io_src_info(389,'sp2.hpf')
# 389 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 389 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'total elapsed time')
# 389 "sp2.hpf"
      z__io = pgf90io_ldw(28,1,0,timeend - tbegin)
# 389 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 391 "sp2.hpf"
99998 continue
# 391 "sp2.hpf"
      deallocate(ffc)
# 391 "sp2.hpf"
      deallocate(fc)
# 391 "sp2.hpf"
      deallocate(qc)
# 391 "sp2.hpf"
      deallocate(sct)
# 391 "sp2.hpf"
      deallocate(scc)
# 391 "sp2.hpf"
      deallocate(shifted)
# 391 "sp2.hpf"
      deallocate(q)
# 391 "sp2.hpf"
      deallocate(fx)
# 391 "sp2.hpf"
      deallocate(mixup)
# 391 "sp2.hpf"
      deallocate(edges)
# 391 "sp2.hpf"
      deallocate(nxp)
# 391 "sp2.hpf"
      deallocate(noff)
# 391 "sp2.hpf"
      deallocate(npp)
# 391 "sp2.hpf"
      deallocate(nps)
# 391 "sp2.hpf"
      deallocate(scr)
# 391 "sp2.hpf"
      deallocate(sum_0)
# 391 "sp2.hpf"
      call pghpf_free(isum_0$d1)
# 391 "sp2.hpf"
      call pghpf_free(sum_0$d)
# 391 "sp2.hpf"
      call pghpf_free(jss$d)
# 391 "sp2.hpf"
      call pghpf_free(ihole$d1)
# 391 "sp2.hpf"
      call pghpf_free(ihole$d)
# 391 "sp2.hpf"
      call pghpf_free(rbufr$d1)
# 391 "sp2.hpf"
      call pghpf_free(rbufr$d)
# 391 "sp2.hpf"
      call pghpf_free(nps$d)
# 391 "sp2.hpf"
      call pghpf_free(scr$d1)
# 391 "sp2.hpf"
      call pghpf_free(mixup$d1)
# 391 "sp2.hpf"
      call pghpf_free(fx$d1)
# 391 "sp2.hpf"
      call pghpf_free(fx$d)
# 391 "sp2.hpf"
      call pghpf_free(maskp$d1)
# 391 "sp2.hpf"
      call pghpf_free(maskp$d)
# 391 "sp2.hpf"
      call pghpf_free(shifted$d)
# 391 "sp2.hpf"
      call pghpf_free(isum_0$d)
# 391 "sp2.hpf"
      call pghpf_free(scc$d)
# 391 "sp2.hpf"
      call pghpf_free(scr$d)
# 391 "sp2.hpf"
      call pghpf_free(sct$d)
# 391 "sp2.hpf"
      call pghpf_free(mixup$d)
# 391 "sp2.hpf"
      call pghpf_free(part$d1)
# 391 "sp2.hpf"
      call pghpf_free(part$d)
# 391 "sp2.hpf"
      call pghpf_free(proc$d)
# 391 "sp2.hpf"
      call pgf90_exit(0)
      end
# 393 "sp2.hpf"
      real function elapsed_time()
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer clock_count, clock_rate, clock_max, last_count, i$i, i$i1
     +, i$i2, i$i3, i$i4, i$i5, i$i6
      logical system_clock_not_yet_called
      save last_count, system_clock_not_yet_called
      data system_clock_not_yet_called /.true./
# 398 "sp2.hpf"
      call pghpf_sysclk(clock_count,clock_rate,clock_max,25,25,25)
# 398 "sp2.hpf"
!     call system_clock(clock_count,clock_rate,clock_max)
# 401 "sp2.hpf"
      if (system_clock_not_yet_called) then
         system_clock_not_yet_called = .false.
         elapsed_time = 0.0e0
         goto 99999
# 404 "sp2.hpf"
      endif
# 404 "sp2.hpf"
      if (clock_count .gt. last_count) then
         elapsed_time = real(clock_count - last_count) / real(clock_rate
     +)
# 406 "sp2.hpf"
      else
         elapsed_time = real(clock_max - last_count + clock_count) / 
     +real(clock_rate)
      endif
# 409 "sp2.hpf"
99999 continue
      last_count = clock_count
      goto 99998
99998 continue
# 412 "sp2.hpf"
      end
# 414 "sp2.hpf"
      subroutine timer(t,t$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      double precision t
      integer t$s0(1)
      integer val(8), i$i, i$i1, i$i2, i$i3, i$i4, i$i5, i$i6, val$d(1)
     +, val$d1(1)
      pointer (val$dp,val$d), (val$dp1,val$d1)
# 414 "sp2.hpf"
      call pghpf_template(val$dp,1,0,1,8)
# 414 "sp2.hpf"
      call pghpf_instance(val$dp1,val$d,25,4,0,0,0)
# 414 "sp2.hpf"
# 419 "sp2.hpf"
      call pghpf_dandt(pghpf_0c,pghpf_0c,pghpf_0c,val,14,14,14,val$d1)
# 419 "sp2.hpf"
!     call date_and_time(pghpf_0c,pghpf_0c,pghpf_0c,val)
      t = dble(val(8)) * 1.00000000000000002d-3 + dble(val(7)) + dble(
     +val(6)) * 6.0d1 + dble(val(5)) * 3.6d3
# 423 "sp2.hpf"
99999 continue
# 423 "sp2.hpf"
      call pghpf_free(val$d1)
# 423 "sp2.hpf"
      call pghpf_free(val$d)
# 423 "sp2.hpf"
      end
# 429 "sp2.hpf"
      subroutine pdost1(part$bs,q$bs,noff$bs,npp$bs,qme,idimp,npmax,
     +kblok,nblok,nxpmx,nx,part$s0,q$s0,noff$s0,npp$s0,qme$s0,idimp$s0,
     +npmax$s0,kblok$s0,nblok$s0,nxpmx$s0,nx$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer nblok, nxpmx
      real qme
      integer part$bs(1), q$bs(1), noff$bs(1), npp$bs(1), part$s0(1), 
     +q$s0(1), noff$s0(1), npp$s0(1), qme$s0(1), idimp$s0(1), npmax$s0(1
     +), kblok$s0(1), nblok$s0(1), nxpmx$s0(1), nx$s0(1)
      integer noff(:), npp(:), z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5
     +, z_b_6, z_b_7, z_b_8, z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, 
     +z_e_41, z_e_42, z_b_14, z_b_15, z_b_16, z_b_17, z_b_18, z_b_19, 
     +z_b_20, z_b_21, z_b_22, z_b_23, z_b_24, z_b_25, z_b_26, z_b_27, 
     +z_b_28, z_b_29, z_b_30, z_b_31, z_b_32, z_b_33, z_b_34, z_b_35, 
     +z_b_36, z_b_37, z_b_38, z_b_39, z_b_40, z_b_41, z_b_42, z_b_43, 
     +z__io, i$i, i$i1, i$i2, i$i3, i$i4, i$i5, i$i6, noff$f77(:), 
     +npp$f77(:), part$f77$d(1), part$f77$d1(1), q$f77$d(1), q$f77$d1(1)
     +, noff$f77$d(1), noff$f77$d1(1), npp$f77$d(1), npp$f77$d1(1), 
     +global_q$f77$d(1), global_q$f77$d1(1), noff$f771(:), npp$f771(:), 
     +q$f771$d(1), q$f771$d1(1), noff$f771$d(1), noff$f771$d1(1), 
     +npp$f771$d(1), npp$f771$d1(1), global_q$f771$d(1), 
     +global_q$f771$d1(1), npp$tl$d(1), noff$tl$d(1), q$tl$d(1), 
     +part$tl$d(1), global_q$d(1), npp$d(1), noff$d(1), q$d(1), part$d(1
     +), global_q$d1(1), npp$d1(1), noff$d1(1), q$d1(1), part$d1(1), 
     +l$$b, u$$b, l$$b1, u$$b1, l$$b2, u$$b2, l$$b3, u$$b3, l$$b4, u$$b4
     +, l$$b5, u$$b5, l$$b6, u$$b6
      real part(:,:,:), q(:,:), part$f77(:,:,:), q$f77(:,:), q$f771(:,:)
      dimension global_q(:,:)
      allocatable part, q, noff, npp, part$f77, q$f77, noff$f77, npp$f77
     +, q$f771, noff$f771, npp$f771
      pointer (part$p,part), (q$p,q), (noff$p,noff), (npp$p,npp), (
     +part$f77$p,part$f77), (q$f77$p,q$f77), (noff$f77$p,noff$f77), (
     +npp$f77$p,npp$f77), (part$f77$dp,part$f77$d), (part$f77$dp1,
     +part$f77$d1), (q$f77$dp,q$f77$d), (q$f77$dp1,q$f77$d1), (
     +noff$f77$dp,noff$f77$d), (noff$f77$dp1,noff$f77$d1), (npp$f77$dp,
     +npp$f77$d), (npp$f77$dp1,npp$f77$d1), (global_q$f77$dp,
     +global_q$f77$d), (global_q$f77$dp1,global_q$f77$d1), (q$f771$p,
     +q$f771), (noff$f771$p,noff$f771), (npp$f771$p,npp$f771), (
     +q$f771$dp,q$f771$d), (q$f771$dp1,q$f771$d1), (noff$f771$dp,
     +noff$f771$d), (noff$f771$dp1,noff$f771$d1), (npp$f771$dp,
     +npp$f771$d), (npp$f771$dp1,npp$f771$d1), (global_q$f771$dp,
     +global_q$f771$d), (global_q$f771$dp1,global_q$f771$d1), (npp$tl$dp
     +,npp$tl$d), (noff$tl$dp,noff$tl$d), (q$tl$dp,q$tl$d), (part$tl$dp,
     +part$tl$d), (global_q$dp,global_q$d), (npp$dp,npp$d), (noff$dp,
     +noff$d), (q$dp,q$d), (part$dp,part$d), (global_q$dp1,global_q$d1)
     +, (npp$dp1,npp$d1), (noff$dp1,noff$d1), (q$dp1,q$d1), (part$dp1,
     +part$d1)
      integer pgf90io_ldw_init, pgf90io_ldw, pgf90io_ldw_end, 
     +pghpf_extent
      external indep_loop_pdost1, all_to_all_q
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(part$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(part$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(part$s0,3)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(q$s0,1)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(q$s0,2)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(noff$s0,1)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(npp$s0,1)
# 0 "sp2.hpf"
      z_e_41 = nxpmx
# 0 "sp2.hpf"
      z_e_42 = nblok
# 0 "sp2.hpf"
      call pghpf_qopy_in(part$p,pghpf_0(3),pghpf_0(3),part$dp1,part$bs,
     +part$s0,3,27,4,2052,3,0,z_b_0,z_b_2,z_b_4,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(part$d1,l$$b,u$$b,l$$b1,u$$b1,l$$b2,u$$b2)
# 0 "sp2.hpf"
      redimension part(l$$b:u$$b,l$$b1:u$$b1,l$$b2:u$$b2)
# 0 "sp2.hpf"
      call pghpf_qopy_in(q$p,pghpf_0(3),pghpf_0(3),q$dp1,q$bs,q$s0,2,27,
     +4,2052,1,0,z_b_10,z_b_12,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(q$d1,l$$b3,u$$b3,l$$b4,u$$b4)
# 0 "sp2.hpf"
      redimension q(l$$b3:u$$b3,l$$b4:u$$b4)
# 0 "sp2.hpf"
      call pghpf_qopy_in(noff$p,pghpf_0(3),pghpf_0(3),noff$dp1,noff$bs,
     +noff$s0,1,25,4,2052,0,0,z_b_6,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(noff$d1,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension noff(l$$b5:u$$b5)
# 0 "sp2.hpf"
      call pghpf_qopy_in(npp$p,pghpf_0(3),pghpf_0(3),npp$dp1,npp$bs,
     +npp$s0,1,25,4,2052,0,0,z_b_8,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(npp$d1,l$$b6,u$$b6)
# 0 "sp2.hpf"
      redimension npp(l$$b6:u$$b6)
# 0 "sp2.hpf"
      call pghpf_template(global_q$dp,2,0,1,z_e_41,1,z_e_42)
# 0 "sp2.hpf"
      call pghpf_instance(global_q$dp1,global_q$d,27,4,0,0,0,0,0)
# 0 "sp2.hpf"
      allocate(global_q(1:z_e_41,1:z_e_42))
# 0 "sp2.hpf"
      z_b_14 = 1
# 0 "sp2.hpf"
      z_b_15 = pghpf_extent(part$d1,1)
# 0 "sp2.hpf"
      z_b_16 = 1
# 0 "sp2.hpf"
      z_b_17 = pghpf_extent(part$d1,2)
# 0 "sp2.hpf"
      z_b_18 = 1
# 0 "sp2.hpf"
      z_b_19 = pghpf_extent(part$d1,3)
# 0 "sp2.hpf"
      z_b_24 = 1
# 0 "sp2.hpf"
      z_b_25 = pghpf_extent(q$d1,1)
# 0 "sp2.hpf"
      z_b_26 = 1
# 0 "sp2.hpf"
      z_b_27 = pghpf_extent(q$d1,2)
# 0 "sp2.hpf"
      z_b_20 = 1
# 0 "sp2.hpf"
      z_b_21 = pghpf_extent(noff$d1,1)
# 0 "sp2.hpf"
      z_b_22 = 1
# 0 "sp2.hpf"
      z_b_23 = pghpf_extent(npp$d1,1)
# 0 "sp2.hpf"
      z_b_28 = 1
# 0 "sp2.hpf"
      z_b_29 = pghpf_extent(global_q$d1,1)
# 0 "sp2.hpf"
      z_b_30 = 1
# 0 "sp2.hpf"
      z_b_31 = pghpf_extent(global_q$d1,2)
# 0 "sp2.hpf"
      call pghpf_qopy_in(part$f77$p,pghpf_0(3),pghpf_0(3),part$f77$dp1,
     +part,part$d1,3,27,4,2148,3,0,z_b_14,z_b_16,z_b_18)
# 0 "sp2.hpf"
      call pghpf_qopy_in(q$f77$p,pghpf_0(3),pghpf_0(3),q$f77$dp1,q,q$d1,
     +2,27,4,2084,1,0,z_b_24,z_b_26)
# 0 "sp2.hpf"
      call pghpf_qopy_in(noff$f77$p,pghpf_0(3),pghpf_0(3),noff$f77$dp1,
     +noff,noff$d1,1,25,4,2148,0,0,z_b_20)
# 0 "sp2.hpf"
      call pghpf_qopy_in(npp$f77$p,pghpf_0(3),pghpf_0(3),npp$f77$dp1,npp
     +,npp$d1,1,25,4,2148,0,0,z_b_22)
# 0 "sp2.hpf"
# 471 "sp2.hpf"
      call indep_loop_pdost1(part$f77,q$f77,noff$f77,npp$f77,qme,idimp,
     +npmax,kblok,nblok,nxpmx,global_q,nx)
# 471 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f77,npp$d1,npp$f77$d1,1)
# 471 "sp2.hpf"
      call pghpf_copy_out(noff,noff$f77,noff$d1,noff$f77$d1,1)
# 471 "sp2.hpf"
      call pghpf_copy_out(q,q$f77,q$d1,q$f77$d1,0)
# 471 "sp2.hpf"
      call pghpf_copy_out(part,part$f77,part$d1,part$f77$d1,1)
# 473 "sp2.hpf"
      call pgf90io_src_info(473,'sp2.hpf')
# 473 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 473 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'first part')
# 473 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 473 "sp2.hpf"
      z_b_36 = 1
# 473 "sp2.hpf"
      z_b_37 = pghpf_extent(q$d1,1)
# 473 "sp2.hpf"
      z_b_38 = 1
# 473 "sp2.hpf"
      z_b_39 = pghpf_extent(q$d1,2)
# 473 "sp2.hpf"
      z_b_32 = 1
# 473 "sp2.hpf"
      z_b_33 = pghpf_extent(noff$d1,1)
# 473 "sp2.hpf"
      z_b_34 = 1
# 473 "sp2.hpf"
      z_b_35 = pghpf_extent(npp$d1,1)
# 473 "sp2.hpf"
      z_b_40 = 1
# 473 "sp2.hpf"
      z_b_41 = pghpf_extent(global_q$d1,1)
# 473 "sp2.hpf"
      z_b_42 = 1
# 473 "sp2.hpf"
      z_b_43 = pghpf_extent(global_q$d1,2)
# 473 "sp2.hpf"
      call pghpf_qopy_in(q$f771$p,pghpf_0(3),pghpf_0(3),q$f771$dp1,q,
     +q$d1,2,27,4,2084,1,0,z_b_36,z_b_38)
# 473 "sp2.hpf"
      call pghpf_qopy_in(noff$f771$p,pghpf_0(3),pghpf_0(3),noff$f771$dp1
     +,noff,noff$d1,1,25,4,2148,0,0,z_b_32)
# 473 "sp2.hpf"
      call pghpf_qopy_in(npp$f771$p,pghpf_0(3),pghpf_0(3),npp$f771$dp1,
     +npp,npp$d1,1,25,4,2148,0,0,z_b_34)
# 473 "sp2.hpf"
# 474 "sp2.hpf"
      call all_to_all_q(q$f771,noff$f771,npp$f771,qme,idimp,npmax,kblok,
     +nblok,nxpmx,global_q,nx)
# 474 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f771,npp$d1,npp$f771$d1,1)
# 474 "sp2.hpf"
      call pghpf_copy_out(noff,noff$f771,noff$d1,noff$f771$d1,1)
# 474 "sp2.hpf"
      call pghpf_copy_out(q,q$f771,q$d1,q$f771$d1,0)
# 477 "sp2.hpf"
99999 continue
# 477 "sp2.hpf"
      call pghpf_free(global_q$d1)
# 477 "sp2.hpf"
      call pghpf_free(global_q$d)
# 477 "sp2.hpf"
      deallocate(global_q)
# 477 "sp2.hpf"
      call pghpf_copy_out(npp$bs,npp,npp$s0,npp$d1,0)
# 477 "sp2.hpf"
      call pghpf_copy_out(noff$bs,noff,noff$s0,noff$d1,0)
# 477 "sp2.hpf"
      call pghpf_copy_out(q$bs,q,q$s0,q$d1,0)
# 477 "sp2.hpf"
      call pghpf_copy_out(part$bs,part,part$s0,part$d1,0)
# 477 "sp2.hpf"
      end
# 488 "sp2.hpf"
      subroutine pmove1(part$bs,edges$bs,npp$bs,sbufr$bs,sbufl$bs,
     +rbufr$bs,rbufl$bs,ihole$bs,jsr$bs,jsl$bs,jss$bs,nx,nvp,idimp,npmax
     +,nblok,idps,nbmax,ntmax,ierr,isum_0$bs,part$s0,edges$s0,npp$s0,
     +sbufr$s0,sbufl$s0,rbufr$s0,rbufl$s0,ihole$s0,jsr$s0,jsl$s0,jss$s0,
     +nx$s0,nvp$s0,idimp$s0,npmax$s0,nblok$s0,idps$s0,nbmax$s0,ntmax$s0,
     +ierr$s0,isum_0$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer part$bs(1), edges$bs(1), npp$bs(1), sbufr$bs(1), sbufl$bs(
     +1), rbufr$bs(1), rbufl$bs(1), ihole$bs(1), jsr$bs(1), jsl$bs(1), 
     +jss$bs(1), isum_0$bs(1), part$s0(1), edges$s0(1), npp$s0(1), 
     +sbufr$s0(1), sbufl$s0(1), rbufr$s0(1), rbufl$s0(1), ihole$s0(1), 
     +jsr$s0(1), jsl$s0(1), jss$s0(1), nx$s0(1), nvp$s0(1), idimp$s0(1)
     +, npmax$s0(1), nblok$s0(1), idps$s0(1), nbmax$s0(1), ntmax$s0(1), 
     +ierr$s0(1), isum_0$s0(1)
      integer npp(:), ihole(:,:), jsr(:,:), jsl(:,:), jss(:,:), isum_0(:
     +), z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5, z_b_6, z_b_7, z_b_8, 
     +z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, z_b_14, z_b_15, z_b_16, 
     +z_b_17, z_b_18, z_b_19, z_b_20, z_b_21, z_b_22, z_b_23, z_b_24, 
     +z_b_25, z_b_26, z_b_27, z_b_28, z_b_29, z_b_30, z_b_31, z_b_32, 
     +z_b_33, z_b_34, z_b_35, z_b_36, z_b_37, z_b_38, z_b_39, z_b_40, 
     +z_b_41, z_b_42, z_b_43, z_b_44, z_b_45, z_b_46, z_b_47, z_b_48, 
     +z_b_49, z_b_50, z_b_51, z_b_52, z_b_53, z__io, i$i, i$i1, i$i2, 
     +i$i3, i$i4, i$i5, i$i6, npp$r, jss$r, isum_0$r, isum_0$r1, npp$r1
     +, npp$f77(:), ihole$f77(:,:), jsr$f77(:,:), jsl$f77(:,:), jss$f77(
     +:,:), z_b_54, z_b_55, z_b_56, z_b_57, z_b_58, z_b_59, z_b_60, 
     +z_b_61, z_b_62, z_b_63, z_b_64, z_b_65, z_b_66, z_b_67, z_b_68, 
     +z_b_69, z_b_70, z_b_71, z_b_72, z_b_73, part$f77$d(1), part$f77$d1
     +(1), edges$f77$d(1), edges$f77$d1(1), npp$f77$d(1), npp$f77$d1(1)
     +, sbufr$f77$d(1), sbufr$f77$d1(1), sbufl$f77$d(1), sbufl$f77$d1(1)
     +, ihole$f77$d(1), ihole$f77$d1(1), jsr$f77$d(1), jsr$f77$d1(1), 
     +jsl$f77$d(1), jsl$f77$d1(1), jss$f77$d(1), jss$f77$d1(1), jss$s(1)
     +, jsl$s(1), jsr$s(1), jsr$s1(1), jsl$s1(1), jsr$f771(:,:), 
     +jsl$f771(:,:)
      integer isum_0$f77(:), z_b_74, z_b_75, z_b_76, z_b_77, z_b_78, 
     +z_b_79, z_b_80, z_b_81, z_b_82, z_b_83, z_b_84, z_b_85, z_b_86, 
     +edges$f771$d(1), edges$f771$d1(1), rbufr$f77$d(1), rbufr$f77$d1(1)
     +, rbufl$f77$d(1), rbufl$f77$d1(1), jsr$f771$d(1), jsr$f771$d1(1), 
     +jsl$f771$d(1), jsl$f771$d1(1), isum_0$f77$d(1), isum_0$f77$d1(1), 
     +jsr$f772(:,:), jsl$f772(:,:), jss$f771(:,:), z_b_87, z_b_88, 
     +z_b_89, z_b_90, z_b_91, z_b_92, z_b_93, z_b_94, z_b_95, z_b_96, 
     +z_b_97, z_b_98, z_b_99, z_b_100, z_b_101, z_b_102, z_b_103, 
     +z_b_104, z_b_105, z_b_106, edges$f772$d(1), edges$f772$d1(1), 
     +sbufr$f771$d(1), sbufr$f771$d1(1), sbufl$f771$d(1), sbufl$f771$d1(
     +1), rbufr$f771$d(1), rbufr$f771$d1(1), rbufl$f771$d(1), 
     +rbufl$f771$d1(1), jsr$f772$d(1), jsr$f772$d1(1), jsl$f772$d(1), 
     +jsl$f772$d1(1), jss$f771$d(1), jss$f771$d1(1), jsr$f773(:,:), 
     +jsl$f773(:,:), jss$f772(:,:), isum_0$f771(:), npp$f771(:), z_b_107
     +, z_b_108, z_b_109, z_b_110, z_b_111, z_b_112, z_b_113, z_b_114, 
     +jsr$f773$d(1), jsr$f773$d1(1), jsl$f773$d(1), jsl$f773$d1(1), 
     +jss$f772$d(1), jss$f772$d1(1), isum_0$f771$d(1), isum_0$f771$d1(1)
     +, npp$f771$d(1), npp$f771$d1(1), npp$f772(:), ihole$f771(:,:), 
     +jsr$f774(:,:)
      integer jsl$f774(:,:), jss$f773(:,:), z_b_115, z_b_116, z_b_117, 
     +z_b_118, z_b_119, z_b_120, z_b_121, z_b_122, z_b_123, z_b_124, 
     +z_b_125, z_b_126, z_b_127, z_b_128, z_b_129, z_b_130, z_b_131, 
     +z_b_132, z_b_133, z_b_134, part$f771$d(1), part$f771$d1(1), 
     +edges$f773$d(1), edges$f773$d1(1), npp$f772$d(1), npp$f772$d1(1), 
     +rbufr$f772$d(1), rbufr$f772$d1(1), rbufl$f772$d(1), rbufl$f772$d1(
     +1), ihole$f771$d(1), ihole$f771$d1(1), jsr$f774$d(1), jsr$f774$d1(
     +1), jsl$f774$d(1), jsl$f774$d1(1), jss$f773$d(1), jss$f773$d1(1), 
     +isum_0$tl$d(1), jss$tl$d(1), jsl$tl$d(1), jsr$tl$d(1), ihole$tl$d(
     +1), rbufl$tl$d(1), rbufr$tl$d(1), sbufl$tl$d(1), sbufr$tl$d(1), 
     +npp$tl$d(1), edges$tl$d(1), part$tl$d(1), isum_0$d(1), jss$d(1), 
     +jsl$d(1), jsr$d(1), ihole$d(1), rbufl$d(1), rbufr$d(1), sbufl$d(1)
     +, sbufr$d(1), npp$d(1), edges$d(1), part$d(1), isum_0$d1(1), 
     +jss$d1(1), jsl$d1(1), jsr$d1(1), ihole$d1(1), rbufl$d1(1), 
     +rbufr$d1(1), sbufl$d1(1), sbufr$d1(1), npp$d1(1), edges$d1(1), 
     +part$d1(1), l$$b, u$$b, l$$b1, u$$b1, l$$b2, u$$b2, l$$b3, u$$b3, 
     +l$$b4, u$$b4, l$$b5, u$$b5, l$$b6, u$$b6, l$$b7, u$$b7, l$$b8, 
     +u$$b8, l$$b9, u$$b9, l$$b10, u$$b10, l$$b11, u$$b11, l$$b12, 
     +u$$b12
      integer l$$b13, u$$b13, l$$b14, u$$b14, l$$b15, u$$b15, l$$b16, 
     +u$$b16, l$$b17, u$$b17, l$$b18, u$$b18, l$$b19, u$$b19, l$$b20, 
     +u$$b20, l$$b21, u$$b21, l$$b22, u$$b22, l$$b23, u$$b23, l$$b24, 
     +u$$b24, l$$b25, u$$b25, l$$b26, u$$b26
      real part(:,:,:), edges(:,:), sbufr(:,:,:), sbufl(:,:,:), rbufr(:,
     +:,:), rbufl(:,:,:), part$f77(:,:,:), edges$f77(:,:), sbufr$f77(:,:
     +,:), sbufl$f77(:,:,:), edges$f771(:,:), rbufr$f77(:,:,:), 
     +rbufl$f77(:,:,:), edges$f772(:,:), sbufr$f771(:,:,:), sbufl$f771(:
     +,:,:), rbufr$f771(:,:,:), rbufl$f771(:,:,:), part$f771(:,:,:), 
     +edges$f773(:,:), rbufr$f772(:,:,:), rbufl$f772(:,:,:)
      allocatable part, edges, npp, sbufr, sbufl, rbufr, rbufl, ihole, 
     +jsr, jsl, jss, isum_0, part$f77, edges$f77, npp$f77, sbufr$f77, 
     +sbufl$f77, ihole$f77, jsr$f77, jsl$f77, jss$f77, edges$f771, 
     +rbufr$f77, rbufl$f77, jsr$f771, jsl$f771, isum_0$f77, edges$f772, 
     +sbufr$f771, sbufl$f771, rbufr$f771, rbufl$f771, jsr$f772, jsl$f772
     +, jss$f771, jsr$f773, jsl$f773, jss$f772, isum_0$f771, npp$f771, 
     +part$f771, edges$f773, npp$f772, rbufr$f772, rbufl$f772, 
     +ihole$f771, jsr$f774, jsl$f774, jss$f773
      pointer (part$p,part), (edges$p,edges), (npp$p,npp), (sbufr$p,
     +sbufr), (sbufl$p,sbufl), (rbufr$p,rbufr), (rbufl$p,rbufl), (
     +ihole$p,ihole), (jsr$p,jsr), (jsl$p,jsl), (jss$p,jss), (isum_0$p,
     +isum_0), (part$f77$p,part$f77), (edges$f77$p,edges$f77), (
     +npp$f77$p,npp$f77), (sbufr$f77$p,sbufr$f77), (sbufl$f77$p,
     +sbufl$f77), (ihole$f77$p,ihole$f77), (jsr$f77$p,jsr$f77), (
     +jsl$f77$p,jsl$f77), (jss$f77$p,jss$f77), (part$f77$dp,part$f77$d)
     +, (part$f77$dp1,part$f77$d1), (edges$f77$dp,edges$f77$d), (
     +edges$f77$dp1,edges$f77$d1), (npp$f77$dp,npp$f77$d), (npp$f77$dp1,
     +npp$f77$d1), (sbufr$f77$dp,sbufr$f77$d), (sbufr$f77$dp1,
     +sbufr$f77$d1), (sbufl$f77$dp,sbufl$f77$d), (sbufl$f77$dp1,
     +sbufl$f77$d1), (ihole$f77$dp,ihole$f77$d), (ihole$f77$dp1,
     +ihole$f77$d1), (jsr$f77$dp,jsr$f77$d), (jsr$f77$dp1,jsr$f77$d1), (
     +jsl$f77$dp,jsl$f77$d), (jsl$f77$dp1,jsl$f77$d1), (jss$f77$dp,
     +jss$f77$d), (jss$f77$dp1,jss$f77$d1), (jss$sp,jss$s), (jsl$sp,
     +jsl$s), (jsr$sp,jsr$s), (jsr$sp1,jsr$s1), (jsl$sp1,jsl$s1), (
     +edges$f771$p,edges$f771), (rbufr$f77$p,rbufr$f77), (rbufl$f77$p,
     +rbufl$f77), (jsr$f771$p,jsr$f771), (jsl$f771$p,jsl$f771), (
     +isum_0$f77$p,isum_0$f77)
      pointer (edges$f771$dp,edges$f771$d), (edges$f771$dp1,
     +edges$f771$d1), (rbufr$f77$dp,rbufr$f77$d), (rbufr$f77$dp1,
     +rbufr$f77$d1), (rbufl$f77$dp,rbufl$f77$d), (rbufl$f77$dp1,
     +rbufl$f77$d1), (jsr$f771$dp,jsr$f771$d), (jsr$f771$dp1,jsr$f771$d1
     +), (jsl$f771$dp,jsl$f771$d), (jsl$f771$dp1,jsl$f771$d1), (
     +isum_0$f77$dp,isum_0$f77$d), (isum_0$f77$dp1,isum_0$f77$d1), (
     +edges$f772$p,edges$f772), (sbufr$f771$p,sbufr$f771), (sbufl$f771$p
     +,sbufl$f771), (rbufr$f771$p,rbufr$f771), (rbufl$f771$p,rbufl$f771)
     +, (jsr$f772$p,jsr$f772), (jsl$f772$p,jsl$f772), (jss$f771$p,
     +jss$f771), (edges$f772$dp,edges$f772$d), (edges$f772$dp1,
     +edges$f772$d1), (sbufr$f771$dp,sbufr$f771$d), (sbufr$f771$dp1,
     +sbufr$f771$d1), (sbufl$f771$dp,sbufl$f771$d), (sbufl$f771$dp1,
     +sbufl$f771$d1), (rbufr$f771$dp,rbufr$f771$d), (rbufr$f771$dp1,
     +rbufr$f771$d1), (rbufl$f771$dp,rbufl$f771$d), (rbufl$f771$dp1,
     +rbufl$f771$d1), (jsr$f772$dp,jsr$f772$d), (jsr$f772$dp1,
     +jsr$f772$d1), (jsl$f772$dp,jsl$f772$d), (jsl$f772$dp1,jsl$f772$d1)
     +, (jss$f771$dp,jss$f771$d), (jss$f771$dp1,jss$f771$d1), (
     +jsr$f773$p,jsr$f773), (jsl$f773$p,jsl$f773), (jss$f772$p,jss$f772)
     +, (isum_0$f771$p,isum_0$f771)
      pointer (npp$f771$p,npp$f771), (jsr$f773$dp,jsr$f773$d), (
     +jsr$f773$dp1,jsr$f773$d1), (jsl$f773$dp,jsl$f773$d), (jsl$f773$dp1
     +,jsl$f773$d1), (jss$f772$dp,jss$f772$d), (jss$f772$dp1,jss$f772$d1
     +), (isum_0$f771$dp,isum_0$f771$d), (isum_0$f771$dp1,isum_0$f771$d1
     +), (npp$f771$dp,npp$f771$d), (npp$f771$dp1,npp$f771$d1), (
     +part$f771$p,part$f771), (edges$f773$p,edges$f773), (npp$f772$p,
     +npp$f772), (rbufr$f772$p,rbufr$f772), (rbufl$f772$p,rbufl$f772), (
     +ihole$f771$p,ihole$f771), (jsr$f774$p,jsr$f774), (jsl$f774$p,
     +jsl$f774), (jss$f773$p,jss$f773), (part$f771$dp,part$f771$d), (
     +part$f771$dp1,part$f771$d1), (edges$f773$dp,edges$f773$d), (
     +edges$f773$dp1,edges$f773$d1), (npp$f772$dp,npp$f772$d), (
     +npp$f772$dp1,npp$f772$d1), (rbufr$f772$dp,rbufr$f772$d), (
     +rbufr$f772$dp1,rbufr$f772$d1), (rbufl$f772$dp,rbufl$f772$d), (
     +rbufl$f772$dp1,rbufl$f772$d1), (ihole$f771$dp,ihole$f771$d), (
     +ihole$f771$dp1,ihole$f771$d1), (jsr$f774$dp,jsr$f774$d), (
     +jsr$f774$dp1,jsr$f774$d1), (jsl$f774$dp,jsl$f774$d), (jsl$f774$dp1
     +,jsl$f774$d1), (jss$f773$dp,jss$f773$d), (jss$f773$dp1,jss$f773$d1
     +), (isum_0$tl$dp,isum_0$tl$d), (jss$tl$dp,jss$tl$d), (jsl$tl$dp,
     +jsl$tl$d)
      pointer (jsr$tl$dp,jsr$tl$d), (ihole$tl$dp,ihole$tl$d), (
     +rbufl$tl$dp,rbufl$tl$d), (rbufr$tl$dp,rbufr$tl$d), (sbufl$tl$dp,
     +sbufl$tl$d), (sbufr$tl$dp,sbufr$tl$d), (npp$tl$dp,npp$tl$d), (
     +edges$tl$dp,edges$tl$d), (part$tl$dp,part$tl$d), (isum_0$dp,
     +isum_0$d), (jss$dp,jss$d), (jsl$dp,jsl$d), (jsr$dp,jsr$d), (
     +ihole$dp,ihole$d), (rbufl$dp,rbufl$d), (rbufr$dp,rbufr$d), (
     +sbufl$dp,sbufl$d), (sbufr$dp,sbufr$d), (npp$dp,npp$d), (edges$dp,
     +edges$d), (part$dp,part$d), (isum_0$dp1,isum_0$d1), (jss$dp1,
     +jss$d1), (jsl$dp1,jsl$d1), (jsr$dp1,jsr$d1), (ihole$dp1,ihole$d1)
     +, (rbufl$dp1,rbufl$d1), (rbufr$dp1,rbufr$d1), (sbufl$dp1,sbufl$d1)
     +, (sbufr$dp1,sbufr$d1), (npp$dp1,npp$d1), (edges$dp1,edges$d1), (
     +part$dp1,part$d1)
      integer pgf90io_ldw_init, pgf90io_ldw, pgf90io_ldw_end, 
     +pghpf_extent, pghpf_sect
      external indep_loop_pmove1_1, indep_loop_pmove1_2, 
     +indep_loop_pmove1_3, indep_loop_pmove1_4, indep_loop_pmove1_5
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(part$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(part$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(part$s0,3)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(edges$s0,1)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(edges$s0,2)
# 0 "sp2.hpf"
      z_b_34 = 1
# 0 "sp2.hpf"
      z_b_35 = pghpf_extent(npp$s0,1)
# 0 "sp2.hpf"
      z_b_16 = 1
# 0 "sp2.hpf"
      z_b_17 = pghpf_extent(sbufr$s0,1)
# 0 "sp2.hpf"
      z_b_18 = 1
# 0 "sp2.hpf"
      z_b_19 = pghpf_extent(sbufr$s0,2)
# 0 "sp2.hpf"
      z_b_20 = 1
# 0 "sp2.hpf"
      z_b_21 = pghpf_extent(sbufr$s0,3)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(sbufl$s0,1)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(sbufl$s0,2)
# 0 "sp2.hpf"
      z_b_14 = 1
# 0 "sp2.hpf"
      z_b_15 = pghpf_extent(sbufl$s0,3)
# 0 "sp2.hpf"
      z_b_28 = 1
# 0 "sp2.hpf"
      z_b_29 = pghpf_extent(rbufr$s0,1)
# 0 "sp2.hpf"
      z_b_30 = 1
# 0 "sp2.hpf"
      z_b_31 = pghpf_extent(rbufr$s0,2)
# 0 "sp2.hpf"
      z_b_32 = 1
# 0 "sp2.hpf"
      z_b_33 = pghpf_extent(rbufr$s0,3)
# 0 "sp2.hpf"
      z_b_22 = 1
# 0 "sp2.hpf"
      z_b_23 = pghpf_extent(rbufl$s0,1)
# 0 "sp2.hpf"
      z_b_24 = 1
# 0 "sp2.hpf"
      z_b_25 = pghpf_extent(rbufl$s0,2)
# 0 "sp2.hpf"
      z_b_26 = 1
# 0 "sp2.hpf"
      z_b_27 = pghpf_extent(rbufl$s0,3)
# 0 "sp2.hpf"
      z_b_48 = 1
# 0 "sp2.hpf"
      z_b_49 = pghpf_extent(ihole$s0,1)
# 0 "sp2.hpf"
      z_b_50 = 1
# 0 "sp2.hpf"
      z_b_51 = pghpf_extent(ihole$s0,2)
# 0 "sp2.hpf"
      z_b_40 = 1
# 0 "sp2.hpf"
      z_b_41 = pghpf_extent(jsr$s0,1)
# 0 "sp2.hpf"
      z_b_42 = 1
# 0 "sp2.hpf"
      z_b_43 = pghpf_extent(jsr$s0,2)
# 0 "sp2.hpf"
      z_b_36 = 1
# 0 "sp2.hpf"
      z_b_37 = pghpf_extent(jsl$s0,1)
# 0 "sp2.hpf"
      z_b_38 = 1
# 0 "sp2.hpf"
      z_b_39 = pghpf_extent(jsl$s0,2)
# 0 "sp2.hpf"
      z_b_44 = 1
# 0 "sp2.hpf"
      z_b_45 = pghpf_extent(jss$s0,1)
# 0 "sp2.hpf"
      z_b_46 = 1
# 0 "sp2.hpf"
      z_b_47 = pghpf_extent(jss$s0,2)
# 0 "sp2.hpf"
      z_b_52 = 1
# 0 "sp2.hpf"
      z_b_53 = pghpf_extent(isum_0$s0,1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(part$p,pghpf_0(3),pghpf_0(3),part$dp1,part$bs,
     +part$s0,3,27,4,2052,3,0,z_b_0,z_b_2,z_b_4,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(part$d1,l$$b,u$$b,l$$b1,u$$b1,l$$b2,u$$b2)
# 0 "sp2.hpf"
      redimension part(l$$b:u$$b,l$$b1:u$$b1,l$$b2:u$$b2)
# 0 "sp2.hpf"
      call pghpf_qopy_in(edges$p,pghpf_0(3),pghpf_0(3),edges$dp1,
     +edges$bs,edges$s0,2,27,4,2052,1,0,z_b_6,z_b_8,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(edges$d1,l$$b3,u$$b3,l$$b4,u$$b4)
# 0 "sp2.hpf"
      redimension edges(l$$b3:u$$b3,l$$b4:u$$b4)
# 0 "sp2.hpf"
      call pghpf_qopy_in(npp$p,pghpf_0(3),pghpf_0(3),npp$dp1,npp$bs,
     +npp$s0,1,25,4,2052,0,0,z_b_34,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(npp$d1,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension npp(l$$b5:u$$b5)
# 0 "sp2.hpf"
      call pghpf_qopy_in(sbufr$p,pghpf_0(3),pghpf_0(3),sbufr$dp1,
     +sbufr$bs,sbufr$s0,3,27,4,2052,3,0,z_b_16,z_b_18,z_b_20,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(sbufr$d1,l$$b6,u$$b6,l$$b7,u$$b7,l$$b8,u$$b8)
# 0 "sp2.hpf"
      redimension sbufr(l$$b6:u$$b6,l$$b7:u$$b7,l$$b8:u$$b8)
# 0 "sp2.hpf"
      call pghpf_qopy_in(sbufl$p,pghpf_0(3),pghpf_0(3),sbufl$dp1,
     +sbufl$bs,sbufl$s0,3,27,4,2052,3,0,z_b_10,z_b_12,z_b_14,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(sbufl$d1,l$$b9,u$$b9,l$$b10,u$$b10,l$$b11,
     +u$$b11)
# 0 "sp2.hpf"
      redimension sbufl(l$$b9:u$$b9,l$$b10:u$$b10,l$$b11:u$$b11)
# 0 "sp2.hpf"
      call pghpf_qopy_in(rbufr$p,pghpf_0(3),pghpf_0(3),rbufr$dp1,
     +rbufr$bs,rbufr$s0,3,27,4,2052,3,0,z_b_28,z_b_30,z_b_32,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(rbufr$d1,l$$b12,u$$b12,l$$b13,u$$b13,l$$b14,
     +u$$b14)
# 0 "sp2.hpf"
      redimension rbufr(l$$b12:u$$b12,l$$b13:u$$b13,l$$b14:u$$b14)
# 0 "sp2.hpf"
      call pghpf_qopy_in(rbufl$p,pghpf_0(3),pghpf_0(3),rbufl$dp1,
     +rbufl$bs,rbufl$s0,3,27,4,2052,3,0,z_b_22,z_b_24,z_b_26,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(rbufl$d1,l$$b15,u$$b15,l$$b16,u$$b16,l$$b17,
     +u$$b17)
# 0 "sp2.hpf"
      redimension rbufl(l$$b15:u$$b15,l$$b16:u$$b16,l$$b17:u$$b17)
# 0 "sp2.hpf"
      call pghpf_qopy_in(ihole$p,pghpf_0(3),pghpf_0(3),ihole$dp1,
     +ihole$bs,ihole$s0,2,25,4,2052,1,0,z_b_48,z_b_50,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(ihole$d1,l$$b18,u$$b18,l$$b19,u$$b19)
# 0 "sp2.hpf"
      redimension ihole(l$$b18:u$$b18,l$$b19:u$$b19)
# 0 "sp2.hpf"
      call pghpf_qopy_in(jsr$p,pghpf_0(3),pghpf_0(3),jsr$dp1,jsr$bs,
     +jsr$s0,2,25,4,2052,1,0,z_b_40,z_b_42,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(jsr$d1,l$$b20,u$$b20,l$$b21,u$$b21)
# 0 "sp2.hpf"
      redimension jsr(l$$b20:u$$b20,l$$b21:u$$b21)
# 0 "sp2.hpf"
      call pghpf_qopy_in(jsl$p,pghpf_0(3),pghpf_0(3),jsl$dp1,jsl$bs,
     +jsl$s0,2,25,4,2052,1,0,z_b_36,z_b_38,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(jsl$d1,l$$b22,u$$b22,l$$b23,u$$b23)
# 0 "sp2.hpf"
      redimension jsl(l$$b22:u$$b22,l$$b23:u$$b23)
# 0 "sp2.hpf"
      call pghpf_qopy_in(jss$p,pghpf_0(3),pghpf_0(3),jss$dp1,jss$bs,
     +jss$s0,2,25,4,2052,1,0,z_b_44,z_b_46,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(jss$d1,l$$b24,u$$b24,l$$b25,u$$b25)
# 0 "sp2.hpf"
      redimension jss(l$$b24:u$$b24,l$$b25:u$$b25)
# 0 "sp2.hpf"
      call pghpf_qopy_in(isum_0$p,pghpf_0(3),pghpf_0(3),isum_0$dp1,
     +isum_0$bs,isum_0$s0,1,25,4,2052,0,0,z_b_52,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(isum_0$d1,l$$b26,u$$b26)
# 0 "sp2.hpf"
      redimension isum_0(l$$b26:u$$b26)
# 589 "sp2.hpf"
      call pghpf_sums(npp$r,npp,.true.,25,npp$d1,19)
# 589 "sp2.hpf"
      npr = npp$r
# 591 "sp2.hpf"
11    continue
# 591 "sp2.hpf"
      z_b_54 = idimp
# 591 "sp2.hpf"
      z_b_55 = npmax
# 591 "sp2.hpf"
      z_b_56 = nblok
# 591 "sp2.hpf"
      z_b_57 = idimp
# 591 "sp2.hpf"
      z_b_58 = nblok
# 591 "sp2.hpf"
      z_b_59 = nblok
# 591 "sp2.hpf"
      z_b_60 = idimp
# 591 "sp2.hpf"
      z_b_61 = nbmax
# 591 "sp2.hpf"
      z_b_62 = nblok
# 591 "sp2.hpf"
      z_b_63 = idimp
# 591 "sp2.hpf"
      z_b_64 = nbmax
# 591 "sp2.hpf"
      z_b_65 = nblok
# 591 "sp2.hpf"
      z_b_66 = ntmax
# 591 "sp2.hpf"
      z_b_67 = nblok
# 591 "sp2.hpf"
      z_b_68 = idimp
# 591 "sp2.hpf"
      z_b_69 = nblok
# 591 "sp2.hpf"
      z_b_70 = idimp
# 591 "sp2.hpf"
      z_b_71 = nblok
# 591 "sp2.hpf"
      z_b_72 = idimp
# 591 "sp2.hpf"
      z_b_73 = nblok
# 591 "sp2.hpf"
      call pghpf_qopy_in(part$f77$p,pghpf_0(3),pghpf_0(3),part$f77$dp1,
     +part,part$d1,3,27,4,2144,3,0,1,z_b_54,1,z_b_55,1,z_b_56)
# 591 "sp2.hpf"
      call pghpf_qopy_in(edges$f77$p,pghpf_0(3),pghpf_0(3),edges$f77$dp1
     +,edges,edges$d1,2,27,4,2144,1,0,1,z_b_57,1,z_b_58)
# 591 "sp2.hpf"
      call pghpf_qopy_in(npp$f77$p,pghpf_0(3),pghpf_0(3),npp$f77$dp1,npp
     +,npp$d1,1,25,4,2144,0,0,1,z_b_59)
# 591 "sp2.hpf"
      call pghpf_qopy_in(sbufr$f77$p,pghpf_0(3),pghpf_0(3),sbufr$f77$dp1
     +,sbufr,sbufr$d1,3,27,4,2208,3,0,1,z_b_60,1,z_b_61,1,z_b_62)
# 591 "sp2.hpf"
      call pghpf_qopy_in(sbufl$f77$p,pghpf_0(3),pghpf_0(3),sbufl$f77$dp1
     +,sbufl,sbufl$d1,3,27,4,2208,3,0,1,z_b_63,1,z_b_64,1,z_b_65)
# 591 "sp2.hpf"
      call pghpf_qopy_in(ihole$f77$p,pghpf_0(3),pghpf_0(3),ihole$f77$dp1
     +,ihole,ihole$d1,2,25,4,2208,1,0,1,z_b_66,1,z_b_67)
# 591 "sp2.hpf"
      call pghpf_qopy_in(jsr$f77$p,pghpf_0(3),pghpf_0(3),jsr$f77$dp1,jsr
     +,jsr$d1,2,25,4,2080,1,0,1,z_b_68,1,z_b_69)
# 591 "sp2.hpf"
      call pghpf_qopy_in(jsl$f77$p,pghpf_0(3),pghpf_0(3),jsl$f77$dp1,jsl
     +,jsl$d1,2,25,4,2080,1,0,1,z_b_70,1,z_b_71)
# 591 "sp2.hpf"
      call pghpf_qopy_in(jss$f77$p,pghpf_0(3),pghpf_0(3),jss$f77$dp1,jss
     +,jss$d1,2,25,4,2080,1,0,1,z_b_72,1,z_b_73)
# 591 "sp2.hpf"
      call indep_loop_pmove1_1(part$f77,edges$f77,npp$f77,sbufr$f77,
     +sbufl$f77,ihole$f77,jsr$f77,jsl$f77,jss$f77,nx,nvp,nbmax,idimp,
     +npmax,nblok,ntmax)
# 591 "sp2.hpf"
      call pghpf_copy_out(jss,jss$f77,jss$d1,jss$f77$d1,0)
# 591 "sp2.hpf"
      call pghpf_copy_out(jsl,jsl$f77,jsl$d1,jsl$f77$d1,0)
# 591 "sp2.hpf"
      call pghpf_copy_out(jsr,jsr$f77,jsr$d1,jsr$f77$d1,0)
# 591 "sp2.hpf"
      call pghpf_copy_out(ihole,ihole$f77,ihole$d1,ihole$f77$d1,2)
# 591 "sp2.hpf"
      call pghpf_copy_out(sbufl,sbufl$f77,sbufl$d1,sbufl$f77$d1,2)
# 591 "sp2.hpf"
      call pghpf_copy_out(sbufr,sbufr$f77,sbufr$d1,sbufr$f77$d1,2)
# 591 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f77,npp$d1,npp$f77$d1,1)
# 591 "sp2.hpf"
      call pghpf_copy_out(edges,edges$f77,edges$d1,edges$f77$d1,1)
# 591 "sp2.hpf"
      call pghpf_copy_out(part,part$f77,part$d1,part$f77$d1,1)
# 597 "sp2.hpf"
      jss$sp = pghpf_sect(jss$d1,2,2,1,1,z_b_47,1,2)
# 597 "sp2.hpf"
      call pghpf_sums(jss$r,jss,.true.,25,jss$s,19)
# 597 "sp2.hpf"
      call pghpf_free(jss$s)
# 597 "sp2.hpf"
      ibflg = jss$r
# 611 "sp2.hpf"
12    continue
# 611 "sp2.hpf"
      jsl$sp = pghpf_sect(jsl$d1,2,2,1,1,z_b_39,1,2)
# 611 "sp2.hpf"
      jsr$sp = pghpf_sect(jsr$d1,1,1,1,1,z_b_43,1,2)
# 611 "sp2.hpf"
      call pghpf_cshifts(jsl,jsr,-1,1,jsl$s,jsr$s,25,25)
# 611 "sp2.hpf"
      call pghpf_free(jsr$s)
# 611 "sp2.hpf"
      call pghpf_free(jsl$s)
      call pghpf_cshifts(rbufl,sbufr,-1,3,rbufl$d1,sbufr$d1,25,25)
# 620 "sp2.hpf"
      jsr$sp1 = pghpf_sect(jsr$d1,2,2,1,1,z_b_43,1,2)
# 620 "sp2.hpf"
      jsl$sp1 = pghpf_sect(jsl$d1,1,1,1,1,z_b_39,1,2)
# 620 "sp2.hpf"
      call pghpf_cshifts(jsr,jsl,1,1,jsr$s1,jsl$s1,25,25)
# 620 "sp2.hpf"
      call pghpf_free(jsl$s1)
# 620 "sp2.hpf"
      call pghpf_free(jsr$s1)
      call pghpf_cshifts(rbufr,sbufl,1,3,rbufr$d1,sbufl$d1,25,25)
# 621 "sp2.hpf"
      z_b_74 = idimp
# 621 "sp2.hpf"
      z_b_75 = nblok
# 621 "sp2.hpf"
      z_b_76 = idimp
# 621 "sp2.hpf"
      z_b_77 = nbmax
# 621 "sp2.hpf"
      z_b_78 = nblok
# 621 "sp2.hpf"
      z_b_79 = idimp
# 621 "sp2.hpf"
      z_b_80 = nbmax
# 621 "sp2.hpf"
      z_b_81 = nblok
# 621 "sp2.hpf"
      z_b_82 = idimp
# 621 "sp2.hpf"
      z_b_83 = nblok
# 621 "sp2.hpf"
      z_b_84 = idimp
# 621 "sp2.hpf"
      z_b_85 = nblok
# 621 "sp2.hpf"
      z_b_86 = nblok
# 621 "sp2.hpf"
      call pghpf_qopy_in(edges$f771$p,pghpf_0(3),pghpf_0(3),
     +edges$f771$dp1,edges,edges$d1,2,27,4,2144,1,0,1,z_b_74,1,z_b_75)
# 621 "sp2.hpf"
      call pghpf_qopy_in(rbufr$f77$p,pghpf_0(3),pghpf_0(3),rbufr$f77$dp1
     +,rbufr,rbufr$d1,3,27,4,2144,3,0,1,z_b_76,1,z_b_77,1,z_b_78)
# 621 "sp2.hpf"
      call pghpf_qopy_in(rbufl$f77$p,pghpf_0(3),pghpf_0(3),rbufl$f77$dp1
     +,rbufl,rbufl$d1,3,27,4,2144,3,0,1,z_b_79,1,z_b_80,1,z_b_81)
# 621 "sp2.hpf"
      call pghpf_qopy_in(jsr$f771$p,pghpf_0(3),pghpf_0(3),jsr$f771$dp1,
     +jsr,jsr$d1,2,25,4,2080,1,0,1,z_b_82,1,z_b_83)
# 621 "sp2.hpf"
      call pghpf_qopy_in(jsl$f771$p,pghpf_0(3),pghpf_0(3),jsl$f771$dp1,
     +jsl,jsl$d1,2,25,4,2080,1,0,1,z_b_84,1,z_b_85)
# 621 "sp2.hpf"
      call pghpf_qopy_in(isum_0$f77$p,pghpf_0(3),pghpf_0(3),
     +isum_0$f77$dp1,isum_0,isum_0$d1,1,25,4,2208,0,0,1,z_b_86)
# 621 "sp2.hpf"
# 627 "sp2.hpf"
      call indep_loop_pmove1_2(edges$f771,rbufr$f77,rbufl$f77,jsr$f771,
     +jsl$f771,isum_0$f77,idimp,nbmax,nblok)
# 627 "sp2.hpf"
      call pghpf_copy_out(isum_0,isum_0$f77,isum_0$d1,isum_0$f77$d1,2)
# 627 "sp2.hpf"
      call pghpf_copy_out(jsl,jsl$f771,jsl$d1,jsl$f771$d1,0)
# 627 "sp2.hpf"
      call pghpf_copy_out(jsr,jsr$f771,jsr$d1,jsr$f771$d1,0)
# 627 "sp2.hpf"
      call pghpf_copy_out(rbufl,rbufl$f77,rbufl$d1,rbufl$f77$d1,1)
# 627 "sp2.hpf"
      call pghpf_copy_out(rbufr,rbufr$f77,rbufr$d1,rbufr$f77$d1,1)
# 627 "sp2.hpf"
      call pghpf_copy_out(edges,edges$f771,edges$d1,edges$f771$d1,1)
# 629 "sp2.hpf"
      call pghpf_sums(isum_0$r,isum_0,.true.,25,isum_0$d1,19)
# 629 "sp2.hpf"
      npss = isum_0$r
# 632 "sp2.hpf"
      if (npss .eq. 0) goto 150
# 632 "sp2.hpf"
      z_b_87 = idimp
# 632 "sp2.hpf"
      z_b_88 = nblok
# 632 "sp2.hpf"
      z_b_89 = idimp
# 632 "sp2.hpf"
      z_b_90 = nbmax
# 632 "sp2.hpf"
      z_b_91 = nblok
# 632 "sp2.hpf"
      z_b_92 = idimp
# 632 "sp2.hpf"
      z_b_93 = nbmax
# 632 "sp2.hpf"
      z_b_94 = nblok
# 632 "sp2.hpf"
      z_b_95 = idimp
# 632 "sp2.hpf"
      z_b_96 = nbmax
# 632 "sp2.hpf"
      z_b_97 = nblok
# 632 "sp2.hpf"
      z_b_98 = idimp
# 632 "sp2.hpf"
      z_b_99 = nbmax
# 632 "sp2.hpf"
      z_b_100 = nblok
# 632 "sp2.hpf"
      z_b_101 = idimp
# 632 "sp2.hpf"
      z_b_102 = nblok
# 632 "sp2.hpf"
      z_b_103 = idimp
# 632 "sp2.hpf"
      z_b_104 = nblok
# 632 "sp2.hpf"
      z_b_105 = idimp
# 632 "sp2.hpf"
      z_b_106 = nblok
# 632 "sp2.hpf"
      call pghpf_qopy_in(edges$f772$p,pghpf_0(3),pghpf_0(3),
     +edges$f772$dp1,edges,edges$d1,2,27,4,2144,1,0,1,z_b_87,1,z_b_88)
# 632 "sp2.hpf"
      call pghpf_qopy_in(sbufr$f771$p,pghpf_0(3),pghpf_0(3),
     +sbufr$f771$dp1,sbufr,sbufr$d1,3,27,4,2080,3,0,1,z_b_89,1,z_b_90,1,
     +z_b_91)
# 632 "sp2.hpf"
      call pghpf_qopy_in(sbufl$f771$p,pghpf_0(3),pghpf_0(3),
     +sbufl$f771$dp1,sbufl,sbufl$d1,3,27,4,2080,3,0,1,z_b_92,1,z_b_93,1,
     +z_b_94)
# 632 "sp2.hpf"
      call pghpf_qopy_in(rbufr$f771$p,pghpf_0(3),pghpf_0(3),
     +rbufr$f771$dp1,rbufr,rbufr$d1,3,27,4,2080,3,0,1,z_b_95,1,z_b_96,1,
     +z_b_97)
# 632 "sp2.hpf"
      call pghpf_qopy_in(rbufl$f771$p,pghpf_0(3),pghpf_0(3),
     +rbufl$f771$dp1,rbufl,rbufl$d1,3,27,4,2080,3,0,1,z_b_98,1,z_b_99,1,
     +z_b_100)
# 632 "sp2.hpf"
      call pghpf_qopy_in(jsr$f772$p,pghpf_0(3),pghpf_0(3),jsr$f772$dp1,
     +jsr,jsr$d1,2,25,4,2080,1,0,1,z_b_101,1,z_b_102)
# 632 "sp2.hpf"
      call pghpf_qopy_in(jsl$f772$p,pghpf_0(3),pghpf_0(3),jsl$f772$dp1,
     +jsl,jsl$d1,2,25,4,2080,1,0,1,z_b_103,1,z_b_104)
# 632 "sp2.hpf"
      call pghpf_qopy_in(jss$f771$p,pghpf_0(3),pghpf_0(3),jss$f771$dp1,
     +jss,jss$d1,2,25,4,2080,1,0,1,z_b_105,1,z_b_106)
# 632 "sp2.hpf"
# 636 "sp2.hpf"
      call indep_loop_pmove1_3(edges$f772,sbufr$f771,sbufl$f771,
     +rbufr$f771,rbufl$f771,jsr$f772,jsl$f772,jss$f771,nvp,nx,idimp,
     +nbmax,nblok)
# 636 "sp2.hpf"
      call pghpf_copy_out(jss,jss$f771,jss$d1,jss$f771$d1,0)
# 636 "sp2.hpf"
      call pghpf_copy_out(jsl,jsl$f772,jsl$d1,jsl$f772$d1,0)
# 636 "sp2.hpf"
      call pghpf_copy_out(jsr,jsr$f772,jsr$d1,jsr$f772$d1,0)
# 636 "sp2.hpf"
      call pghpf_copy_out(rbufl,rbufl$f771,rbufl$d1,rbufl$f771$d1,0)
# 636 "sp2.hpf"
      call pghpf_copy_out(rbufr,rbufr$f771,rbufr$d1,rbufr$f771$d1,0)
# 636 "sp2.hpf"
      call pghpf_copy_out(sbufl,sbufl$f771,sbufl$d1,sbufl$f771$d1,0)
# 636 "sp2.hpf"
      call pghpf_copy_out(sbufr,sbufr$f771,sbufr$d1,sbufr$f771$d1,0)
# 636 "sp2.hpf"
      call pghpf_copy_out(edges,edges$f772,edges$d1,edges$f772$d1,1)
# 636 "sp2.hpf"
      z_b_107 = idimp
# 636 "sp2.hpf"
      z_b_108 = nblok
# 636 "sp2.hpf"
      z_b_109 = idimp
# 636 "sp2.hpf"
      z_b_110 = nblok
# 636 "sp2.hpf"
      z_b_111 = idimp
# 636 "sp2.hpf"
      z_b_112 = nblok
# 636 "sp2.hpf"
      z_b_113 = nblok
# 636 "sp2.hpf"
      z_b_114 = nblok
# 636 "sp2.hpf"
      call pghpf_qopy_in(jsr$f773$p,pghpf_0(3),pghpf_0(3),jsr$f773$dp1,
     +jsr,jsr$d1,2,25,4,2080,1,0,1,z_b_107,1,z_b_108)
# 636 "sp2.hpf"
      call pghpf_qopy_in(jsl$f773$p,pghpf_0(3),pghpf_0(3),jsl$f773$dp1,
     +jsl,jsl$d1,2,25,4,2080,1,0,1,z_b_109,1,z_b_110)
# 636 "sp2.hpf"
      call pghpf_qopy_in(jss$f772$p,pghpf_0(3),pghpf_0(3),jss$f772$dp1,
     +jss,jss$d1,2,25,4,2080,1,0,1,z_b_111,1,z_b_112)
# 636 "sp2.hpf"
      call pghpf_qopy_in(isum_0$f771$p,pghpf_0(3),pghpf_0(3),
     +isum_0$f771$dp1,isum_0,isum_0$d1,1,25,4,2208,0,0,1,z_b_113)
# 636 "sp2.hpf"
      call pghpf_qopy_in(npp$f771$p,pghpf_0(3),pghpf_0(3),npp$f771$dp1,
     +npp,npp$d1,1,25,4,2144,0,0,1,z_b_114)
# 636 "sp2.hpf"
# 642 "sp2.hpf"
      call indep_loop_pmove1_4(jsr$f773,jsl$f773,jss$f772,npmax,
     +isum_0$f771,npp$f771,idimp,nblok)
# 642 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f771,npp$d1,npp$f771$d1,1)
# 642 "sp2.hpf"
      call pghpf_copy_out(isum_0,isum_0$f771,isum_0$d1,isum_0$f771$d1,2)
# 642 "sp2.hpf"
      call pghpf_copy_out(jss,jss$f772,jss$d1,jss$f772$d1,0)
# 642 "sp2.hpf"
      call pghpf_copy_out(jsl,jsl$f773,jsl$d1,jsl$f773$d1,0)
# 642 "sp2.hpf"
      call pghpf_copy_out(jsr,jsr$f773,jsr$d1,jsr$f773$d1,0)
# 645 "sp2.hpf"
150   continue
# 645 "sp2.hpf"
      call pghpf_sums(isum_0$r1,isum_0,.true.,25,isum_0$d1,19)
# 645 "sp2.hpf"
      ierr = isum_0$r1
# 648 "sp2.hpf"
      if (ierr .gt. 0) then
         call pgf90io_src_info(649,'sp2.hpf')
# 649 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 649 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'particle overflow error, ierr =')
# 649 "sp2.hpf"
         z__io = pgf90io_ldw(25,1,0,ierr)
# 649 "sp2.hpf"
         z__io = pgf90io_ldw_end()
         goto 99999
      endif
# 651 "sp2.hpf"
      z_b_115 = idimp
# 651 "sp2.hpf"
      z_b_116 = npmax
# 651 "sp2.hpf"
      z_b_117 = nblok
# 651 "sp2.hpf"
      z_b_118 = idimp
# 651 "sp2.hpf"
      z_b_119 = nblok
# 651 "sp2.hpf"
      z_b_120 = nblok
# 651 "sp2.hpf"
      z_b_121 = idimp
# 651 "sp2.hpf"
      z_b_122 = nbmax
# 651 "sp2.hpf"
      z_b_123 = nblok
# 651 "sp2.hpf"
      z_b_124 = idimp
# 651 "sp2.hpf"
      z_b_125 = nbmax
# 651 "sp2.hpf"
      z_b_126 = nblok
# 651 "sp2.hpf"
      z_b_127 = ntmax
# 651 "sp2.hpf"
      z_b_128 = nblok
# 651 "sp2.hpf"
      z_b_129 = idimp
# 651 "sp2.hpf"
      z_b_130 = nblok
# 651 "sp2.hpf"
      z_b_131 = idimp
# 651 "sp2.hpf"
      z_b_132 = nblok
# 651 "sp2.hpf"
      z_b_133 = idimp
# 651 "sp2.hpf"
      z_b_134 = nblok
# 651 "sp2.hpf"
      call pghpf_qopy_in(part$f771$p,pghpf_0(3),pghpf_0(3),part$f771$dp1
     +,part,part$d1,3,27,4,2080,3,0,1,z_b_115,1,z_b_116,1,z_b_117)
# 651 "sp2.hpf"
      call pghpf_qopy_in(edges$f773$p,pghpf_0(3),pghpf_0(3),
     +edges$f773$dp1,edges,edges$d1,2,27,4,2144,1,0,1,z_b_118,1,z_b_119)
# 651 "sp2.hpf"
      call pghpf_qopy_in(npp$f772$p,pghpf_0(3),pghpf_0(3),npp$f772$dp1,
     +npp,npp$d1,1,25,4,2080,0,0,1,z_b_120)
# 651 "sp2.hpf"
      call pghpf_qopy_in(rbufr$f772$p,pghpf_0(3),pghpf_0(3),
     +rbufr$f772$dp1,rbufr,rbufr$d1,3,27,4,2144,3,0,1,z_b_121,1,z_b_122,
     +1,z_b_123)
# 651 "sp2.hpf"
      call pghpf_qopy_in(rbufl$f772$p,pghpf_0(3),pghpf_0(3),
     +rbufl$f772$dp1,rbufl,rbufl$d1,3,27,4,2144,3,0,1,z_b_124,1,z_b_125,
     +1,z_b_126)
# 651 "sp2.hpf"
      call pghpf_qopy_in(ihole$f771$p,pghpf_0(3),pghpf_0(3),
     +ihole$f771$dp1,ihole,ihole$d1,2,25,4,2144,1,0,1,z_b_127,1,z_b_128)
# 651 "sp2.hpf"
      call pghpf_qopy_in(jsr$f774$p,pghpf_0(3),pghpf_0(3),jsr$f774$dp1,
     +jsr,jsr$d1,2,25,4,2080,1,0,1,z_b_129,1,z_b_130)
# 651 "sp2.hpf"
      call pghpf_qopy_in(jsl$f774$p,pghpf_0(3),pghpf_0(3),jsl$f774$dp1,
     +jsl,jsl$d1,2,25,4,2080,1,0,1,z_b_131,1,z_b_132)
# 651 "sp2.hpf"
      call pghpf_qopy_in(jss$f773$p,pghpf_0(3),pghpf_0(3),jss$f773$dp1,
     +jss,jss$d1,2,25,4,2080,1,0,1,z_b_133,1,z_b_134)
# 651 "sp2.hpf"
# 656 "sp2.hpf"
      call indep_loop_pmove1_5(part$f771,edges$f773,npp$f772,rbufr$f772,
     +rbufl$f772,ihole$f771,jsr$f774,jsl$f774,jss$f773,idimp,npmax,nblok
     +,nbmax,ntmax)
# 656 "sp2.hpf"
      call pghpf_copy_out(jss,jss$f773,jss$d1,jss$f773$d1,0)
# 656 "sp2.hpf"
      call pghpf_copy_out(jsl,jsl$f774,jsl$d1,jsl$f774$d1,0)
# 656 "sp2.hpf"
      call pghpf_copy_out(jsr,jsr$f774,jsr$d1,jsr$f774$d1,0)
# 656 "sp2.hpf"
      call pghpf_copy_out(ihole,ihole$f771,ihole$d1,ihole$f771$d1,1)
# 656 "sp2.hpf"
      call pghpf_copy_out(rbufl,rbufl$f772,rbufl$d1,rbufl$f772$d1,1)
# 656 "sp2.hpf"
      call pghpf_copy_out(rbufr,rbufr$f772,rbufr$d1,rbufr$f772$d1,1)
# 656 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f772,npp$d1,npp$f772$d1,0)
# 656 "sp2.hpf"
      call pghpf_copy_out(edges,edges$f773,edges$d1,edges$f773$d1,1)
# 656 "sp2.hpf"
      call pghpf_copy_out(part,part$f771,part$d1,part$f771$d1,0)
# 663 "sp2.hpf"
      if (npss .gt. 0) goto 12
# 665 "sp2.hpf"
      if (ibflg .gt. 0) goto 11
# 667 "sp2.hpf"
      call pghpf_sums(npp$r1,npp,.true.,25,npp$d1,19)
# 667 "sp2.hpf"
      npss = npp$r1
      if (npr .ne. npss) then
# 668 "sp2.hpf"
         call pgf90io_src_info(668,'sp2.hpf')
# 668 "sp2.hpf"
         z__io = pgf90io_ldw_init(6,0,0,0)
# 668 "sp2.hpf"
         z__io = pgf90io_ldw(14,1,0,'number error,np-old,np-new=')
# 668 "sp2.hpf"
         z__io = pgf90io_ldw(25,1,0,npr)
# 668 "sp2.hpf"
         z__io = pgf90io_ldw(25,1,0,npss)
# 668 "sp2.hpf"
         z__io = pgf90io_ldw_end()
# 668 "sp2.hpf"
      endif
99999 continue
# 669 "sp2.hpf"
      call pghpf_copy_out(isum_0$bs,isum_0,isum_0$s0,isum_0$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(jss$bs,jss,jss$s0,jss$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(jsl$bs,jsl,jsl$s0,jsl$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(jsr$bs,jsr,jsr$s0,jsr$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(ihole$bs,ihole,ihole$s0,ihole$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(rbufl$bs,rbufl,rbufl$s0,rbufl$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(rbufr$bs,rbufr,rbufr$s0,rbufr$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(sbufl$bs,sbufl,sbufl$s0,sbufl$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(sbufr$bs,sbufr,sbufr$s0,sbufr$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(npp$bs,npp,npp$s0,npp$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(edges$bs,edges,edges$s0,edges$d1,0)
# 669 "sp2.hpf"
      call pghpf_copy_out(part$bs,part,part$s0,part$d1,0)
# 669 "sp2.hpf"
      end
# 674 "sp2.hpf"
      subroutine ifft(f$bs,g$bs,isign,mixup$bs,sct$bs,indx,kxp,kblok,
     +shifted$bs,f$s0,g$s0,isign$s0,mixup$s0,sct$s0,indx$s0,kxp$s0,
     +kblok$s0,shifted$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer f$bs(1), g$bs(1), mixup$bs(1), sct$bs(1), shifted$bs(1), 
     +f$s0(1), g$s0(1), isign$s0(1), mixup$s0(1), sct$s0(1), indx$s0(1)
     +, kxp$s0(1), kblok$s0(1), shifted$s0(1)
      integer mixup(:,:), z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5, 
     +z_b_6, z_b_7, z_b_8, z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, z_b_14
     +, z_b_15, z_b_16, z_b_17, i$i, i$i1, i$i2, i$i3, i$i4, i$i5, i$i6
     +, mixup$f77(:,:), z_b_18, z_b_19, z_b_20, z_b_21, z_b_22, z_b_23, 
     +f$f77$d(1), f$f77$d1(1), g$f77$d(1), g$f77$d1(1), mixup$f77$d(1), 
     +mixup$f77$d1(1), mixup$f771(:,:), z_b_24, z_b_25, z_b_26, z_b_27, 
     +z_b_28, z_b_29, z_b_30, z_b_31, f$f771$d(1), f$f771$d1(1), 
     +g$f771$d(1), g$f771$d1(1), mixup$f771$d(1), mixup$f771$d1(1), 
     +sct$f77$d(1), sct$f77$d1(1), g$s(1), z_b_32, z_b_33, z_b_34, 
     +z_b_35, z_b_36, f$f772$d(1), f$f772$d1(1), g$f772$d(1), g$f772$d1(
     +1), shifted$f77$d(1), shifted$f77$d1(1), shifted$tl$d(1), sct$tl$d
     +(1), mixup$tl$d(1), g$tl$d(1), f$tl$d(1), shifted$d(1), sct$d(1), 
     +mixup$d(1), g$d(1), f$d(1), shifted$d1(1), sct$d1(1), mixup$d1(1)
     +, g$d1(1), f$d1(1), l$$b, u$$b, l$$b1, u$$b1, l$$b2, u$$b2, l$$b3
     +, u$$b3, l$$b4, u$$b4, l$$b5, u$$b5, l$$b6, u$$b6, l$$b7, u$$b7, 
     +l$$b8, u$$b8
      complex f(:,:), g(:,:), sct(:,:), shifted(:), f$f77(:,:), g$f77(:,
     +:), f$f771(:,:), g$f771(:,:), sct$f77(:,:), f$f772(:,:), g$f772(:,
     +:), shifted$f77(:)
      allocatable f, g, mixup, sct, shifted, f$f77, g$f77, mixup$f77, 
     +f$f771, g$f771, mixup$f771, sct$f77, f$f772, g$f772, shifted$f77
      pointer (f$p,f), (g$p,g), (mixup$p,mixup), (sct$p,sct), (shifted$p
     +,shifted), (f$f77$p,f$f77), (g$f77$p,g$f77), (mixup$f77$p,
     +mixup$f77), (f$f77$dp,f$f77$d), (f$f77$dp1,f$f77$d1), (g$f77$dp,
     +g$f77$d), (g$f77$dp1,g$f77$d1), (mixup$f77$dp,mixup$f77$d), (
     +mixup$f77$dp1,mixup$f77$d1), (f$f771$p,f$f771), (g$f771$p,g$f771)
     +, (mixup$f771$p,mixup$f771), (sct$f77$p,sct$f77), (f$f771$dp,
     +f$f771$d), (f$f771$dp1,f$f771$d1), (g$f771$dp,g$f771$d), (
     +g$f771$dp1,g$f771$d1), (mixup$f771$dp,mixup$f771$d), (
     +mixup$f771$dp1,mixup$f771$d1), (sct$f77$dp,sct$f77$d), (
     +sct$f77$dp1,sct$f77$d1), (g$sp,g$s), (f$f772$p,f$f772), (g$f772$p,
     +g$f772), (shifted$f77$p,shifted$f77), (f$f772$dp,f$f772$d), (
     +f$f772$dp1,f$f772$d1), (g$f772$dp,g$f772$d), (g$f772$dp1,g$f772$d1
     +), (shifted$f77$dp,shifted$f77$d), (shifted$f77$dp1,shifted$f77$d1
     +), (shifted$tl$dp,shifted$tl$d), (sct$tl$dp,sct$tl$d), (
     +mixup$tl$dp,mixup$tl$d), (g$tl$dp,g$tl$d), (f$tl$dp,f$tl$d), (
     +shifted$dp,shifted$d), (sct$dp,sct$d), (mixup$dp,mixup$d), (g$dp,
     +g$d), (f$dp,f$d), (shifted$dp1,shifted$d1), (sct$dp1,sct$d1), (
     +mixup$dp1,mixup$d1), (g$dp1,g$d1), (f$dp1,f$d1)
      integer pghpf_extent, pghpf_sect
      external fft, scramble, permute
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(f$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(f$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(g$s0,1)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(g$s0,2)
# 0 "sp2.hpf"
      z_b_14 = 1
# 0 "sp2.hpf"
      z_b_15 = pghpf_extent(mixup$s0,1)
# 0 "sp2.hpf"
      z_b_16 = 1
# 0 "sp2.hpf"
      z_b_17 = pghpf_extent(mixup$s0,2)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(sct$s0,1)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(sct$s0,2)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(shifted$s0,1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(f$p,pghpf_0(3),pghpf_0(3),f$dp1,f$bs,f$s0,2,9,8
     +,2052,1,0,z_b_0,z_b_2,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(f$d1,l$$b,u$$b,l$$b1,u$$b1)
# 0 "sp2.hpf"
      redimension f(l$$b:u$$b,l$$b1:u$$b1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(g$p,pghpf_0(3),pghpf_0(3),g$dp1,g$bs,g$s0,2,9,8
     +,2052,1,0,z_b_4,z_b_6,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(g$d1,l$$b2,u$$b2,l$$b3,u$$b3)
# 0 "sp2.hpf"
      redimension g(l$$b2:u$$b2,l$$b3:u$$b3)
# 0 "sp2.hpf"
      call pghpf_qopy_in(mixup$p,pghpf_0(3),pghpf_0(3),mixup$dp1,
     +mixup$bs,mixup$s0,2,25,4,2052,1,0,z_b_14,z_b_16,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(mixup$d1,l$$b4,u$$b4,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension mixup(l$$b4:u$$b4,l$$b5:u$$b5)
# 0 "sp2.hpf"
      call pghpf_qopy_in(sct$p,pghpf_0(3),pghpf_0(3),sct$dp1,sct$bs,
     +sct$s0,2,9,8,2052,1,0,z_b_8,z_b_10,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(sct$d1,l$$b6,u$$b6,l$$b7,u$$b7)
# 0 "sp2.hpf"
      redimension sct(l$$b6:u$$b6,l$$b7:u$$b7)
# 0 "sp2.hpf"
      call pghpf_qopy_in(shifted$p,pghpf_0(3),pghpf_0(3),shifted$dp1,
     +shifted$bs,shifted$s0,1,9,8,2052,0,0,z_b_12,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(shifted$d1,l$$b8,u$$b8)
# 0 "sp2.hpf"
      redimension shifted(l$$b8:u$$b8)
# 0 "sp2.hpf"
      z_b_18 = kxp
# 0 "sp2.hpf"
      z_b_19 = kblok
# 0 "sp2.hpf"
      z_b_20 = kxp
# 0 "sp2.hpf"
      z_b_21 = kblok
# 0 "sp2.hpf"
      z_b_22 = kxp
# 0 "sp2.hpf"
      z_b_23 = kblok
# 0 "sp2.hpf"
      call pghpf_qopy_in(f$f77$p,pghpf_0(3),pghpf_0(3),f$f77$dp1,f,f$d1,
     +2,9,8,2080,1,0,1,z_b_18,1,z_b_19)
# 0 "sp2.hpf"
      call pghpf_qopy_in(g$f77$p,pghpf_0(3),pghpf_0(3),g$f77$dp1,g,g$d1,
     +2,9,8,2080,1,0,1,z_b_20,1,z_b_21)
# 0 "sp2.hpf"
      call pghpf_qopy_in(mixup$f77$p,pghpf_0(3),pghpf_0(3),mixup$f77$dp1
     +,mixup,mixup$d1,2,25,4,2080,1,0,1,z_b_22,1,z_b_23)
# 0 "sp2.hpf"
# 714 "sp2.hpf"
      call permute(f$f77,g$f77,mixup$f77,indx,kxp,kblok)
# 714 "sp2.hpf"
      call pghpf_copy_out(mixup,mixup$f77,mixup$d1,mixup$f77$d1,0)
# 714 "sp2.hpf"
      call pghpf_copy_out(g,g$f77,g$d1,g$f77$d1,0)
# 714 "sp2.hpf"
      call pghpf_copy_out(f,f$f77,f$d1,f$f77$d1,0)
# 714 "sp2.hpf"
      z_b_24 = kxp
# 714 "sp2.hpf"
      z_b_25 = kblok
# 714 "sp2.hpf"
      z_b_26 = kxp
# 714 "sp2.hpf"
      z_b_27 = kblok
# 714 "sp2.hpf"
      z_b_28 = kxp
# 714 "sp2.hpf"
      z_b_29 = kblok
# 714 "sp2.hpf"
      z_b_30 = kxp
# 714 "sp2.hpf"
      z_b_31 = kblok
# 714 "sp2.hpf"
      call pghpf_qopy_in(f$f771$p,pghpf_0(3),pghpf_0(3),f$f771$dp1,f,
     +f$d1,2,9,8,2080,1,0,1,z_b_24,1,z_b_25)
# 714 "sp2.hpf"
      call pghpf_qopy_in(g$f771$p,pghpf_0(3),pghpf_0(3),g$f771$dp1,g,
     +g$d1,2,9,8,2080,1,0,1,z_b_26,1,z_b_27)
# 714 "sp2.hpf"
      call pghpf_qopy_in(mixup$f771$p,pghpf_0(3),pghpf_0(3),
     +mixup$f771$dp1,mixup,mixup$d1,2,25,4,2144,1,0,1,z_b_28,1,z_b_29)
# 714 "sp2.hpf"
      call pghpf_qopy_in(sct$f77$p,pghpf_0(3),pghpf_0(3),sct$f77$dp1,sct
     +,sct$d1,2,9,8,2080,1,0,1,z_b_30,1,z_b_31)
# 714 "sp2.hpf"
# 715 "sp2.hpf"
      call fft(f$f771,g$f771,isign,mixup$f771,sct$f77,indx,kxp,kblok)
# 715 "sp2.hpf"
      call pghpf_copy_out(sct,sct$f77,sct$d1,sct$f77$d1,0)
# 715 "sp2.hpf"
      call pghpf_copy_out(mixup,mixup$f771,mixup$d1,mixup$f771$d1,1)
# 715 "sp2.hpf"
      call pghpf_copy_out(g,g$f771,g$d1,g$f771$d1,0)
# 715 "sp2.hpf"
      call pghpf_copy_out(f,f$f771,f$d1,f$f771$d1,0)
      g$sp = pghpf_sect(g$d1,1,1,1,1,z_b_7,1,2)
# 716 "sp2.hpf"
      call pghpf_cshifts(shifted,g,1,1,shifted$d1,g$s,25,25)
# 716 "sp2.hpf"
      call pghpf_free(g$s)
# 716 "sp2.hpf"
      z_b_32 = kxp
# 716 "sp2.hpf"
      z_b_33 = kblok
# 716 "sp2.hpf"
      z_b_34 = kxp
# 716 "sp2.hpf"
      z_b_35 = kblok
# 716 "sp2.hpf"
      z_b_36 = kblok
# 716 "sp2.hpf"
      call pghpf_qopy_in(f$f772$p,pghpf_0(3),pghpf_0(3),f$f772$dp1,f,
     +f$d1,2,9,8,2080,1,0,1,z_b_32,1,z_b_33)
# 716 "sp2.hpf"
      call pghpf_qopy_in(g$f772$p,pghpf_0(3),pghpf_0(3),g$f772$dp1,g,
     +g$d1,2,9,8,2080,1,0,1,z_b_34,1,z_b_35)
# 716 "sp2.hpf"
      call pghpf_qopy_in(shifted$f77$p,pghpf_0(3),pghpf_0(3),
     +shifted$f77$dp1,shifted,shifted$d1,1,9,8,2144,0,0,1,z_b_36)
# 716 "sp2.hpf"
# 717 "sp2.hpf"
      call scramble(f$f772,g$f772,isign,indx,kxp,kblok,shifted$f77)
# 717 "sp2.hpf"
      call pghpf_copy_out(shifted,shifted$f77,shifted$d1,shifted$f77$d1,
     +1)
# 717 "sp2.hpf"
      call pghpf_copy_out(g,g$f772,g$d1,g$f772$d1,0)
# 717 "sp2.hpf"
      call pghpf_copy_out(f,f$f772,f$d1,f$f772$d1,0)
# 719 "sp2.hpf"
      goto 99999
99999 continue
# 720 "sp2.hpf"
      call pghpf_copy_out(shifted$bs,shifted,shifted$s0,shifted$d1,0)
# 720 "sp2.hpf"
      call pghpf_copy_out(sct$bs,sct,sct$s0,sct$d1,0)
# 720 "sp2.hpf"
      call pghpf_copy_out(mixup$bs,mixup,mixup$s0,mixup$d1,0)
# 720 "sp2.hpf"
      call pghpf_copy_out(g$bs,g,g$s0,g$d1,0)
# 720 "sp2.hpf"
      call pghpf_copy_out(f$bs,f,f$s0,f$d1,0)
# 720 "sp2.hpf"
      end
# 723 "sp2.hpf"
      subroutine dfft(f$bs,g$bs,isign,mixup$bs,sct$bs,indx,kxp,kblok,
     +shifted$bs,f$s0,g$s0,isign$s0,mixup$s0,sct$s0,indx$s0,kxp$s0,
     +kblok$s0,shifted$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer f$bs(1), g$bs(1), mixup$bs(1), sct$bs(1), shifted$bs(1), 
     +f$s0(1), g$s0(1), isign$s0(1), mixup$s0(1), sct$s0(1), indx$s0(1)
     +, kxp$s0(1), kblok$s0(1), shifted$s0(1)
      integer mixup(:,:), z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5, 
     +z_b_6, z_b_7, z_b_8, z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, z_b_14
     +, z_b_15, z_b_16, z_b_17, z_b_18, z_b_19, z_b_20, z_b_21, z_b_22, 
     +z_b_23, z_b_24, z_b_25, z_b_26, z_b_27, z_b_28, z_b_29, z_b_30, 
     +z_b_31, z_b_32, z_b_33, z_b_34, z_b_35, z_b_36, z_b_37, z_b_38, 
     +z_b_39, z_b_40, z_b_41, z_b_42, z_b_43, i$i, i$i1, i$i2, i$i3, 
     +i$i4, i$i5, i$i6, g$s(1), f$f77$d(1), f$f77$d1(1), g$f77$d(1), 
     +g$f77$d1(1), shifted$f77$d(1), shifted$f77$d1(1), mixup$f77(:,:), 
     +z_b_44, z_b_45, z_b_46, z_b_47, z_b_48, z_b_49, f$f771$d(1), 
     +f$f771$d1(1), g$f771$d(1), g$f771$d1(1), mixup$f77$d(1), 
     +mixup$f77$d1(1), mixup$f771(:,:), f$f772$d(1), f$f772$d1(1), 
     +g$f772$d(1), g$f772$d1(1), mixup$f771$d(1), mixup$f771$d1(1), 
     +sct$f77$d(1), sct$f77$d1(1), shifted$tl$d(1), sct$tl$d(1), 
     +mixup$tl$d(1), g$tl$d(1), f$tl$d(1), shifted$d(1), sct$d(1), 
     +mixup$d(1), g$d(1), f$d(1), shifted$d1(1), sct$d1(1), mixup$d1(1)
     +, g$d1(1), f$d1(1), l$$b, u$$b, l$$b1, u$$b1, l$$b2, u$$b2, l$$b3
     +, u$$b3, l$$b4, u$$b4, l$$b5, u$$b5, l$$b6, u$$b6, l$$b7, u$$b7, 
     +l$$b8, u$$b8
      complex f(:,:), g(:,:), sct(:,:), shifted(:), f$f77(:,:), g$f77(:,
     +:), shifted$f77(:), f$f771(:,:), g$f771(:,:), f$f772(:,:), g$f772(
     +:,:), sct$f77(:,:)
      allocatable f, g, mixup, sct, shifted, f$f77, g$f77, shifted$f77, 
     +f$f771, g$f771, mixup$f77, f$f772, g$f772, mixup$f771, sct$f77
      pointer (f$p,f), (g$p,g), (mixup$p,mixup), (sct$p,sct), (shifted$p
     +,shifted), (g$sp,g$s), (f$f77$p,f$f77), (g$f77$p,g$f77), (
     +shifted$f77$p,shifted$f77), (f$f77$dp,f$f77$d), (f$f77$dp1,
     +f$f77$d1), (g$f77$dp,g$f77$d), (g$f77$dp1,g$f77$d1), (
     +shifted$f77$dp,shifted$f77$d), (shifted$f77$dp1,shifted$f77$d1), (
     +f$f771$p,f$f771), (g$f771$p,g$f771), (mixup$f77$p,mixup$f77), (
     +f$f771$dp,f$f771$d), (f$f771$dp1,f$f771$d1), (g$f771$dp,g$f771$d)
     +, (g$f771$dp1,g$f771$d1), (mixup$f77$dp,mixup$f77$d), (
     +mixup$f77$dp1,mixup$f77$d1), (f$f772$p,f$f772), (g$f772$p,g$f772)
     +, (mixup$f771$p,mixup$f771), (sct$f77$p,sct$f77), (f$f772$dp,
     +f$f772$d), (f$f772$dp1,f$f772$d1), (g$f772$dp,g$f772$d), (
     +g$f772$dp1,g$f772$d1), (mixup$f771$dp,mixup$f771$d), (
     +mixup$f771$dp1,mixup$f771$d1), (sct$f77$dp,sct$f77$d), (
     +sct$f77$dp1,sct$f77$d1), (shifted$tl$dp,shifted$tl$d), (sct$tl$dp,
     +sct$tl$d), (mixup$tl$dp,mixup$tl$d), (g$tl$dp,g$tl$d), (f$tl$dp,
     +f$tl$d), (shifted$dp,shifted$d), (sct$dp,sct$d), (mixup$dp,mixup$d
     +), (g$dp,g$d), (f$dp,f$d), (shifted$dp1,shifted$d1), (sct$dp1,
     +sct$d1), (mixup$dp1,mixup$d1), (g$dp1,g$d1), (f$dp1,f$d1)
      integer pghpf_extent, pghpf_sect
      external fft, scramble, permute
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(f$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(f$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(g$s0,1)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(g$s0,2)
# 0 "sp2.hpf"
      z_b_14 = 1
# 0 "sp2.hpf"
      z_b_15 = pghpf_extent(mixup$s0,1)
# 0 "sp2.hpf"
      z_b_16 = 1
# 0 "sp2.hpf"
      z_b_17 = pghpf_extent(mixup$s0,2)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(sct$s0,1)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(sct$s0,2)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(shifted$s0,1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(f$p,pghpf_0(3),pghpf_0(3),f$dp1,f$bs,f$s0,2,9,8
     +,2052,1,0,z_b_0,z_b_2,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(f$d1,l$$b,u$$b,l$$b1,u$$b1)
# 0 "sp2.hpf"
      redimension f(l$$b:u$$b,l$$b1:u$$b1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(g$p,pghpf_0(3),pghpf_0(3),g$dp1,g$bs,g$s0,2,9,8
     +,2052,1,0,z_b_4,z_b_6,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(g$d1,l$$b2,u$$b2,l$$b3,u$$b3)
# 0 "sp2.hpf"
      redimension g(l$$b2:u$$b2,l$$b3:u$$b3)
# 0 "sp2.hpf"
      call pghpf_qopy_in(mixup$p,pghpf_0(3),pghpf_0(3),mixup$dp1,
     +mixup$bs,mixup$s0,2,25,4,2052,1,0,z_b_14,z_b_16,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(mixup$d1,l$$b4,u$$b4,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension mixup(l$$b4:u$$b4,l$$b5:u$$b5)
# 0 "sp2.hpf"
      call pghpf_qopy_in(sct$p,pghpf_0(3),pghpf_0(3),sct$dp1,sct$bs,
     +sct$s0,2,9,8,2052,1,0,z_b_8,z_b_10,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(sct$d1,l$$b6,u$$b6,l$$b7,u$$b7)
# 0 "sp2.hpf"
      redimension sct(l$$b6:u$$b6,l$$b7:u$$b7)
# 0 "sp2.hpf"
      call pghpf_qopy_in(shifted$p,pghpf_0(3),pghpf_0(3),shifted$dp1,
     +shifted$bs,shifted$s0,1,9,8,2052,0,0,z_b_12,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(shifted$d1,l$$b8,u$$b8)
# 0 "sp2.hpf"
      redimension shifted(l$$b8:u$$b8)
# 763 "sp2.hpf"
      g$sp = pghpf_sect(g$d1,1,1,1,1,z_b_7,1,2)
# 763 "sp2.hpf"
      call pghpf_cshifts(shifted,g,1,1,shifted$d1,g$s,25,25)
# 763 "sp2.hpf"
      call pghpf_free(g$s)
# 763 "sp2.hpf"
      z_b_34 = 1
# 763 "sp2.hpf"
      z_b_35 = pghpf_extent(f$d1,1)
# 763 "sp2.hpf"
      z_b_36 = 1
# 763 "sp2.hpf"
      z_b_37 = pghpf_extent(f$d1,2)
# 763 "sp2.hpf"
      z_b_38 = 1
# 763 "sp2.hpf"
      z_b_39 = pghpf_extent(g$d1,1)
# 763 "sp2.hpf"
      z_b_40 = 1
# 763 "sp2.hpf"
      z_b_41 = pghpf_extent(g$d1,2)
# 763 "sp2.hpf"
      z_b_42 = 1
# 763 "sp2.hpf"
      z_b_43 = pghpf_extent(shifted$d1,1)
# 763 "sp2.hpf"
      call pghpf_qopy_in(f$f77$p,pghpf_0(3),pghpf_0(3),f$f77$dp1,f,f$d1,
     +2,9,8,2084,1,0,z_b_34,z_b_36)
# 763 "sp2.hpf"
      call pghpf_qopy_in(g$f77$p,pghpf_0(3),pghpf_0(3),g$f77$dp1,g,g$d1,
     +2,9,8,2084,1,0,z_b_38,z_b_40)
# 763 "sp2.hpf"
      call pghpf_qopy_in(shifted$f77$p,pghpf_0(3),pghpf_0(3),
     +shifted$f77$dp1,shifted,shifted$d1,1,9,8,2148,0,0,z_b_42)
# 763 "sp2.hpf"
# 764 "sp2.hpf"
      call scramble(f$f77,g$f77,isign,indx,kxp,kblok,shifted$f77)
# 764 "sp2.hpf"
      call pghpf_copy_out(shifted,shifted$f77,shifted$d1,shifted$f77$d1,
     +1)
# 764 "sp2.hpf"
      call pghpf_copy_out(g,g$f77,g$d1,g$f77$d1,0)
# 764 "sp2.hpf"
      call pghpf_copy_out(f,f$f77,f$d1,f$f77$d1,0)
# 764 "sp2.hpf"
      z_b_44 = kxp
# 764 "sp2.hpf"
      z_b_45 = kblok
# 764 "sp2.hpf"
      z_b_46 = kxp
# 764 "sp2.hpf"
      z_b_47 = kblok
# 764 "sp2.hpf"
      z_b_48 = kxp
# 764 "sp2.hpf"
      z_b_49 = kblok
# 764 "sp2.hpf"
      call pghpf_qopy_in(f$f771$p,pghpf_0(3),pghpf_0(3),f$f771$dp1,f,
     +f$d1,2,9,8,2080,1,0,1,z_b_44,1,z_b_45)
# 764 "sp2.hpf"
      call pghpf_qopy_in(g$f771$p,pghpf_0(3),pghpf_0(3),g$f771$dp1,g,
     +g$d1,2,9,8,2080,1,0,1,z_b_46,1,z_b_47)
# 764 "sp2.hpf"
      call pghpf_qopy_in(mixup$f77$p,pghpf_0(3),pghpf_0(3),mixup$f77$dp1
     +,mixup,mixup$d1,2,25,4,2080,1,0,1,z_b_48,1,z_b_49)
# 764 "sp2.hpf"
# 765 "sp2.hpf"
      call permute(f$f771,g$f771,mixup$f77,indx,kxp,kblok)
# 765 "sp2.hpf"
      call pghpf_copy_out(mixup,mixup$f77,mixup$d1,mixup$f77$d1,0)
# 765 "sp2.hpf"
      call pghpf_copy_out(g,g$f771,g$d1,g$f771$d1,0)
# 765 "sp2.hpf"
      call pghpf_copy_out(f,f$f771,f$d1,f$f771$d1,0)
# 765 "sp2.hpf"
      z_b_22 = 1
# 765 "sp2.hpf"
      z_b_23 = pghpf_extent(f$d1,1)
# 765 "sp2.hpf"
      z_b_24 = 1
# 765 "sp2.hpf"
      z_b_25 = pghpf_extent(f$d1,2)
# 765 "sp2.hpf"
      z_b_18 = 1
# 765 "sp2.hpf"
      z_b_19 = pghpf_extent(g$d1,1)
# 765 "sp2.hpf"
      z_b_20 = 1
# 765 "sp2.hpf"
      z_b_21 = pghpf_extent(g$d1,2)
# 765 "sp2.hpf"
      z_b_30 = 1
# 765 "sp2.hpf"
      z_b_31 = pghpf_extent(mixup$d1,1)
# 765 "sp2.hpf"
      z_b_32 = 1
# 765 "sp2.hpf"
      z_b_33 = pghpf_extent(mixup$d1,2)
# 765 "sp2.hpf"
      z_b_26 = 1
# 765 "sp2.hpf"
      z_b_27 = pghpf_extent(sct$d1,1)
# 765 "sp2.hpf"
      z_b_28 = 1
# 765 "sp2.hpf"
      z_b_29 = pghpf_extent(sct$d1,2)
# 765 "sp2.hpf"
      call pghpf_qopy_in(f$f772$p,pghpf_0(3),pghpf_0(3),f$f772$dp1,f,
     +f$d1,2,9,8,2084,1,0,z_b_22,z_b_24)
# 765 "sp2.hpf"
      call pghpf_qopy_in(g$f772$p,pghpf_0(3),pghpf_0(3),g$f772$dp1,g,
     +g$d1,2,9,8,2084,1,0,z_b_18,z_b_20)
# 765 "sp2.hpf"
      call pghpf_qopy_in(mixup$f771$p,pghpf_0(3),pghpf_0(3),
     +mixup$f771$dp1,mixup,mixup$d1,2,25,4,2148,1,0,z_b_30,z_b_32)
# 765 "sp2.hpf"
      call pghpf_qopy_in(sct$f77$p,pghpf_0(3),pghpf_0(3),sct$f77$dp1,sct
     +,sct$d1,2,9,8,2084,1,0,z_b_26,z_b_28)
# 765 "sp2.hpf"
# 766 "sp2.hpf"
      call fft(f$f772,g$f772,isign,mixup$f771,sct$f77,indx,kxp,kblok)
# 766 "sp2.hpf"
      call pghpf_copy_out(sct,sct$f77,sct$d1,sct$f77$d1,0)
# 766 "sp2.hpf"
      call pghpf_copy_out(mixup,mixup$f771,mixup$d1,mixup$f771$d1,1)
# 766 "sp2.hpf"
      call pghpf_copy_out(g,g$f772,g$d1,g$f772$d1,0)
# 766 "sp2.hpf"
      call pghpf_copy_out(f,f$f772,f$d1,f$f772$d1,0)
      goto 99999
99999 continue
# 768 "sp2.hpf"
      call pghpf_copy_out(shifted$bs,shifted,shifted$s0,shifted$d1,0)
# 768 "sp2.hpf"
      call pghpf_copy_out(sct$bs,sct,sct$s0,sct$d1,0)
# 768 "sp2.hpf"
      call pghpf_copy_out(mixup$bs,mixup,mixup$s0,mixup$d1,0)
# 768 "sp2.hpf"
      call pghpf_copy_out(g$bs,g,g$s0,g$d1,0)
# 768 "sp2.hpf"
      call pghpf_copy_out(f$bs,f,f$s0,f$d1,0)
# 768 "sp2.hpf"
      end
# 780 "sp2.hpf"
      subroutine ppush1(part$bs,fx$bs,npp$bs,noff$bs,qtme,dt,ek,idimp,
     +npmax,nblok,nxpmx,sum_0$bs,edges$bs,nx,part$s0,fx$s0,npp$s0,
     +noff$s0,qtme$s0,dt$s0,ek$s0,idimp$s0,npmax$s0,nblok$s0,nxpmx$s0,
     +sum_0$s0,edges$s0,nx$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer nblok, nxpmx
      integer part$bs(1), fx$bs(1), npp$bs(1), noff$bs(1), sum_0$bs(1), 
     +edges$bs(1), part$s0(1), fx$s0(1), npp$s0(1), noff$s0(1), qtme$s0(
     +1), dt$s0(1), ek$s0(1), idimp$s0(1), npmax$s0(1), nblok$s0(1), 
     +nxpmx$s0(1), sum_0$s0(1), edges$s0(1), nx$s0(1)
      integer npp(:), noff(:), z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5
     +, z_b_6, z_b_7, z_b_8, z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, 
     +z_b_14, z_b_15, z_b_16, z_b_17, z_b_18, z_b_19, z_e_54, z_e_55, 
     +z_b_20, z_b_21, z_b_22, z_b_23, z_b_24, z_b_25, z_b_26, z_b_27, 
     +z_b_28, z_b_29, z_b_30, z_b_31, z_b_32, z_b_33, z_b_34, z_b_35, 
     +z_b_36, z_b_37, z_b_38, z_b_39, z_b_40, z_b_41, z_b_42, z_b_43, 
     +z_b_44, z_b_45, z_b_46, z_b_47, z__io, i$i, i$i1, i$i2, i$i3, i$i4
     +, i$i5, i$i6, fx$f77$d(1), fx$f77$d1(1), global_fx$f77$d(1), 
     +global_fx$f77$d1(1), npp$f77(:), noff$f77(:), part$f77$d(1), 
     +part$f77$d1(1), fx$f771$d(1), fx$f771$d1(1), npp$f77$d(1), 
     +npp$f77$d1(1), noff$f77$d(1), noff$f77$d1(1), sum_0$f77$d(1), 
     +sum_0$f77$d1(1), edges$f77$d(1), edges$f77$d1(1), edges$tl$d(1), 
     +sum_0$tl$d(1), noff$tl$d(1), npp$tl$d(1), fx$tl$d(1), part$tl$d(1)
     +, global_fx$d(1), edges$d(1), sum_0$d(1), noff$d(1), npp$d(1), 
     +fx$d(1), part$d(1), global_fx$d1(1), edges$d1(1), sum_0$d1(1), 
     +noff$d1(1), npp$d1(1), fx$d1(1), part$d1(1), l$$b, u$$b, l$$b1, 
     +u$$b1, l$$b2, u$$b2, l$$b3, u$$b3, l$$b4, u$$b4, l$$b5, u$$b5, 
     +l$$b6, u$$b6, l$$b7, u$$b7, l$$b8, u$$b8, l$$b9, u$$b9
      real part(:,:,:), fx(:,:), sum_0(:), edges(:,:), sum_0$r, fx$f77(:
     +,:), part$f77(:,:,:), sum_0$f77(:), edges$f77(:,:)
      dimension global_fx(:,:)
      allocatable part, fx, npp, noff, sum_0, edges, fx$f77, part$f77, 
     +npp$f77, noff$f77, sum_0$f77, edges$f77
      pointer (part$p,part), (fx$p,fx), (npp$p,npp), (noff$p,noff), (
     +sum_0$p,sum_0), (edges$p,edges), (fx$f77$p,fx$f77), (fx$f77$dp,
     +fx$f77$d), (fx$f77$dp1,fx$f77$d1), (global_fx$f77$dp,
     +global_fx$f77$d), (global_fx$f77$dp1,global_fx$f77$d1), (
     +part$f77$p,part$f77), (npp$f77$p,npp$f77), (noff$f77$p,noff$f77), 
     +(sum_0$f77$p,sum_0$f77), (edges$f77$p,edges$f77), (part$f77$dp,
     +part$f77$d), (part$f77$dp1,part$f77$d1), (fx$f771$dp,fx$f771$d), (
     +fx$f771$dp1,fx$f771$d1), (npp$f77$dp,npp$f77$d), (npp$f77$dp1,
     +npp$f77$d1), (noff$f77$dp,noff$f77$d), (noff$f77$dp1,noff$f77$d1)
     +, (sum_0$f77$dp,sum_0$f77$d), (sum_0$f77$dp1,sum_0$f77$d1), (
     +edges$f77$dp,edges$f77$d), (edges$f77$dp1,edges$f77$d1), (
     +edges$tl$dp,edges$tl$d), (sum_0$tl$dp,sum_0$tl$d), (noff$tl$dp,
     +noff$tl$d), (npp$tl$dp,npp$tl$d), (fx$tl$dp,fx$tl$d), (part$tl$dp,
     +part$tl$d), (global_fx$dp,global_fx$d), (edges$dp,edges$d), (
     +sum_0$dp,sum_0$d), (noff$dp,noff$d), (npp$dp,npp$d), (fx$dp,fx$d)
     +, (part$dp,part$d), (global_fx$dp1,global_fx$d1), (edges$dp1,
     +edges$d1), (sum_0$dp1,sum_0$d1), (noff$dp1,noff$d1), (npp$dp1,
     +npp$d1), (fx$dp1,fx$d1), (part$dp1,part$d1)
      integer pgf90io_ldw_init, pgf90io_ldw, pgf90io_ldw_end, 
     +pghpf_extent
      external indep_loop_ppush1, all_to_all_fx
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(part$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(part$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(part$s0,3)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(fx$s0,1)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(fx$s0,2)
# 0 "sp2.hpf"
      z_b_16 = 1
# 0 "sp2.hpf"
      z_b_17 = pghpf_extent(npp$s0,1)
# 0 "sp2.hpf"
      z_b_18 = 1
# 0 "sp2.hpf"
      z_b_19 = pghpf_extent(noff$s0,1)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(sum_0$s0,1)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(edges$s0,1)
# 0 "sp2.hpf"
      z_b_14 = 1
# 0 "sp2.hpf"
      z_b_15 = pghpf_extent(edges$s0,2)
# 0 "sp2.hpf"
      z_e_54 = nxpmx
# 0 "sp2.hpf"
      z_e_55 = nblok
# 0 "sp2.hpf"
      call pghpf_qopy_in(part$p,pghpf_0(3),pghpf_0(3),part$dp1,part$bs,
     +part$s0,3,27,4,2052,3,0,z_b_0,z_b_2,z_b_4,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(part$d1,l$$b,u$$b,l$$b1,u$$b1,l$$b2,u$$b2)
# 0 "sp2.hpf"
      redimension part(l$$b:u$$b,l$$b1:u$$b1,l$$b2:u$$b2)
# 0 "sp2.hpf"
      call pghpf_qopy_in(fx$p,pghpf_0(3),pghpf_0(3),fx$dp1,fx$bs,fx$s0,2
     +,27,4,2052,1,0,z_b_6,z_b_8,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(fx$d1,l$$b3,u$$b3,l$$b4,u$$b4)
# 0 "sp2.hpf"
      redimension fx(l$$b3:u$$b3,l$$b4:u$$b4)
# 0 "sp2.hpf"
      call pghpf_qopy_in(npp$p,pghpf_0(3),pghpf_0(3),npp$dp1,npp$bs,
     +npp$s0,1,25,4,2052,0,0,z_b_16,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(npp$d1,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension npp(l$$b5:u$$b5)
# 0 "sp2.hpf"
      call pghpf_qopy_in(noff$p,pghpf_0(3),pghpf_0(3),noff$dp1,noff$bs,
     +noff$s0,1,25,4,2052,0,0,z_b_18,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(noff$d1,l$$b6,u$$b6)
# 0 "sp2.hpf"
      redimension noff(l$$b6:u$$b6)
# 0 "sp2.hpf"
      call pghpf_qopy_in(sum_0$p,pghpf_0(3),pghpf_0(3),sum_0$dp1,
     +sum_0$bs,sum_0$s0,1,27,4,2052,0,0,z_b_10,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(sum_0$d1,l$$b7,u$$b7)
# 0 "sp2.hpf"
      redimension sum_0(l$$b7:u$$b7)
# 0 "sp2.hpf"
      call pghpf_qopy_in(edges$p,pghpf_0(3),pghpf_0(3),edges$dp1,
     +edges$bs,edges$s0,2,27,4,2052,1,0,z_b_12,z_b_14,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(edges$d1,l$$b8,u$$b8,l$$b9,u$$b9)
# 0 "sp2.hpf"
      redimension edges(l$$b8:u$$b8,l$$b9:u$$b9)
# 0 "sp2.hpf"
      call pghpf_template(global_fx$dp,2,0,1,z_e_54,1,z_e_55)
# 0 "sp2.hpf"
      call pghpf_instance(global_fx$dp1,global_fx$d,27,4,0,0,0,0,0)
# 0 "sp2.hpf"
      allocate(global_fx(1:z_e_54,1:z_e_55))
# 0 "sp2.hpf"
      z_b_40 = 1
# 0 "sp2.hpf"
      z_b_41 = pghpf_extent(fx$d1,1)
# 0 "sp2.hpf"
      z_b_42 = 1
# 0 "sp2.hpf"
      z_b_43 = pghpf_extent(fx$d1,2)
# 0 "sp2.hpf"
      z_b_44 = 1
# 0 "sp2.hpf"
      z_b_45 = pghpf_extent(global_fx$d1,1)
# 0 "sp2.hpf"
      z_b_46 = 1
# 0 "sp2.hpf"
      z_b_47 = pghpf_extent(global_fx$d1,2)
# 0 "sp2.hpf"
      call pghpf_qopy_in(fx$f77$p,pghpf_0(3),pghpf_0(3),fx$f77$dp1,fx,
     +fx$d1,2,27,4,2148,1,0,z_b_40,z_b_42)
# 0 "sp2.hpf"
# 818 "sp2.hpf"
      call all_to_all_fx(fx$f77,global_fx,nxpmx,nblok)
# 818 "sp2.hpf"
      call pghpf_copy_out(fx,fx$f77,fx$d1,fx$f77$d1,1)
      call pgf90io_src_info(819,'sp2.hpf')
# 819 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 819 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after first part')
# 819 "sp2.hpf"
      z__io = pgf90io_ldw_end()
# 819 "sp2.hpf"
      z_b_20 = 1
# 819 "sp2.hpf"
      z_b_21 = pghpf_extent(part$d1,1)
# 819 "sp2.hpf"
      z_b_22 = 1
# 819 "sp2.hpf"
      z_b_23 = pghpf_extent(part$d1,2)
# 819 "sp2.hpf"
      z_b_24 = 1
# 819 "sp2.hpf"
      z_b_25 = pghpf_extent(part$d1,3)
# 819 "sp2.hpf"
      z_b_34 = 1
# 819 "sp2.hpf"
      z_b_35 = pghpf_extent(global_fx$d1,1)
# 819 "sp2.hpf"
      z_b_36 = 1
# 819 "sp2.hpf"
      z_b_37 = pghpf_extent(global_fx$d1,2)
# 819 "sp2.hpf"
      z_b_32 = 1
# 819 "sp2.hpf"
      z_b_33 = pghpf_extent(npp$d1,1)
# 819 "sp2.hpf"
      z_b_30 = 1
# 819 "sp2.hpf"
      z_b_31 = pghpf_extent(noff$d1,1)
# 819 "sp2.hpf"
      z_b_38 = 1
# 819 "sp2.hpf"
      z_b_39 = pghpf_extent(sum_0$d1,1)
# 819 "sp2.hpf"
      z_b_26 = 1
# 819 "sp2.hpf"
      z_b_27 = pghpf_extent(edges$d1,1)
# 819 "sp2.hpf"
      z_b_28 = 1
# 819 "sp2.hpf"
      z_b_29 = pghpf_extent(edges$d1,2)
# 819 "sp2.hpf"
      call pghpf_qopy_in(part$f77$p,pghpf_0(3),pghpf_0(3),part$f77$dp1,
     +part,part$d1,3,27,4,2084,3,0,z_b_20,z_b_22,z_b_24)
# 819 "sp2.hpf"
      call pghpf_qopy_in(npp$f77$p,pghpf_0(3),pghpf_0(3),npp$f77$dp1,npp
     +,npp$d1,1,25,4,2148,0,0,z_b_32)
# 819 "sp2.hpf"
      call pghpf_qopy_in(noff$f77$p,pghpf_0(3),pghpf_0(3),noff$f77$dp1,
     +noff,noff$d1,1,25,4,2148,0,0,z_b_30)
# 819 "sp2.hpf"
      call pghpf_qopy_in(sum_0$f77$p,pghpf_0(3),pghpf_0(3),sum_0$f77$dp1
     +,sum_0,sum_0$d1,1,27,4,2084,0,0,z_b_38)
# 819 "sp2.hpf"
      call pghpf_qopy_in(edges$f77$p,pghpf_0(3),pghpf_0(3),edges$f77$dp1
     +,edges,edges$d1,2,27,4,2084,1,0,z_b_26,z_b_28)
# 819 "sp2.hpf"
# 821 "sp2.hpf"
      call indep_loop_ppush1(part$f77,global_fx,npp$f77,noff$f77,qtme,dt
     +,sum_0$f77,idimp,npmax,nblok,nxpmx,edges$f77,nx)
# 821 "sp2.hpf"
      call pghpf_copy_out(edges,edges$f77,edges$d1,edges$f77$d1,0)
# 821 "sp2.hpf"
      call pghpf_copy_out(sum_0,sum_0$f77,sum_0$d1,sum_0$f77$d1,0)
# 821 "sp2.hpf"
      call pghpf_copy_out(noff,noff$f77,noff$d1,noff$f77$d1,1)
# 821 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f77,npp$d1,npp$f77$d1,1)
# 821 "sp2.hpf"
      call pghpf_copy_out(part,part$f77,part$d1,part$f77$d1,0)
# 824 "sp2.hpf"
      call pgf90io_src_info(824,'sp2.hpf')
# 824 "sp2.hpf"
      z__io = pgf90io_ldw_init(6,0,0,0)
# 824 "sp2.hpf"
      z__io = pgf90io_ldw(14,1,0,'after second part')
# 824 "sp2.hpf"
      z__io = pgf90io_ldw_end()
      call pghpf_sums(sum_0$r,sum_0,.true.,27,sum_0$d1,19)
# 825 "sp2.hpf"
      sum1 = sum_0$r
# 829 "sp2.hpf"
      ek = sum1 * 1.25e-1 + ek
# 831 "sp2.hpf"
      goto 99999
99999 continue
# 832 "sp2.hpf"
      call pghpf_free(global_fx$d1)
# 832 "sp2.hpf"
      call pghpf_free(global_fx$d)
# 832 "sp2.hpf"
      deallocate(global_fx)
# 832 "sp2.hpf"
      call pghpf_copy_out(edges$bs,edges,edges$s0,edges$d1,0)
# 832 "sp2.hpf"
      call pghpf_copy_out(sum_0$bs,sum_0,sum_0$s0,sum_0$d1,0)
# 832 "sp2.hpf"
      call pghpf_copy_out(noff$bs,noff,noff$s0,noff$d1,0)
# 832 "sp2.hpf"
      call pghpf_copy_out(npp$bs,npp,npp$s0,npp$d1,0)
# 832 "sp2.hpf"
      call pghpf_copy_out(fx$bs,fx,fx$s0,fx$d1,0)
# 832 "sp2.hpf"
      call pghpf_copy_out(part$bs,part,part$s0,part$d1,0)
# 832 "sp2.hpf"
      end
# 843 "sp2.hpf"
      subroutine dcomp1(edges$bs,nxp$bs,noff$bs,nx,nvp,idps,nblok,
     +edges$s0,nxp$s0,noff$s0,nx$s0,nvp$s0,idps$s0,nblok$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer edges$bs(1), nxp$bs(1), noff$bs(1), edges$s0(1), nxp$s0(1)
     +, noff$s0(1), nx$s0(1), nvp$s0(1), idps$s0(1), nblok$s0(1)
      integer nxp(:), noff(:), z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5
     +, z_b_6, z_b_7, k, i$i, i$i1, i$i2, i$i3, i$i4, i$i5, i$i6, 
     +noff$f$s(1), edges$s(1), nxp$f$s(1), edges$s1(1), nxp$s(1), nxp$f1
     +(:), nxp$f1$s(1), noff$s(1), i$$l, i$$u, i$$l1, i$$u1, i$$l2, 
     +i$$u2, i$$l3, i$$u3, noff$tl$tl$d(1), noff$f$d(1), noff$f$d1(1), 
     +l$$b, u$$b, nxp$tl$tl$d(1), nxp$f$d(1), nxp$f$d1(1), l$$b1, u$$b1
     +, nxp$tl$tl$d1(1), noff$tl$tl$d1(1), edges$tl$d(1), noff$d(1), 
     +nxp$d(1), edges$d(1), noff$d1(1), nxp$d1(1), edges$d1(1), l$$b2, 
     +u$$b2, l$$b3, u$$b3, l$$b4, u$$b4, l$$b5, u$$b5
      real edges(:,:), at1, noff$f(:), nxp$f(:)
      integer cp$$com, xfer$$com, cp$$com1, xfer$$com1, cp$$com2, 
     +xfer$$com2
      allocatable edges, nxp, noff, noff$f, nxp$f, nxp$f1
      pointer (edges$p,edges), (nxp$p,nxp), (noff$p,noff), (noff$f$sp,
     +noff$f$s), (edges$sp,edges$s), (nxp$f$sp,nxp$f$s), (edges$sp1,
     +edges$s1), (nxp$sp,nxp$s), (nxp$f1$sp,nxp$f1$s), (noff$sp,noff$s)
     +, (noff$tl$tl$dp,noff$tl$tl$d), (noff$f$dp,noff$f$d), (noff$f$dp1,
     +noff$f$d1), (nxp$tl$tl$dp,nxp$tl$tl$d), (nxp$f$dp,nxp$f$d), (
     +nxp$f$dp1,nxp$f$d1), (nxp$tl$tl$dp1,nxp$tl$tl$d1), (noff$tl$tl$dp1
     +,noff$tl$tl$d1), (edges$tl$dp,edges$tl$d), (noff$dp,noff$d), (
     +nxp$dp,nxp$d), (edges$dp,edges$d), (noff$dp1,noff$d1), (nxp$dp1,
     +nxp$d1), (edges$dp1,edges$d1)
      integer pghpf_extent, pghpf_sect, pghpf_comm_copy, 
     +pghpf_comm_start
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(edges$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(edges$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(nxp$s0,1)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(noff$s0,1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(edges$p,pghpf_0(3),pghpf_0(3),edges$dp1,
     +edges$bs,edges$s0,2,27,4,2052,1,0,z_b_0,z_b_2,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(edges$d1,l$$b2,u$$b2,l$$b3,u$$b3)
# 0 "sp2.hpf"
      redimension edges(l$$b2:u$$b2,l$$b3:u$$b3)
# 0 "sp2.hpf"
      call pghpf_qopy_in(nxp$p,pghpf_0(3),pghpf_0(3),nxp$dp1,nxp$bs,
     +nxp$s0,1,25,4,2052,0,0,z_b_4,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(nxp$d1,l$$b4,u$$b4)
# 0 "sp2.hpf"
      redimension nxp(l$$b4:u$$b4)
# 0 "sp2.hpf"
      call pghpf_qopy_in(noff$p,pghpf_0(3),pghpf_0(3),noff$dp1,noff$bs,
     +noff$s0,1,25,4,2052,0,0,z_b_6,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(noff$d1,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension noff(l$$b5:u$$b5)
# 853 "sp2.hpf"
      at1 = float(nx) / float(nvp)
      continue
# 854 "sp2.hpf"
!     forall (k=1:nblok)
      call pghpf_localize_bounds(edges$d1,2,1,nblok,1,i$$l,i$$u)
# 855 "sp2.hpf"
!     forall (i$i=i$$l:i$$u) edges(1,i$i) = at1 * float(i$i - 1)
# 855 "sp2.hpf"
      do i$i = i$$l, i$$u
# 855 "sp2.hpf"
         edges(1,i$i) = at1 * float(i$i - 1)
# 855 "sp2.hpf"
      enddo
# 855 "sp2.hpf"
!     edges(1,k) = at1 * float(k - 1)
# 855 "sp2.hpf"
      call pghpf_template(noff$tl$tl$dp,1,1024,0,0,z_b_6,z_b_7)
# 855 "sp2.hpf"
      call pghpf_template(noff$f$dp,1,20480,noff$tl$tl$d,0,z_b_6,z_b_7)
# 855 "sp2.hpf"
      call pghpf_instance(noff$f$dp1,noff$f$d,27,4,0,4,4)
# 855 "sp2.hpf"
# 856 "sp2.hpf"
      call pghpf_allobnds(noff$f$d1,l$$b,u$$b)
# 856 "sp2.hpf"
      allocate(noff$f(l$$b:u$$b))
# 856 "sp2.hpf"
      noff$f$sp = pghpf_sect(noff$f$d1,1,nblok,1,1)
# 856 "sp2.hpf"
      edges$sp = pghpf_sect(edges$d1,1,1,1,1,nblok,1,2)
# 856 "sp2.hpf"
      cp$$com = pghpf_comm_copy(noff$f,edges,noff$f$s,edges$s)
# 856 "sp2.hpf"
      xfer$$com = pghpf_comm_start(cp$$com,noff$f,noff$f$s,edges,edges$s
     +)
# 856 "sp2.hpf"
      call pghpf_comm_finish(xfer$$com)
# 856 "sp2.hpf"
      call pghpf_localize_bounds(noff$d1,1,1,nblok,1,i$$l1,i$$u1)
# 856 "sp2.hpf"
!     forall (i$i=i$$l1:i$$u1) noff(i$i) = noff$f(i$i) + 5.0e-1
# 856 "sp2.hpf"
      do i$i = i$$l1, i$$u1
# 856 "sp2.hpf"
         noff(i$i) = noff$f(i$i) + 5.0e-1
# 856 "sp2.hpf"
      enddo
# 856 "sp2.hpf"
      call pghpf_comm_free(1,cp$$com)
# 856 "sp2.hpf"
      call pghpf_free(edges$s)
# 856 "sp2.hpf"
      call pghpf_free(noff$f$s)
# 856 "sp2.hpf"
      call pghpf_freen(3,noff$f$d1,noff$f$d,noff$tl$tl$d)
# 856 "sp2.hpf"
      deallocate(noff$f)
# 856 "sp2.hpf"
!     noff(k) = edges(1,k) + 5.0e-1
      call pghpf_localize_bounds(edges$d1,2,1,nblok,1,i$$l2,i$$u2)
# 857 "sp2.hpf"
!     forall (i$i=i$$l2:i$$u2) edges(2,i$i) = at1 * float(i$i)
# 857 "sp2.hpf"
      do i$i = i$$l2, i$$u2
# 857 "sp2.hpf"
         edges(2,i$i) = at1 * float(i$i)
# 857 "sp2.hpf"
      enddo
# 857 "sp2.hpf"
!     edges(2,k) = at1 * float(k)
# 857 "sp2.hpf"
      call pghpf_template(nxp$tl$tl$dp,1,1024,0,0,z_b_4,z_b_5)
# 857 "sp2.hpf"
      call pghpf_template(nxp$f$dp,1,20480,nxp$tl$tl$d,0,z_b_4,z_b_5)
# 857 "sp2.hpf"
      call pghpf_instance(nxp$f$dp1,nxp$f$d,27,4,0,4,4)
# 857 "sp2.hpf"
# 858 "sp2.hpf"
      call pghpf_allobnds(nxp$f$d1,l$$b1,u$$b1)
# 858 "sp2.hpf"
      allocate(nxp$f(l$$b1:u$$b1))
# 858 "sp2.hpf"
      nxp$f$sp = pghpf_sect(nxp$f$d1,1,nblok,1,1)
# 858 "sp2.hpf"
      edges$sp1 = pghpf_sect(edges$d1,2,2,1,1,nblok,1,2)
# 858 "sp2.hpf"
      cp$$com1 = pghpf_comm_copy(nxp$f,edges,nxp$f$s,edges$s1)
# 858 "sp2.hpf"
      xfer$$com1 = pghpf_comm_start(cp$$com1,nxp$f,nxp$f$s,edges,
     +edges$s1)
# 858 "sp2.hpf"
      call pghpf_comm_finish(xfer$$com1)
# 858 "sp2.hpf"
      nxp$sp = pghpf_sect(nxp$d1,1,nblok,1,1)
# 858 "sp2.hpf"
      noff$sp = pghpf_sect(noff$d1,1,nblok,1,1)
# 858 "sp2.hpf"
      cp$$com2 = pghpf_comm_copy(nxp,noff,nxp$s,noff$s)
# 858 "sp2.hpf"
      xfer$$com2 = pghpf_comm_start(cp$$com2,nxp,nxp$s,noff,noff$s)
# 858 "sp2.hpf"
      call pghpf_comm_finish(xfer$$com2)
# 858 "sp2.hpf"
      call pghpf_localize_bounds(nxp$d1,1,1,nblok,1,i$$l3,i$$u3)
# 858 "sp2.hpf"
!     forall (i$i=i$$l3:i$$u3) nxp(i$i) = int(nxp$f(i$i) + 5.0e-1) - nxp
!    +(i$i)
# 858 "sp2.hpf"
      do i$i = i$$l3, i$$u3
# 858 "sp2.hpf"
         nxp(i$i) = int(nxp$f(i$i) + 5.0e-1) - nxp(i$i)
# 858 "sp2.hpf"
      enddo
# 858 "sp2.hpf"
      call pghpf_comm_free(1,cp$$com2)
# 858 "sp2.hpf"
      call pghpf_free(noff$s)
# 858 "sp2.hpf"
      call pghpf_free(nxp$s)
# 858 "sp2.hpf"
      call pghpf_comm_free(1,cp$$com1)
# 858 "sp2.hpf"
      call pghpf_free(edges$s1)
# 858 "sp2.hpf"
      call pghpf_free(nxp$f$s)
# 858 "sp2.hpf"
      call pghpf_freen(3,nxp$f$d1,nxp$f$d,nxp$tl$tl$d)
# 858 "sp2.hpf"
      deallocate(nxp$f)
# 858 "sp2.hpf"
!     nxp(k) = int(edges(2,k) + 5.0e-1) - noff(k)
!     endforall
# 868 "sp2.hpf"
      goto 99999
99999 continue
# 869 "sp2.hpf"
      call pghpf_copy_out(noff$bs,noff,noff$s0,noff$d1,0)
# 869 "sp2.hpf"
      call pghpf_copy_out(nxp$bs,nxp,nxp$s0,nxp$d1,0)
# 869 "sp2.hpf"
      call pghpf_copy_out(edges$bs,edges,edges$s0,edges$d1,0)
# 869 "sp2.hpf"
      end
# 878 "sp2.hpf"
      subroutine pistr1(part$bs,edges$bs,npp$bs,nps$bs,vtx,vdx,npx,nx,
     +idimp,npmax,nblok,idps,sum_0$bs,part$s0,edges$s0,npp$s0,nps$s0,
     +vtx$s0,vdx$s0,npx$s0,nx$s0,idimp$s0,npmax$s0,nblok$s0,idps$s0,
     +sum_0$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer part$bs(1), edges$bs(1), npp$bs(1), nps$bs(1), sum_0$bs(1)
     +, part$s0(1), edges$s0(1), npp$s0(1), nps$s0(1), vtx$s0(1), vdx$s0
     +(1), npx$s0(1), nx$s0(1), idimp$s0(1), npmax$s0(1), nblok$s0(1), 
     +idps$s0(1), sum_0$s0(1)
      integer npp(:), nps(:), z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5, 
     +z_b_6, z_b_7, z_b_8, z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, z_b_14
     +, z_b_15, i$i, i$i1, i$i2, i$i3, i$i4, i$i5, i$i6, npp$f77(:), 
     +z_b_16, z_b_17, z_b_18, z_b_19, z_b_20, z_b_21, part$f77$d(1), 
     +part$f77$d1(1), edges$f77$d(1), edges$f77$d1(1), npp$f77$d(1), 
     +npp$f77$d1(1), npp$f771(:), nps$f77(:), z_b_22, z_b_23, z_b_24, 
     +z_b_25, z_b_26, z_b_27, npp$f771$d(1), npp$f771$d1(1), nps$f77$d(1
     +), nps$f77$d1(1), part$f771$d(1), part$f771$d1(1), sum_0$f77$d(1)
     +, sum_0$f77$d1(1), npp$f772(:), nps$f771(:), z_b_28, z_b_29, 
     +z_b_30, z_b_31, z_b_32, npp$f772$d(1), npp$f772$d1(1), nps$f771$d(
     +1), nps$f771$d1(1), part$f772$d(1), part$f772$d1(1), sum_0$tl$d(1)
     +, nps$tl$d(1), npp$tl$d(1), edges$tl$d(1), part$tl$d(1), sum_0$d(1
     +), nps$d(1), npp$d(1), edges$d(1), part$d(1), sum_0$d1(1), nps$d1(
     +1), npp$d1(1), edges$d1(1), part$d1(1), l$$b, u$$b, l$$b1, u$$b1, 
     +l$$b2, u$$b2, l$$b3, u$$b3, l$$b4, u$$b4, l$$b5, u$$b5, l$$b6, 
     +u$$b6, l$$b7, u$$b7
      real part(:,:,:), edges(:,:), sum_0(:), sum_1, sum_0$r, part$f77(:
     +,:,:), edges$f77(:,:), part$f771(:,:,:), sum_0$f77(:), part$f772(:
     +,:,:)
      double precision ranorm
      allocatable part, edges, npp, nps, sum_0, part$f77, edges$f77, 
     +npp$f77, npp$f771, nps$f77, part$f771, sum_0$f77, npp$f772, 
     +nps$f771, part$f772
      pointer (part$p,part), (edges$p,edges), (npp$p,npp), (nps$p,nps), 
     +(sum_0$p,sum_0), (part$f77$p,part$f77), (edges$f77$p,edges$f77), (
     +npp$f77$p,npp$f77), (part$f77$dp,part$f77$d), (part$f77$dp1,
     +part$f77$d1), (edges$f77$dp,edges$f77$d), (edges$f77$dp1,
     +edges$f77$d1), (npp$f77$dp,npp$f77$d), (npp$f77$dp1,npp$f77$d1), (
     +npp$f771$p,npp$f771), (nps$f77$p,nps$f77), (part$f771$p,part$f771)
     +, (sum_0$f77$p,sum_0$f77), (npp$f771$dp,npp$f771$d), (npp$f771$dp1
     +,npp$f771$d1), (nps$f77$dp,nps$f77$d), (nps$f77$dp1,nps$f77$d1), (
     +part$f771$dp,part$f771$d), (part$f771$dp1,part$f771$d1), (
     +sum_0$f77$dp,sum_0$f77$d), (sum_0$f77$dp1,sum_0$f77$d1), (
     +npp$f772$p,npp$f772), (nps$f771$p,nps$f771), (part$f772$p,
     +part$f772), (npp$f772$dp,npp$f772$d), (npp$f772$dp1,npp$f772$d1), 
     +(nps$f771$dp,nps$f771$d), (nps$f771$dp1,nps$f771$d1), (
     +part$f772$dp,part$f772$d), (part$f772$dp1,part$f772$d1), (
     +sum_0$tl$dp,sum_0$tl$d), (nps$tl$dp,nps$tl$d), (npp$tl$dp,npp$tl$d
     +), (edges$tl$dp,edges$tl$d), (part$tl$dp,part$tl$d), (sum_0$dp,
     +sum_0$d), (nps$dp,nps$d), (npp$dp,npp$d), (edges$dp,edges$d), (
     +part$dp,part$d), (sum_0$dp1,sum_0$d1), (nps$dp1,nps$d1), (npp$dp1,
     +npp$d1)
      pointer (edges$dp1,edges$d1), (part$dp1,part$d1)
      integer pghpf_extent
      external indep_loop_pist1_1, indep_loop_pist1_2, dist_particle
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(part$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(part$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(part$s0,3)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(edges$s0,1)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(edges$s0,2)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(npp$s0,1)
# 0 "sp2.hpf"
      z_b_14 = 1
# 0 "sp2.hpf"
      z_b_15 = pghpf_extent(nps$s0,1)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(sum_0$s0,1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(part$p,pghpf_0(3),pghpf_0(3),part$dp1,part$bs,
     +part$s0,3,27,4,2052,3,0,z_b_0,z_b_2,z_b_4,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(part$d1,l$$b,u$$b,l$$b1,u$$b1,l$$b2,u$$b2)
# 0 "sp2.hpf"
      redimension part(l$$b:u$$b,l$$b1:u$$b1,l$$b2:u$$b2)
# 0 "sp2.hpf"
      call pghpf_qopy_in(edges$p,pghpf_0(3),pghpf_0(3),edges$dp1,
     +edges$bs,edges$s0,2,27,4,2052,1,0,z_b_6,z_b_8,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(edges$d1,l$$b3,u$$b3,l$$b4,u$$b4)
# 0 "sp2.hpf"
      redimension edges(l$$b3:u$$b3,l$$b4:u$$b4)
# 0 "sp2.hpf"
      call pghpf_qopy_in(npp$p,pghpf_0(3),pghpf_0(3),npp$dp1,npp$bs,
     +npp$s0,1,25,4,2052,0,0,z_b_12,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(npp$d1,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension npp(l$$b5:u$$b5)
# 0 "sp2.hpf"
      call pghpf_qopy_in(nps$p,pghpf_0(3),pghpf_0(3),nps$dp1,nps$bs,
     +nps$s0,1,25,4,2052,0,0,z_b_14,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(nps$d1,l$$b6,u$$b6)
# 0 "sp2.hpf"
      redimension nps(l$$b6:u$$b6)
# 0 "sp2.hpf"
      call pghpf_qopy_in(sum_0$p,pghpf_0(3),pghpf_0(3),sum_0$dp1,
     +sum_0$bs,sum_0$s0,1,27,4,2052,0,0,z_b_10,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(sum_0$d1,l$$b7,u$$b7)
# 0 "sp2.hpf"
      redimension sum_0(l$$b7:u$$b7)
# 0 "sp2.hpf"
      z_b_16 = idimp
# 0 "sp2.hpf"
      z_b_17 = npmax
# 0 "sp2.hpf"
      z_b_18 = nblok
# 0 "sp2.hpf"
      z_b_19 = idimp
# 0 "sp2.hpf"
      z_b_20 = nblok
# 0 "sp2.hpf"
      z_b_21 = nblok
# 0 "sp2.hpf"
      call pghpf_qopy_in(part$f77$p,pghpf_0(3),pghpf_0(3),part$f77$dp1,
     +part,part$d1,3,27,4,2080,3,0,1,z_b_16,1,z_b_17,1,z_b_18)
# 0 "sp2.hpf"
      call pghpf_qopy_in(edges$f77$p,pghpf_0(3),pghpf_0(3),edges$f77$dp1
     +,edges,edges$d1,2,27,4,2144,1,0,1,z_b_19,1,z_b_20)
# 0 "sp2.hpf"
      call pghpf_qopy_in(npp$f77$p,pghpf_0(3),pghpf_0(3),npp$f77$dp1,npp
     +,npp$d1,1,25,4,2080,0,0,1,z_b_21)
# 0 "sp2.hpf"
# 932 "sp2.hpf"
      call dist_particle(part$f77,edges$f77,npp$f77,npx,vtx,nblok,idimp,
     +npmax,nx)
# 932 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f77,npp$d1,npp$f77$d1,0)
# 932 "sp2.hpf"
      call pghpf_copy_out(edges,edges$f77,edges$d1,edges$f77$d1,1)
# 932 "sp2.hpf"
      call pghpf_copy_out(part,part$f77,part$d1,part$f77$d1,0)
# 932 "sp2.hpf"
      z_b_22 = nblok
# 932 "sp2.hpf"
      z_b_23 = nblok
# 932 "sp2.hpf"
      z_b_24 = idimp
# 932 "sp2.hpf"
      z_b_25 = npmax
# 932 "sp2.hpf"
      z_b_26 = nblok
# 932 "sp2.hpf"
      z_b_27 = nblok
# 932 "sp2.hpf"
      call pghpf_qopy_in(npp$f771$p,pghpf_0(3),pghpf_0(3),npp$f771$dp1,
     +npp,npp$d1,1,25,4,2144,0,0,1,z_b_22)
# 932 "sp2.hpf"
      call pghpf_qopy_in(nps$f77$p,pghpf_0(3),pghpf_0(3),nps$f77$dp1,nps
     +,nps$d1,1,25,4,2144,0,0,1,z_b_23)
# 932 "sp2.hpf"
      call pghpf_qopy_in(part$f771$p,pghpf_0(3),pghpf_0(3),part$f771$dp1
     +,part,part$d1,3,27,4,2144,3,0,1,z_b_24,1,z_b_25,1,z_b_26)
# 932 "sp2.hpf"
      call pghpf_qopy_in(sum_0$f77$p,pghpf_0(3),pghpf_0(3),sum_0$f77$dp1
     +,sum_0,sum_0$d1,1,27,4,2208,0,0,1,z_b_27)
# 932 "sp2.hpf"
# 934 "sp2.hpf"
      call indep_loop_pist1_1(npp$f771,nps$f77,part$f771,sum_0$f77,idimp
     +,nblok,npmax)
# 934 "sp2.hpf"
      call pghpf_copy_out(sum_0,sum_0$f77,sum_0$d1,sum_0$f77$d1,2)
# 934 "sp2.hpf"
      call pghpf_copy_out(part,part$f771,part$d1,part$f771$d1,1)
# 934 "sp2.hpf"
      call pghpf_copy_out(nps,nps$f77,nps$d1,nps$f77$d1,1)
# 934 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f771,npp$d1,npp$f771$d1,1)
# 936 "sp2.hpf"
      call pghpf_sums(sum_0$r,sum_0,.true.,27,sum_0$d1,19)
# 936 "sp2.hpf"
      sum_1 = sum_0$r
# 938 "sp2.hpf"
      sum_1 = sum_1 / float(npx) - vdx
# 938 "sp2.hpf"
      z_b_28 = nblok
# 938 "sp2.hpf"
      z_b_29 = nblok
# 938 "sp2.hpf"
      z_b_30 = idimp
# 938 "sp2.hpf"
      z_b_31 = npmax
# 938 "sp2.hpf"
      z_b_32 = nblok
# 938 "sp2.hpf"
      call pghpf_qopy_in(npp$f772$p,pghpf_0(3),pghpf_0(3),npp$f772$dp1,
     +npp,npp$d1,1,25,4,2144,0,0,1,z_b_28)
# 938 "sp2.hpf"
      call pghpf_qopy_in(nps$f771$p,pghpf_0(3),pghpf_0(3),nps$f771$dp1,
     +nps,nps$d1,1,25,4,2144,0,0,1,z_b_29)
# 938 "sp2.hpf"
      call pghpf_qopy_in(part$f772$p,pghpf_0(3),pghpf_0(3),part$f772$dp1
     +,part,part$d1,3,27,4,2080,3,0,1,z_b_30,1,z_b_31,1,z_b_32)
# 938 "sp2.hpf"
# 940 "sp2.hpf"
      call indep_loop_pist1_2(npp$f772,nps$f771,part$f772,sum_1,idimp,
     +nblok,npmax)
# 940 "sp2.hpf"
      call pghpf_copy_out(part,part$f772,part$d1,part$f772$d1,0)
# 940 "sp2.hpf"
      call pghpf_copy_out(nps,nps$f771,nps$d1,nps$f771$d1,1)
# 940 "sp2.hpf"
      call pghpf_copy_out(npp,npp$f772,npp$d1,npp$f772$d1,1)
# 943 "sp2.hpf"
      goto 99999
99999 continue
# 944 "sp2.hpf"
      call pghpf_copy_out(sum_0$bs,sum_0,sum_0$s0,sum_0$d1,0)
# 944 "sp2.hpf"
      call pghpf_copy_out(nps$bs,nps,nps$s0,nps$d1,0)
# 944 "sp2.hpf"
      call pghpf_copy_out(npp$bs,npp,npp$s0,npp$d1,0)
# 944 "sp2.hpf"
      call pghpf_copy_out(edges$bs,edges,edges$s0,edges$d1,0)
# 944 "sp2.hpf"
      call pghpf_copy_out(part$bs,part,part$s0,part$d1,0)
# 944 "sp2.hpf"
      end
# 963 "sp2.hpf"
      subroutine ppois1(q$bs,fx$bs,isign,ffc$bs,ax,affp,wp,nx,kxp,kblok,
     +nblok,sum_0$bs,q$s0,fx$s0,isign$s0,ffc$s0,ax$s0,affp$s0,wp$s0,
     +nx$s0,kxp$s0,kblok$s0,nblok$s0,sum_0$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer q$bs(1), fx$bs(1), ffc$bs(1), sum_0$bs(1), q$s0(1), fx$s0(
     +1), isign$s0(1), ffc$s0(1), ax$s0(1), affp$s0(1), wp$s0(1), nx$s0(
     +1), kxp$s0(1), kblok$s0(1), nblok$s0(1), sum_0$s0(1)
      integer z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5, z_b_6, z_b_7, 
     +z_b_8, z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, i$i, i$i1, i$i2, 
     +i$i3, i$i4, i$i5, i$i6, z_b_20, z_b_21, ffc$f77$d(1), ffc$f77$d1(1
     +), z_b_22, z_b_23, z_b_24, z_b_25, z_b_26, z_b_27, z_b_28, 
     +ffc$f771$d(1), ffc$f771$d1(1), qc$f77$d(1), qc$f77$d1(1), fc$f77$d
     +(1), fc$f77$d1(1), sum_0$f77$d(1), sum_0$f77$d1(1), sum_0$tl$d(1)
     +, ffc$tl$d(1), fx$tl$d(1), q$tl$d(1), sum_0$d(1), ffc$d(1), fx$d(1
     +), q$d(1), sum_0$d1(1), ffc$d1(1), fx$d1(1), q$d1(1), l$$b, u$$b, 
     +l$$b1, u$$b1, l$$b2, u$$b2, l$$b3, u$$b3, l$$b4, u$$b4, l$$b5, 
     +u$$b5, l$$b6, u$$b6
      real sum_0(:), sum_0$r, sum_0$f77(:)
      complex q(:,:), fx(:,:), ffc(:,:), ffc$f77(:,:), ffc$f771(:,:), 
     +qc$f77(:,:), fc$f77(:,:)
      allocatable q, fx, ffc, sum_0, ffc$f77, ffc$f771, qc$f77, fc$f77, 
     +sum_0$f77
      pointer (q$p,q), (fx$p,fx), (ffc$p,ffc), (sum_0$p,sum_0), (
     +ffc$f77$p,ffc$f77), (ffc$f77$dp,ffc$f77$d), (ffc$f77$dp1,
     +ffc$f77$d1), (ffc$f771$p,ffc$f771), (qc$f77$p,qc$f77), (fc$f77$p,
     +fc$f77), (sum_0$f77$p,sum_0$f77), (ffc$f771$dp,ffc$f771$d), (
     +ffc$f771$dp1,ffc$f771$d1), (qc$f77$dp,qc$f77$d), (qc$f77$dp1,
     +qc$f77$d1), (fc$f77$dp,fc$f77$d), (fc$f77$dp1,fc$f77$d1), (
     +sum_0$f77$dp,sum_0$f77$d), (sum_0$f77$dp1,sum_0$f77$d1), (
     +sum_0$tl$dp,sum_0$tl$d), (ffc$tl$dp,ffc$tl$d), (fx$tl$dp,fx$tl$d)
     +, (q$tl$dp,q$tl$d), (sum_0$dp,sum_0$d), (ffc$dp,ffc$d), (fx$dp,
     +fx$d), (q$dp,q$d), (sum_0$dp1,sum_0$d1), (ffc$dp1,ffc$d1), (fx$dp1
     +,fx$d1), (q$dp1,q$d1)
      integer pghpf_extent
      external indep_loop_ppois1_1, indep_loop_ppois1_2
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(q$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(q$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(fx$s0,1)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(fx$s0,2)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(ffc$s0,1)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(ffc$s0,2)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(sum_0$s0,1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(q$p,pghpf_0(3),pghpf_0(3),q$dp1,q$bs,q$s0,2,9,8
     +,2052,1,0,z_b_0,z_b_2,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(q$d1,l$$b,u$$b,l$$b1,u$$b1)
# 0 "sp2.hpf"
      redimension q(l$$b:u$$b,l$$b1:u$$b1)
# 0 "sp2.hpf"
      call pghpf_qopy_in(fx$p,pghpf_0(3),pghpf_0(3),fx$dp1,fx$bs,fx$s0,2
     +,9,8,2052,1,0,z_b_4,z_b_6,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(fx$d1,l$$b2,u$$b2,l$$b3,u$$b3)
# 0 "sp2.hpf"
      redimension fx(l$$b2:u$$b2,l$$b3:u$$b3)
# 0 "sp2.hpf"
      call pghpf_qopy_in(ffc$p,pghpf_0(3),pghpf_0(3),ffc$dp1,ffc$bs,
     +ffc$s0,2,9,8,2052,1,0,z_b_8,z_b_10,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(ffc$d1,l$$b4,u$$b4,l$$b5,u$$b5)
# 0 "sp2.hpf"
      redimension ffc(l$$b4:u$$b4,l$$b5:u$$b5)
# 0 "sp2.hpf"
      call pghpf_qopy_in(sum_0$p,pghpf_0(3),pghpf_0(3),sum_0$dp1,
     +sum_0$bs,sum_0$s0,1,27,4,2052,0,0,z_b_12,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(sum_0$d1,l$$b6,u$$b6)
# 0 "sp2.hpf"
      redimension sum_0(l$$b6:u$$b6)
# 1000 "sp2.hpf"
      nxh = nx / 2
# 1002 "sp2.hpf"
      if (isign .eq. 0) then
         if (1 .gt. nxh) then
# 1003 "sp2.hpf"
            goto 99999
# 1003 "sp2.hpf"
         endif
# 1003 "sp2.hpf"
         z_b_20 = kxp
# 1003 "sp2.hpf"
         z_b_21 = kblok
# 1003 "sp2.hpf"
         call pghpf_qopy_in(ffc$f77$p,pghpf_0(3),pghpf_0(3),ffc$f77$dp1,
     +ffc,ffc$d1,2,9,8,2208,1,0,1,z_b_20,1,z_b_21)
# 1003 "sp2.hpf"
# 1004 "sp2.hpf"
         call indep_loop_ppois1_1(ffc$f77,nx,kxp,affp,ax,kblok)
# 1004 "sp2.hpf"
         call pghpf_copy_out(ffc,ffc$f77,ffc$d1,ffc$f77$d1,2)
      else
         if (1 .gt. nxh) then
# 1006 "sp2.hpf"
            goto 99999
# 1006 "sp2.hpf"
         endif
# 1006 "sp2.hpf"
         z_b_22 = kxp
# 1006 "sp2.hpf"
         z_b_23 = kblok
# 1006 "sp2.hpf"
         z_b_24 = kxp
# 1006 "sp2.hpf"
         z_b_25 = kblok
# 1006 "sp2.hpf"
         z_b_26 = kxp
# 1006 "sp2.hpf"
         z_b_27 = kblok
# 1006 "sp2.hpf"
         z_b_28 = nblok
# 1006 "sp2.hpf"
         call pghpf_qopy_in(ffc$f771$p,pghpf_0(3),pghpf_0(3),
     +ffc$f771$dp1,ffc,ffc$d1,2,9,8,2144,1,0,1,z_b_22,1,z_b_23)
# 1006 "sp2.hpf"
         call pghpf_qopy_in(qc$f77$p,pghpf_0(3),pghpf_0(3),qc$f77$dp1,q,
     +q$d1,2,9,8,2144,1,0,1,z_b_24,1,z_b_25)
# 1006 "sp2.hpf"
         call pghpf_qopy_in(fc$f77$p,pghpf_0(3),pghpf_0(3),fc$f77$dp1,fx
     +,fx$d1,2,9,8,2208,1,0,1,z_b_26,1,z_b_27)
# 1006 "sp2.hpf"
         call pghpf_qopy_in(sum_0$f77$p,pghpf_0(3),pghpf_0(3),
     +sum_0$f77$dp1,sum_0,sum_0$d1,1,27,4,2208,0,0,1,z_b_28)
# 1006 "sp2.hpf"
# 1007 "sp2.hpf"
         call indep_loop_ppois1_2(ffc$f771,qc$f77,fc$f77,nx,kxp,affp,ax,
     +sum_0$f77,kblok,nblok)
# 1007 "sp2.hpf"
         call pghpf_copy_out(sum_0,sum_0$f77,sum_0$d1,sum_0$f77$d1,2)
# 1007 "sp2.hpf"
         call pghpf_copy_out(fx,fc$f77,fx$d1,fc$f77$d1,2)
# 1007 "sp2.hpf"
         call pghpf_copy_out(q,qc$f77,q$d1,qc$f77$d1,1)
# 1007 "sp2.hpf"
         call pghpf_copy_out(ffc,ffc$f771,ffc$d1,ffc$f771$d1,1)
# 1010 "sp2.hpf"
         call pghpf_sums(sum_0$r,sum_0,.true.,27,sum_0$d1,19)
# 1010 "sp2.hpf"
         wp = sum_0$r
         wp = wp * float(nx)
      endif
# 1014 "sp2.hpf"
      goto 99999
99999 continue
# 1015 "sp2.hpf"
      call pghpf_copy_out(sum_0$bs,sum_0,sum_0$s0,sum_0$d1,0)
# 1015 "sp2.hpf"
      call pghpf_copy_out(ffc$bs,ffc,ffc$s0,ffc$d1,0)
# 1015 "sp2.hpf"
      call pghpf_copy_out(fx$bs,fx,fx$s0,fx$d1,0)
# 1015 "sp2.hpf"
      call pghpf_copy_out(q$bs,q,q$s0,q$d1,0)
# 1015 "sp2.hpf"
      end
# 1028 "sp2.hpf"
      subroutine cppfp1(f$bs,fc$bs,isign,scr$bs,scc$bs,nvp,nxpmx,nblok,
     +kxp,kblok,idps,f$s0,fc$s0,isign$s0,scr$s0,scc$s0,nvp$s0,nxpmx$s0,
     +nblok$s0,kxp$s0,kblok$s0,idps$s0)
      common /pghpf_0/pghpf_0, /pghpf_0c/pghpf_0c
     +, /pghpf_lineno/pghpf_lineno
      integer pghpf_0(4), pghpf_lineno
      character*1 pghpf_0c
      common /pghpf_local_mode / pghpf_local_mode
      integer pghpf_local_mode
      integer f$bs(1), fc$bs(1), scr$bs(1), scc$bs(1), f$s0(1), fc$s0(1)
     +, isign$s0(1), scr$s0(1), scc$s0(1), nvp$s0(1), nxpmx$s0(1), 
     +nblok$s0(1), kxp$s0(1), kblok$s0(1), idps$s0(1)
      integer z_b_0, z_b_1, z_b_2, z_b_3, z_b_4, z_b_5, z_b_6, z_b_7, 
     +z_b_8, z_b_9, z_b_10, z_b_11, z_b_12, z_b_13, z_b_14, z_b_15, 
     +z_b_16, z_b_17, z_b_18, z_b_19, z_b_20, z_b_21, z_b_22, z_b_23, 
     +i$i, i$i1, i$i2, i$i3, i$i4, i$i5, i$i6, fc$f$s(1), f$s(1), 
     +fc$f1$s(1), f$s1(1), scr$s(1), f$s2(1), scr$s1(1), f$s3(1), 
     +fc$f2$s(1), scr$s2(1), fc$f3$s(1), scr$s3(1), scr$s4(1), f$s4(1), 
     +fc$f4$s(1), scr$s5(1), f$f77$d(1), f$f77$d1(1), fc$f77$d(1), 
     +fc$f77$d1(1), scc$s(1), fc$s(1), f$f$s(1), scc$s1(1), scc$s2(1), 
     +fc$s1(1), f$f1$s(1), scc$s3(1), f$f2$s(1), scc$s4(1), i$$l, i$$u, 
     +i$$l1, i$$u1, i$$l2, i$$u2, i$$l3, i$$u3, i$$l4, i$$u4, i$$l5, 
     +i$$u5, fc$tl$tl$d(1), fc$f$d(1), fc$f$d1(1), l$$b, u$$b, l$$b1, 
     +u$$b1, fc$tl$tl1$d(1), fc$f1$d(1), fc$f1$d1(1), l$$b2, u$$b2, 
     +l$$b3, u$$b3, fc$tl$tl2$d(1), fc$f2$d(1), fc$f2$d1(1), l$$b4, 
     +u$$b4, fc$tl$tl3$d(1), fc$f3$d(1), fc$f3$d1(1), l$$b5, u$$b5, 
     +fc$tl$tl4$d(1), fc$f4$d(1), fc$f4$d1(1), l$$b6, u$$b6, f$tl$tl$d(1
     +), f$f$d(1), f$f$d1(1), l$$b7, u$$b7, f$tl$tl1$d(1), f$f1$d(1), 
     +f$f1$d1(1), l$$b8, u$$b8, f$tl$tl2$d(1), f$f2$d(1), f$f2$d1(1), 
     +l$$b9, u$$b9, f$tl$tl2$d1(1), fc$tl$tl4$d1(1), scc$tl$d(1), 
     +scr$tl$d(1)
      integer scc$d(1), scr$d(1), fc$d(1), f$d(1), scc$d1(1), scr$d1(1)
     +, fc$d1(1), f$d1(1), l$$b10, u$$b10, l$$b11, u$$b11, l$$b12, 
     +u$$b12, l$$b13, u$$b13, l$$b14, u$$b14, l$$b15, u$$b15, l$$b16, 
     +u$$b16, l$$b17, u$$b17
      real f(:,:), scr(:,:), fc$f(:,:), fc$f1(:,:), fc$f2(:), fc$f3(:), 
     +fc$f4(:), f$f77(:,:)
      complex fc(:,:), scc(:,:), fc$f77(:,:), f$f(:), f$f1(:), f$f2(:)
      integer cp$$com, xfer$$com, cp$$com1, xfer$$com1, cp$$com2, 
     +xfer$$com2, cp$$com3, xfer$$com3, cp$$com4, xfer$$com4, cp$$com5, 
     +xfer$$com5, cp$$com6, xfer$$com6, cp$$com7, xfer$$com7
      allocatable f, fc, scr, scc, fc$f, fc$f1, fc$f2, fc$f3, fc$f4, 
     +f$f77, fc$f77, f$f, f$f1, f$f2
      pointer (f$p,f), (fc$p,fc), (scr$p,scr), (scc$p,scc), (fc$f$sp,
     +fc$f$s), (f$sp,f$s), (fc$f1$sp,fc$f1$s), (f$sp1,f$s1), (scr$sp,
     +scr$s), (f$sp2,f$s2), (scr$sp1,scr$s1), (f$sp3,f$s3), (fc$f2$sp,
     +fc$f2$s), (scr$sp2,scr$s2), (fc$f3$sp,fc$f3$s), (scr$sp3,scr$s3), 
     +(scr$sp4,scr$s4), (f$sp4,f$s4), (fc$f4$sp,fc$f4$s), (scr$sp5,
     +scr$s5), (f$f77$p,f$f77), (fc$f77$p,fc$f77), (f$f77$dp,f$f77$d), (
     +f$f77$dp1,f$f77$d1), (fc$f77$dp,fc$f77$d), (fc$f77$dp1,fc$f77$d1)
     +, (scc$sp,scc$s), (fc$sp,fc$s), (f$f$sp,f$f$s), (scc$sp1,scc$s1), 
     +(scc$sp2,scc$s2), (fc$sp1,fc$s1), (f$f1$sp,f$f1$s), (scc$sp3,
     +scc$s3), (f$f2$sp,f$f2$s), (scc$sp4,scc$s4), (fc$tl$tl$dp,
     +fc$tl$tl$d), (fc$f$dp,fc$f$d), (fc$f$dp1,fc$f$d1), (fc$tl$tl1$dp,
     +fc$tl$tl1$d), (fc$f1$dp,fc$f1$d), (fc$f1$dp1,fc$f1$d1), (
     +fc$tl$tl2$dp,fc$tl$tl2$d), (fc$f2$dp,fc$f2$d), (fc$f2$dp1,fc$f2$d1
     +), (fc$tl$tl3$dp,fc$tl$tl3$d), (fc$f3$dp,fc$f3$d), (fc$f3$dp1,
     +fc$f3$d1), (fc$tl$tl4$dp,fc$tl$tl4$d), (fc$f4$dp,fc$f4$d), (
     +fc$f4$dp1,fc$f4$d1), (f$tl$tl$dp,f$tl$tl$d), (f$f$dp,f$f$d), (
     +f$f$dp1,f$f$d1), (f$tl$tl1$dp,f$tl$tl1$d), (f$f1$dp,f$f1$d), (
     +f$f1$dp1,f$f1$d1), (f$tl$tl2$dp,f$tl$tl2$d), (f$f2$dp,f$f2$d), (
     +f$f2$dp1,f$f2$d1)
      pointer (f$tl$tl2$dp1,f$tl$tl2$d1), (fc$tl$tl4$dp1,fc$tl$tl4$d1), 
     +(scc$tl$dp,scc$tl$d), (scr$tl$dp,scr$tl$d), (scc$dp,scc$d), (
     +scr$dp,scr$d), (fc$dp,fc$d), (f$dp,f$d), (scc$dp1,scc$d1), (
     +scr$dp1,scr$d1), (fc$dp1,fc$d1), (f$dp1,f$d1)
      integer pghpf_extent, pghpf_sect, pghpf_comm_copy, 
     +pghpf_comm_start
      external do_forall
# 0 "sp2.hpf"
      z_b_0 = 1
# 0 "sp2.hpf"
      z_b_1 = pghpf_extent(f$s0,1)
# 0 "sp2.hpf"
      z_b_2 = 1
# 0 "sp2.hpf"
      z_b_3 = pghpf_extent(f$s0,2)
# 0 "sp2.hpf"
      z_b_4 = 1
# 0 "sp2.hpf"
      z_b_5 = pghpf_extent(fc$s0,1)
# 0 "sp2.hpf"
      z_b_6 = 1
# 0 "sp2.hpf"
      z_b_7 = pghpf_extent(fc$s0,2)
# 0 "sp2.hpf"
      z_b_12 = 1
# 0 "sp2.hpf"
      z_b_13 = pghpf_extent(scr$s0,1)
# 0 "sp2.hpf"
      z_b_14 = 1
# 0 "sp2.hpf"
      z_b_15 = pghpf_extent(scr$s0,2)
# 0 "sp2.hpf"
      z_b_8 = 1
# 0 "sp2.hpf"
      z_b_9 = pghpf_extent(scc$s0,1)
# 0 "sp2.hpf"
      z_b_10 = 1
# 0 "sp2.hpf"
      z_b_11 = pghpf_extent(scc$s0,2)
# 0 "sp2.hpf"
      call pghpf_qopy_in(f$p,pghpf_0(3),pghpf_0(3),f$dp1,f$bs,f$s0,2,27,
     +4,2052,1,0,z_b_0,z_b_2,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(f$d1,l$$b10,u$$b10,l$$b11,u$$b11)
# 0 "sp2.hpf"
      redimension f(l$$b10:u$$b10,l$$b11:u$$b11)
# 0 "sp2.hpf"
      call pghpf_qopy_in(fc$p,pghpf_0(3),pghpf_0(3),fc$dp1,fc$bs,fc$s0,2
     +,9,8,2052,1,0,z_b_4,z_b_6,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(fc$d1,l$$b12,u$$b12,l$$b13,u$$b13)
# 0 "sp2.hpf"
      redimension fc(l$$b12:u$$b12,l$$b13:u$$b13)
# 0 "sp2.hpf"
      call pghpf_qopy_in(scr$p,pghpf_0(3),pghpf_0(3),scr$dp1,scr$bs,
     +scr$s0,2,27,4,2052,1,0,z_b_12,z_b_14,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(scr$d1,l$$b14,u$$b14,l$$b15,u$$b15)
# 0 "sp2.hpf"
      redimension scr(l$$b14:u$$b14,l$$b15:u$$b15)
# 0 "sp2.hpf"
      call pghpf_qopy_in(scc$p,pghpf_0(3),pghpf_0(3),scc$dp1,scc$bs,
     +scc$s0,2,9,8,2052,1,0,z_b_8,z_b_10,4,4)
# 0 "sp2.hpf"
      call pghpf_allobnds(scc$d1,l$$b16,u$$b16,l$$b17,u$$b17)
# 0 "sp2.hpf"
      redimension scc(l$$b16:u$$b16,l$$b17:u$$b17)
# 1048 "sp2.hpf"
      if (isign .eq. -1) then
# 1050 "sp2.hpf"
         continue
# 1050 "sp2.hpf"
!        forall (k=1:kblok, j=1:kxp)
# 1050 "sp2.hpf"
         call pghpf_template(fc$tl$tl$dp,1,1024,0,0,z_b_6,z_b_7)
# 1050 "sp2.hpf"
         call pghpf_template(fc$f$dp,2,4096,fc$tl$tl$d,0,1,1,1,0,0,z_b_4
     +,z_b_5,z_b_6,z_b_7)
# 1050 "sp2.hpf"
         call pghpf_instance(fc$f$dp1,fc$f$d,27,4,1,4,4)
# 1050 "sp2.hpf"
# 1051 "sp2.hpf"
         call pghpf_allobnds(fc$f$d1,l$$b,u$$b,l$$b1,u$$b1)
# 1051 "sp2.hpf"
         allocate(fc$f(l$$b:u$$b,l$$b1:u$$b1))
# 1051 "sp2.hpf"
         fc$f$sp = pghpf_sect(fc$f$d1,1,kxp,1,1,kblok,1,3)
# 1051 "sp2.hpf"
         f$sp = pghpf_sect(f$d1,2,kxp * 2,2,1,kblok,1,3)
# 1051 "sp2.hpf"
         cp$$com = pghpf_comm_copy(fc$f,f,fc$f$s,f$s)
# 1051 "sp2.hpf"
         xfer$$com = pghpf_comm_start(cp$$com,fc$f,fc$f$s,f,f$s)
# 1051 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com)
# 1051 "sp2.hpf"
         call pghpf_template(fc$tl$tl1$dp,1,1024,0,0,z_b_6,z_b_7)
# 1051 "sp2.hpf"
         call pghpf_template(fc$f1$dp,2,4096,fc$tl$tl1$d,0,1,1,1,0,0,
     +z_b_4,z_b_5,z_b_6,z_b_7)
# 1051 "sp2.hpf"
         call pghpf_instance(fc$f1$dp1,fc$f1$d,27,4,1,4,4)
# 1051 "sp2.hpf"
         call pghpf_allobnds(fc$f1$d1,l$$b2,u$$b2,l$$b3,u$$b3)
# 1051 "sp2.hpf"
         allocate(fc$f1(l$$b2:u$$b2,l$$b3:u$$b3))
# 1051 "sp2.hpf"
         fc$f1$sp = pghpf_sect(fc$f1$d1,1,kxp,1,1,kblok,1,3)
# 1051 "sp2.hpf"
         f$sp1 = pghpf_sect(f$d1,3,kxp * 2 + 1,2,1,kblok,1,3)
# 1051 "sp2.hpf"
         cp$$com1 = pghpf_comm_copy(fc$f1,f,fc$f1$s,f$s1)
# 1051 "sp2.hpf"
         xfer$$com1 = pghpf_comm_start(cp$$com1,fc$f1,fc$f1$s,f,f$s1)
# 1051 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com1)
# 1051 "sp2.hpf"
         call pghpf_localize_bounds(fc$d1,2,1,kblok,1,i$$l,i$$u)
# 1051 "sp2.hpf"
!        forall (i$i=i$$l:i$$u, i$i1=1:kxp) fc(i$i1,i$i) = cmplx(fc$f(
!    +i$i1,i$i),fc$f1(i$i1,i$i))
# 1051 "sp2.hpf"
         do i$i = i$$l, i$$u
# 1051 "sp2.hpf"
            do i$i1 = 1, kxp
# 1051 "sp2.hpf"
               fc(i$i1,i$i) = cmplx(fc$f(i$i1,i$i),fc$f1(i$i1,i$i))
# 1051 "sp2.hpf"
            enddo
# 1051 "sp2.hpf"
         enddo
# 1051 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com1)
# 1051 "sp2.hpf"
         call pghpf_free(f$s1)
# 1051 "sp2.hpf"
         call pghpf_free(fc$f1$s)
# 1051 "sp2.hpf"
         call pghpf_freen(3,fc$f1$d1,fc$f1$d,fc$tl$tl1$d)
# 1051 "sp2.hpf"
         deallocate(fc$f1)
# 1051 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com)
# 1051 "sp2.hpf"
         call pghpf_free(f$s)
# 1051 "sp2.hpf"
         call pghpf_free(fc$f$s)
# 1051 "sp2.hpf"
         call pghpf_freen(3,fc$f$d1,fc$f$d,fc$tl$tl$d)
# 1051 "sp2.hpf"
         deallocate(fc$f)
# 1051 "sp2.hpf"
!        fc(j,k) = cmplx(f(j*2,k),f(j*2+1,k))
!        endforall
# 1054 "sp2.hpf"
         scr$sp = pghpf_sect(scr$d1,1,1,1,1,z_b_15,1,2)
# 1054 "sp2.hpf"
         f$sp2 = pghpf_sect(f$d1,nxpmx - 1,nxpmx - 1,1,1,z_b_3,1,2)
# 1054 "sp2.hpf"
         call pghpf_cshifts(scr,f,-1,1,scr$s,f$s2,25,25)
# 1054 "sp2.hpf"
         call pghpf_free(f$s2)
# 1054 "sp2.hpf"
         call pghpf_free(scr$s)
         scr$sp1 = pghpf_sect(scr$d1,2,2,1,1,z_b_15,1,2)
# 1055 "sp2.hpf"
         f$sp3 = pghpf_sect(f$d1,nxpmx,nxpmx,1,1,z_b_3,1,2)
# 1055 "sp2.hpf"
         call pghpf_cshifts(scr,f,-1,1,scr$s1,f$s3,25,25)
# 1055 "sp2.hpf"
         call pghpf_free(f$s3)
# 1055 "sp2.hpf"
         call pghpf_free(scr$s1)
# 1055 "sp2.hpf"
         call pghpf_template(fc$tl$tl2$dp,1,1024,0,0,z_b_6,z_b_7)
# 1055 "sp2.hpf"
         call pghpf_template(fc$f2$dp,1,20480,fc$tl$tl2$d,0,z_b_6,z_b_7)
# 1055 "sp2.hpf"
         call pghpf_instance(fc$f2$dp1,fc$f2$d,27,4,0,4,4)
# 1055 "sp2.hpf"
# 1063 "sp2.hpf"
         call pghpf_allobnds(fc$f2$d1,l$$b4,u$$b4)
# 1063 "sp2.hpf"
         allocate(fc$f2(l$$b4:u$$b4))
# 1063 "sp2.hpf"
         fc$f2$sp = pghpf_sect(fc$f2$d1,1,z_b_7,1,1)
# 1063 "sp2.hpf"
         scr$sp2 = pghpf_sect(scr$d1,1,1,1,1,z_b_15,1,2)
# 1063 "sp2.hpf"
         cp$$com2 = pghpf_comm_copy(fc$f2,scr,fc$f2$s,scr$s2)
# 1063 "sp2.hpf"
         xfer$$com2 = pghpf_comm_start(cp$$com2,fc$f2,fc$f2$s,scr,scr$s2
     +)
# 1063 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com2)
# 1063 "sp2.hpf"
         call pghpf_template(fc$tl$tl3$dp,1,1024,0,0,z_b_6,z_b_7)
# 1063 "sp2.hpf"
         call pghpf_template(fc$f3$dp,1,20480,fc$tl$tl3$d,0,z_b_6,z_b_7)
# 1063 "sp2.hpf"
         call pghpf_instance(fc$f3$dp1,fc$f3$d,27,4,0,4,4)
# 1063 "sp2.hpf"
         call pghpf_allobnds(fc$f3$d1,l$$b5,u$$b5)
# 1063 "sp2.hpf"
         allocate(fc$f3(l$$b5:u$$b5))
# 1063 "sp2.hpf"
         fc$f3$sp = pghpf_sect(fc$f3$d1,1,z_b_7,1,1)
# 1063 "sp2.hpf"
         scr$sp3 = pghpf_sect(scr$d1,2,2,1,1,z_b_15,1,2)
# 1063 "sp2.hpf"
         cp$$com3 = pghpf_comm_copy(fc$f3,scr,fc$f3$s,scr$s3)
# 1063 "sp2.hpf"
         xfer$$com3 = pghpf_comm_start(cp$$com3,fc$f3,fc$f3$s,scr,scr$s3
     +)
# 1063 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com3)
# 1063 "sp2.hpf"
         call pghpf_localize_bounds(fc$d1,2,1,z_b_7,1,i$$l1,i$$u1)
# 1063 "sp2.hpf"
!        forall (i$i=i$$l1:i$$u1:1) fc(1,i$i) = fc(1,i$i) + cmplx(fc$f2(
!    +i$i),fc$f3(i$i))
# 1063 "sp2.hpf"
         do i$i = i$$l1, i$$u1
# 1063 "sp2.hpf"
            fc(1,i$i) = fc(1,i$i) + cmplx(fc$f2(i$i),fc$f3(i$i))
# 1063 "sp2.hpf"
         enddo
# 1063 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com3)
# 1063 "sp2.hpf"
         call pghpf_free(scr$s3)
# 1063 "sp2.hpf"
         call pghpf_free(fc$f3$s)
# 1063 "sp2.hpf"
         call pghpf_freen(3,fc$f3$d1,fc$f3$d,fc$tl$tl3$d)
# 1063 "sp2.hpf"
         deallocate(fc$f3)
# 1063 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com2)
# 1063 "sp2.hpf"
         call pghpf_free(scr$s2)
# 1063 "sp2.hpf"
         call pghpf_free(fc$f2$s)
# 1063 "sp2.hpf"
         call pghpf_freen(3,fc$f2$d1,fc$f2$d,fc$tl$tl2$d)
# 1063 "sp2.hpf"
         deallocate(fc$f2)
# 1065 "sp2.hpf"
         scr$sp4 = pghpf_sect(scr$d1,1,1,1,1,z_b_15,1,2)
# 1065 "sp2.hpf"
         f$sp4 = pghpf_sect(f$d1,1,1,1,1,z_b_3,1,2)
# 1065 "sp2.hpf"
         call pghpf_cshifts(scr,f,1,1,scr$s4,f$s4,25,25)
# 1065 "sp2.hpf"
         call pghpf_free(f$s4)
# 1065 "sp2.hpf"
         call pghpf_free(scr$s4)
# 1065 "sp2.hpf"
         call pghpf_template(fc$tl$tl4$dp,1,1024,0,0,z_b_6,z_b_7)
# 1065 "sp2.hpf"
         call pghpf_template(fc$f4$dp,1,20480,fc$tl$tl4$d,0,z_b_6,z_b_7)
# 1065 "sp2.hpf"
         call pghpf_instance(fc$f4$dp1,fc$f4$d,27,4,0,4,4)
# 1065 "sp2.hpf"
# 1071 "sp2.hpf"
         call pghpf_allobnds(fc$f4$d1,l$$b6,u$$b6)
# 1071 "sp2.hpf"
         allocate(fc$f4(l$$b6:u$$b6))
# 1071 "sp2.hpf"
         fc$f4$sp = pghpf_sect(fc$f4$d1,1,z_b_7,1,1)
# 1071 "sp2.hpf"
         scr$sp5 = pghpf_sect(scr$d1,1,1,1,1,z_b_15,1,2)
# 1071 "sp2.hpf"
         cp$$com4 = pghpf_comm_copy(fc$f4,scr,fc$f4$s,scr$s5)
# 1071 "sp2.hpf"
         xfer$$com4 = pghpf_comm_start(cp$$com4,fc$f4,fc$f4$s,scr,scr$s5
     +)
# 1071 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com4)
# 1071 "sp2.hpf"
         call pghpf_localize_bounds(fc$d1,2,1,z_b_7,1,i$$l2,i$$u2)
# 1071 "sp2.hpf"
!        forall (i$i=i$$l2:i$$u2:1) fc(kxp,i$i) = fc(kxp,i$i) + cmplx(
!    +0.0e0,fc$f4(i$i))
# 1071 "sp2.hpf"
         do i$i = i$$l2, i$$u2
# 1071 "sp2.hpf"
            fc(kxp,i$i) = fc(kxp,i$i) + cmplx(0.0e0,fc$f4(i$i))
# 1071 "sp2.hpf"
         enddo
# 1071 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com4)
# 1071 "sp2.hpf"
         call pghpf_free(scr$s5)
# 1071 "sp2.hpf"
         call pghpf_free(fc$f4$s)
# 1071 "sp2.hpf"
         call pghpf_freen(3,fc$f4$d1,fc$f4$d,fc$tl$tl4$d)
# 1071 "sp2.hpf"
         deallocate(fc$f4)
# 1073 "sp2.hpf"
         goto 99999
# 1073 "sp2.hpf"
      endif
# 1073 "sp2.hpf"
      if (isign .eq. 1) then
# 1073 "sp2.hpf"
         z_b_16 = 1
# 1073 "sp2.hpf"
         z_b_17 = pghpf_extent(f$d1,1)
# 1073 "sp2.hpf"
         z_b_18 = 1
# 1073 "sp2.hpf"
         z_b_19 = pghpf_extent(f$d1,2)
# 1073 "sp2.hpf"
         z_b_20 = 1
# 1073 "sp2.hpf"
         z_b_21 = pghpf_extent(fc$d1,1)
# 1073 "sp2.hpf"
         z_b_22 = 1
# 1073 "sp2.hpf"
         z_b_23 = pghpf_extent(fc$d1,2)
# 1073 "sp2.hpf"
         call pghpf_qopy_in(f$f77$p,pghpf_0(3),pghpf_0(3),f$f77$dp1,f,
     +f$d1,2,27,4,2212,1,0,z_b_16,z_b_18)
# 1073 "sp2.hpf"
         call pghpf_qopy_in(fc$f77$p,pghpf_0(3),pghpf_0(3),fc$f77$dp1,fc
     +,fc$d1,2,9,8,2148,1,0,z_b_20,z_b_22)
# 1073 "sp2.hpf"
# 1079 "sp2.hpf"
         call do_forall(f$f77,fc$f77,kxp,kblok)
# 1079 "sp2.hpf"
         call pghpf_copy_out(fc,fc$f77,fc$d1,fc$f77$d1,1)
# 1079 "sp2.hpf"
         call pghpf_copy_out(f,f$f77,f$d1,f$f77$d1,2)
# 1081 "sp2.hpf"
         scc$sp = pghpf_sect(scc$d1,1,1,1,1,z_b_11,1,2)
# 1081 "sp2.hpf"
         fc$sp = pghpf_sect(fc$d1,kxp,kxp,1,1,z_b_7,1,2)
# 1081 "sp2.hpf"
         call pghpf_cshifts(scc,fc,-1,1,scc$s,fc$s,25,25)
# 1081 "sp2.hpf"
         call pghpf_free(fc$s)
# 1081 "sp2.hpf"
         call pghpf_free(scc$s)
# 1081 "sp2.hpf"
         call pghpf_template(f$tl$tl$dp,1,1024,0,0,z_b_2,z_b_3)
# 1081 "sp2.hpf"
         call pghpf_template(f$f$dp,1,20480,f$tl$tl$d,0,z_b_2,z_b_3)
# 1081 "sp2.hpf"
         call pghpf_instance(f$f$dp1,f$f$d,9,8,0,4,4)
# 1081 "sp2.hpf"
# 1087 "sp2.hpf"
         call pghpf_allobnds(f$f$d1,l$$b7,u$$b7)
# 1087 "sp2.hpf"
         allocate(f$f(l$$b7:u$$b7))
# 1087 "sp2.hpf"
         f$f$sp = pghpf_sect(f$f$d1,1,z_b_3,1,1)
# 1087 "sp2.hpf"
         scc$sp1 = pghpf_sect(scc$d1,1,1,1,1,z_b_11,1,2)
# 1087 "sp2.hpf"
         cp$$com5 = pghpf_comm_copy(f$f,scc,f$f$s,scc$s1)
# 1087 "sp2.hpf"
         xfer$$com5 = pghpf_comm_start(cp$$com5,f$f,f$f$s,scc,scc$s1)
# 1087 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com5)
# 1087 "sp2.hpf"
         call pghpf_localize_bounds(f$d1,2,1,z_b_3,1,i$$l3,i$$u3)
# 1087 "sp2.hpf"
!        forall (i$i=i$$l3:i$$u3:1) f(1,i$i) = aimag(f$f(i$i))
# 1087 "sp2.hpf"
         do i$i = i$$l3, i$$u3
# 1087 "sp2.hpf"
            f(1,i$i) = aimag(f$f(i$i))
# 1087 "sp2.hpf"
         enddo
# 1087 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com5)
# 1087 "sp2.hpf"
         call pghpf_free(scc$s1)
# 1087 "sp2.hpf"
         call pghpf_free(f$f$s)
# 1087 "sp2.hpf"
         call pghpf_freen(3,f$f$d1,f$f$d,f$tl$tl$d)
# 1087 "sp2.hpf"
         deallocate(f$f)
# 1089 "sp2.hpf"
         scc$sp2 = pghpf_sect(scc$d1,1,1,1,1,z_b_11,1,2)
# 1089 "sp2.hpf"
         fc$sp1 = pghpf_sect(fc$d1,1,1,1,1,z_b_7,1,2)
# 1089 "sp2.hpf"
         call pghpf_cshifts(scc,fc,1,1,scc$s2,fc$s1,25,25)
# 1089 "sp2.hpf"
         call pghpf_free(fc$s1)
# 1089 "sp2.hpf"
         call pghpf_free(scc$s2)
# 1089 "sp2.hpf"
         call pghpf_template(f$tl$tl1$dp,1,1024,0,0,z_b_2,z_b_3)
# 1089 "sp2.hpf"
         call pghpf_template(f$f1$dp,1,20480,f$tl$tl1$d,0,z_b_2,z_b_3)
# 1089 "sp2.hpf"
         call pghpf_instance(f$f1$dp1,f$f1$d,9,8,0,4,4)
# 1089 "sp2.hpf"
# 1096 "sp2.hpf"
         call pghpf_allobnds(f$f1$d1,l$$b8,u$$b8)
# 1096 "sp2.hpf"
         allocate(f$f1(l$$b8:u$$b8))
# 1096 "sp2.hpf"
         f$f1$sp = pghpf_sect(f$f1$d1,1,z_b_3,1,1)
# 1096 "sp2.hpf"
         scc$sp3 = pghpf_sect(scc$d1,1,1,1,1,z_b_11,1,2)
# 1096 "sp2.hpf"
         cp$$com6 = pghpf_comm_copy(f$f1,scc,f$f1$s,scc$s3)
# 1096 "sp2.hpf"
         xfer$$com6 = pghpf_comm_start(cp$$com6,f$f1,f$f1$s,scc,scc$s3)
# 1096 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com6)
# 1096 "sp2.hpf"
         call pghpf_localize_bounds(f$d1,2,1,z_b_3,1,i$$l4,i$$u4)
# 1096 "sp2.hpf"
!        forall (i$i=i$$l4:i$$u4:1) f(nxpmx-1,i$i) = real(f$f1(i$i))
# 1096 "sp2.hpf"
         do i$i = i$$l4, i$$u4
# 1096 "sp2.hpf"
            f(nxpmx-1,i$i) = real(f$f1(i$i))
# 1096 "sp2.hpf"
         enddo
# 1096 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com6)
# 1096 "sp2.hpf"
         call pghpf_free(scc$s3)
# 1096 "sp2.hpf"
         call pghpf_free(f$f1$s)
# 1096 "sp2.hpf"
         call pghpf_freen(3,f$f1$d1,f$f1$d,f$tl$tl1$d)
# 1096 "sp2.hpf"
         deallocate(f$f1)
# 1096 "sp2.hpf"
         call pghpf_template(f$tl$tl2$dp,1,1024,0,0,z_b_2,z_b_3)
# 1096 "sp2.hpf"
         call pghpf_template(f$f2$dp,1,20480,f$tl$tl2$d,0,z_b_2,z_b_3)
# 1096 "sp2.hpf"
         call pghpf_instance(f$f2$dp1,f$f2$d,9,8,0,4,4)
# 1096 "sp2.hpf"
# 1097 "sp2.hpf"
         call pghpf_allobnds(f$f2$d1,l$$b9,u$$b9)
# 1097 "sp2.hpf"
         allocate(f$f2(l$$b9:u$$b9))
# 1097 "sp2.hpf"
         f$f2$sp = pghpf_sect(f$f2$d1,1,z_b_3,1,1)
# 1097 "sp2.hpf"
         scc$sp4 = pghpf_sect(scc$d1,1,1,1,1,z_b_11,1,2)
# 1097 "sp2.hpf"
         cp$$com7 = pghpf_comm_copy(f$f2,scc,f$f2$s,scc$s4)
# 1097 "sp2.hpf"
         xfer$$com7 = pghpf_comm_start(cp$$com7,f$f2,f$f2$s,scc,scc$s4)
# 1097 "sp2.hpf"
         call pghpf_comm_finish(xfer$$com7)
# 1097 "sp2.hpf"
         call pghpf_localize_bounds(f$d1,2,1,z_b_3,1,i$$l5,i$$u5)
# 1097 "sp2.hpf"
!        forall (i$i=i$$l5:i$$u5:1) f(nxpmx,i$i) = aimag(f$f2(i$i))
# 1097 "sp2.hpf"
         do i$i = i$$l5, i$$u5
# 1097 "sp2.hpf"
            f(nxpmx,i$i) = aimag(f$f2(i$i))
# 1097 "sp2.hpf"
         enddo
# 1097 "sp2.hpf"
         call pghpf_comm_free(1,cp$$com7)
# 1097 "sp2.hpf"
         call pghpf_free(scc$s4)
# 1097 "sp2.hpf"
         call pghpf_free(f$f2$s)
# 1097 "sp2.hpf"
         call pghpf_freen(3,f$f2$d1,f$f2$d,f$tl$tl2$d)
# 1097 "sp2.hpf"
         deallocate(f$f2)
# 1099 "sp2.hpf"
      endif
# 1099 "sp2.hpf"
99999 continue
# 1101 "sp2.hpf"
      goto 99998
99998 continue
# 1102 "sp2.hpf"
      call pghpf_copy_out(scc$bs,scc,scc$s0,scc$d1,0)
# 1102 "sp2.hpf"
      call pghpf_copy_out(scr$bs,scr,scr$s0,scr$d1,0)
# 1102 "sp2.hpf"
      call pghpf_copy_out(fc$bs,fc,fc$s0,fc$d1,0)
# 1102 "sp2.hpf"
      call pghpf_copy_out(f$bs,f,f$s0,f$d1,0)
# 1102 "sp2.hpf"
      end
